VERSION 2.00
Begin Form fecsim 
   BackColor       =   &H0080FFFF&
   Caption         =   "Windows Server"
   ClientHeight    =   2280
   ClientLeft      =   1140
   ClientTop       =   3285
   ClientWidth     =   6255
   ForeColor       =   &H000000C0&
   Height          =   2970
   Icon            =   FECSIM.FRX:0000
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   2280
   ScaleWidth      =   6255
   Top             =   2655
   Width           =   6375
   Begin Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   0
      Top             =   1200
   End
   Begin Srv Eqp2 
      Caption         =   ""
      ContactName     =   ""
      EqpName         =   "WINCOS"
      EqpNumModules   =   10
      ExportName      =   "WINCOS"
      Height          =   420
      Left            =   0
      Top             =   480
      Width           =   420
   End
   Begin Srv Eqp1 
      Caption         =   ""
      ContactName     =   ""
      EqpName         =   "SINSIM"
      EqpNumModules   =   100
      ExportName      =   "WINSINE"
      Height          =   420
      Left            =   0
      Top             =   0
      Width           =   420
   End
   Begin Label debug2 
      BorderStyle     =   1  'Fixed Single
      Height          =   975
      Left            =   240
      TabIndex        =   1
      Top             =   1200
      Width           =   5895
   End
   Begin Label debug1 
      BorderStyle     =   1  'Fixed Single
      Height          =   975
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   5895
   End
   Begin Menu opts 
      Caption         =   "&Options"
      Begin Menu callInfo 
         Caption         =   "&Caller Information"
      End
      Begin Menu dbg 
         Caption         =   "&Debug Server"
      End
      Begin Menu prt 
         Caption         =   "&Print"
      End
   End
End
Dim RDat As UserType
Dim WDat As UserType
Dim fecsimText$
Dim dataMode  As Integer
Dim t1(MAX_TEST1%) As Test1Struct

Sub callInfo_Click ()
If callInfo.Checked Then  ' toggle from info mode
  Debug1.Visible = False
  Debug2.Visible = False
  callInfo.Checked = False
Else                      ' toggle to info mode
  Cls
  Debug1.Visible = True
  Debug2.Visible = True
  callInfo.Checked = True
End If

End Sub

Sub dbg_Click ()
If dbg.Checked Then  ' toggle from debug mode
  rc% = DebugServer(0)
  dbg.Checked = False
Else                 ' toggle to debug mode
  rc% = DebugServer(1)
  dbg.Checked = True
End If
End Sub

' This is the new interface event routine :
Sub Eqp1_EqpFcn (devName As String, devProperty As String, outArrayLen As Long, inArrayLen As Long, devAccess As Integer)
Static Eqp1Count&
Dim mode%

Eqp1Count = Eqp1Count + 1
Eqp1.EqpTime = UTIME()

EqNo% = GetModuleNumber(Eqp1.EqpName, devName)
Select Case devProperty
  
  Case "SINE":
   If devAccess And CA_WRITE Then ' something has come in
     Eqp1.EqpRecv = CADDR(WDat)
   Else                           ' zero the WDAT array
     For i% = 0 To NumValues% - 1: WDat.Array(i%) = 0: Next
   End If
   If outArrayLen = 0 Then
     Eqp1.Status = illegal_read_write
     Exit Sub
   End If
   
   For i% = 0 To outArrayLen - 1: RDat.Array(i%) = WDat.Array(i%) + dbuf(i%): Next
   Eqp1.EqpSend = CADDR(RDat)

  Case "TEST":
   
'   If (devAccess And CA_WRITE) Or outArrayLen = 0 Then
'     Eqp1.Status = illegal_read_write
'     Exit Sub
'   End If
   If inArrayLen > 1 Then Eqp1.EqpRecv = CADDR(WDat)
   For i% = inArrayLen To NumValues% - 1: WDat.Array(i%) = 0: Next
   For i% = 0 To outArrayLen - 1: RDat.Array(i%) = WDat.Array(i%) + i%: Next
   Eqp1.EqpSend = CADDR(RDat)
  
  Case "ECHO":

   If (devAccess And CA_WRITE) Or outArrayLen = 0 Then
     Eqp1.Status = illegal_read_write
     Exit Sub
   End If
   If inArrayLen > 1 Then Eqp1.EqpRecv = CADDR(WDat)
   
   For i% = 0 To outArrayLen - 1: RDat.Array(i%) = WDat.Array(i%): Next
   Eqp1.EqpSend = CADDR(RDat)

  Case "STRUCTTEST":
   
   If inArrayLen > 0 Then
     Eqp1.EqpRecv = CADDR(t1(0))
   End If
   If outArrayLen > 0 Then
     Eqp1.EqpSend = CADDR(t1(0))
   End If
  
  Case "ERRTEST": ' set my own personal error
    Eqp1.Status = 512
    Eqp1.ErrorString = "This is a test error"
    Exit Sub
  Case "INIT": ' a property without data
   If Not ((devAccess And CA_WRITE) = CA_WRITE) Then
     Eqp1.Status = illegal_read_write
   Else
     ' do whatever initialization needs to be done
   End If

  Case "MODE": ' set the data mode (TRAVELLING or SIGNAL)
   If inArrayLen = 1 Then
     Eqp1.EqpRecv = CADDR(mode%)
     If mode% >= 0 And mode% < 2 Then dataMode% = mode%
   End If
   If outArrayLen = 1 Then
     Eqp1.EqpSend = CADDR(dataMode%)
   End If

  Case Else:
    
    Eqp1.Status = illegal_property
    Exit Sub
End Select
Eqp1.Status = 0 ' assume success
'Exit Sub
If Debug1.Visible = True Then
 ' Call CTIME(rpctime$, Eqp1.EqpTime)
  Call ASCTIME(rpctime, Eqp1.EqpTime)
  a$ = nl$ + Str$(Eqp1Count) + "Device: " + devName + " Number : " + Str$(EqNo%) + " Prop:  " + devProperty
  a$ = a$ + nl$ + " Status: " + Str$(Eqp1.Status) + " Size: (out) " + Str$(outArrayLen) + " (in) " + Str$(inArrayLen)
  a$ = a$ + nl$ + "Caller: " + Eqp1.ClientName + " at [" + Eqp1.ClientAddress + "]"
  a$ = a$ + nl$ + "Access: " + Hex$(devAccess) + " Timestamp: " + Str$(Eqp1.EqpTime) + " " + rpctime
  Debug1.Caption = a$
End If

End Sub

' This is the old interface event routine
' "EqpFcn" is called first.  If the .Status property is
' set to some value (other than not_posted) then
' "Receive" is not called. Otherwise "Receive" is called.
Sub Eqp2_Receive ()
Static phi!, Eqp2Count&
Eqp2Count = Eqp2Count + 1
EqNo% = Eqp2.EqpNumber
Eqp2.Status = 0    'assume success

Select Case Eqp2.Property
  
  Case "SINE", "COSINE":
   
   Select Case Eqp2.RWSize  'array size in doubles
     Case Is > NumValues%:
       Eqp2.Status = illegal_read_write
     Case Is > 0:
       For i% = 0 To Eqp2.RWSize: RDat.Array(i%) = 512 * (Sin(6.28 * CSng(i%) / CSng(NumValues%) + phi) + 1): Next
       phi = phi + .1
     Case Is >= -NumValues%:
       Eqp2.EqpTime = UTIME()
       Eqp2.WAddress = Address(WDat)
       For i% = 0 To -Eqp2.RWSize: RDat.Array(i%) = WDat.Array(i%) + 512 * (Sin(6.28 * CSng(i%) / CSng(NumValues%) + phi) + 1): Next
     Case Else: Eqp2.Status = illegal_read_write
   End Select
  
  Case "TEST":
   
   Select Case Eqp2.RWSize
     Case Is > NumValues%:
       Eqp2.Status = illegal_read_write
     Case Is > 0:
       For i% = 0 To Eqp2.RWSize: RDat.Array(i%) = i%: Next
     Case Else:
       Eqp2.Status = illegal_read_write
   End Select

  Case "TESTFI":
   
   Select Case Eqp2.RWSize
     Case Is > NumValues%:
       Eqp2.Status = illegal_read_write
     Case Is > 0:
       For i% = 0 To Eqp2.RWSize
         fiarray(i%).fval = i%
         fiarray(i%).ival = i%
       Next
       Eqp2.RAddress = Address(fiarray(0))
       Exit Sub
     Case Else:
       Eqp2.Status = illegal_read_write
   End Select
  
  Case Else:
    
    Eqp2.Status = illegal_property

End Select

Eqp2.RAddress = Address(RDat)

If Debug2.Visible = True Then
   Call CTIME(rpctime$, Eqp1.EqpTime)
  a$ = nl$ + Str$(Eqp2Count) + " Prop:  " + Eqp2.Property + " Status: " + Str$(Eqp2.Status) + " EqpIndex: " + Str$(Eqp2.EqpIndex) + " Size: " + Str$(Eqp2.RWSize)
  a$ = a$ + nl$ + "Caller: " + Eqp2.ClientName + " at [" + Eqp2.ClientAddress + "]"
  a$ = a$ + nl$ + "Format: " + Str$(Eqp2.EqpFormat) + "Timestamp: " + Str$(Eqp2.EqpTime) + " " + rpctime$
  Debug2.Caption = a$
End If
End Sub

Sub Form_Load ()
 ' ===================================================
 ' put special initialization in seperater routine:
 ' ===================================================

  initServer
 
 ' ===================================================
 '  Debug information is sometimes useful
 ' ===================================================
 
  Debug1.Visible = False: Debug2.Visible = False
 
 ' ===================================================
 ' Equipment function initialization :
 '    assign 1) eqpment function name and export name
 '              (only the 1st 6 characters of EqpName are registered)
 '              (only the 1st 8 characters of ExportName are currently used)
 '           2) default VB buffer lengths (in bytes)
 '    These assignments can be changed dynamically at run time
 '    or assigned at design time
 '    If the value passed in RSize or WSize does not
 '    correspond to the true VB buffer length
 '    there could of course be serious problems
 '    When you set enabled = true, the eqpuipment function
 '    registers itself
 '
 '    You should then register any properties you wish to
 '    export (to be seen by remote clients).  This is
 '    done thru the RegisterProperty API call
 '
 '    Note that for the Plug-and-play (self-registering)
 '    features to take place, you'll need to include
 '    two files in your WINDOWS config directory, namely:
 '    herans.csv - which gives the name server address
 '    fecid.csv  - which you'll have to edit so that it
 '                 reflects your FEC name and description
 '
 '    To make use of the ALARM server features, you might
 '    want to register alarm code information via the
 '    local database file <eqpname>al.csv. where <eqpname>
 '    is the 1st 6 letters of your local eqp function name
 '    e.g.:  The EqpName property of the server VBX
 '           is here "WINSINE", so the server DLL will look
 '           for a database file called winsinal.csv.
 '    If you use your own alarm codes (as opposed to the error table in
 '    winsrv.bas) make sure they start at number 512 and
 '    increase
 ' ===================================================

 'Eqp1.RSize = Len(RDat): Eqp2.RSize = Len(RDat)
 'Eqp1.WSize = Len(WDat): Eqp2.WSize = Len(WDat)
 Eqp1.Enabled = True: Eqp2.Enabled = True
 ' rc% = DebugServer(2)
 
 ' you need to register all properties you want to see
 ' from a remote station like this:
 
 '"Extended" Property Registration:
 cc% = RegisterPropertyEx("SINSIM", "SINE", NumValues%, CF_DOUBLE, "", NumValues%, CF_DOUBLE, "", CA_READ + CA_WRITE, "Sine function from Winfec")
 cc% = RegisterPropertyEx("SINSIM", "TEST", NumValues%, CF_DOUBLE, "", NumValues%, CF_DOUBLE, "", CA_READ + CA_WRITE, "Test function from Winfec")
 cc% = RegisterPropertyEx("SINSIM", "ECHO", NumValues%, CF_DOUBLE, "", NumValues%, CF_DOUBLE, "", CA_READ + CA_WRITE, "Echo function from Winfec")
 cc% = RegisterPropertyEx("SINSIM", "STRUCTTEST", MAX_TEST1%, CF_STRUCT, "TEST1", MAX_TEST1%, CF_STRUCT, "TEST1", CA_READ + CA_WRITE, "Struct function from Winfec")
 cc% = RegisterPropertyEx("SINSIM", "ERRTEST", 1, CF_DOUBLE, "", 1, CF_DOUBLE, "", CA_READ + CA_WRITE, "Error test from Winfec")
 cc% = RegisterPropertyEx("SINSIM", "MODE", 1, CF_SHORT, "", 1, CF_SHORT, "", CA_READ + CA_WRITE, "Data Simulation mode")
 cc% = RegisterPropertyEx("SINSIM", "HISTORY", 0, CF_NULL, "", HistoryDepth%, CF_FLOAT, "", CA_READ, "Post Mortem History")
 cc% = RegisterPropertyEx("SINSIM", "INIT", 0, CF_NULL, "", 0, CF_NULL, "", CA_WRITE, "Trigger Initialization")
 
 ' "Old-fashioned" Property Registration:
 cc% = RegisterProperty("WINCOS", "SINE", NumValues%, CF_DOUBLE, 1, "Sine function from Winfec")
 cc% = RegisterProperty("WINCOS", "COSINE", NumValues%, CF_DOUBLE, 1, "Sine function from Winfec")
 cc% = RegisterProperty("WINCOS", "TEST", NumValues%, CF_DOUBLE, 1, "Test function from Winfec")
 cc% = RegisterProperty("WINCOS", "TESTFI", NumValues%, CF_FLTINT, 1, "Test function from Winfec")
'Declare Function RegisterPropertyEx Lib "winsrv.dll" (ByVal eqm$, ByVal prop$, ByVal sizIn%, ByVal fmtIn%, ByVal tagIn$, ByVal sizOut%, ByVal fmtOut%, ByVal tagOut$, ByVal acc%, ByVal dsc$) As Integer
 
 ' you can also bind a device name to a device number as follows:
 cc% = RegisterModuleName("SINSIM", "SINE_DEV_0", 0)
 cc% = RegisterModuleName("SINSIM", "SINE_DEV_1", 1)
 cc% = RegisterModuleName("SINSIM", "SINE_DEV_2", 2)
 cc% = RegisterModuleName("SINSIM", "SINE_DEV_3", 3)
 cc% = RegisterModuleName("SINSIM", "SINE_DEV_4", 4)
 cc% = RegisterModuleName("SINSIM", "SINE_DEV_5", 5)
 cc% = RegisterModuleName("SINSIM", "SINE_DEV_6", 6)
 cc% = RegisterModuleName("SINSIM", "SINE_DEV_7", 7)
 cc% = RegisterModuleName("SINSIM", "SINE_DEV_8", 8)
 cc% = RegisterModuleName("SINSIM", "SINE_DEV_9", 9)
 
 For i% = 10 To 99
   cc% = RegisterModuleName("SINSIM", "SINE_DEV_" + Trim$(Str$(i%)), i%)
 Next

 ' note: this example does no error checking here, in
 ' principal, you will want to compare cc% against 0
 ' as in:
 '
 ' if cc% then msgbox RPCERROR(cc%)
 '
 ' or something of that nature


 ' random alarms will be set in the timer routine - in
 ' order to simulate IO problems
 ' the timer is disabled, so enable now:

timer1.Enabled = True

End Sub

Sub Form_Paint ()
If dbg.Checked = False Then
 fecsim.CurrentX = 0: fecsim.CurrentY = 0
 Print fecsimText$
End If
End Sub

Sub Form_Unload (Cancel As Integer)
 Eqp1.Enabled = False: Eqp2.Enabled = False
 rc% = DebugServer(0)
End
End Sub

Sub initServer ()
 nl$ = Chr(13) + Chr(10)
 
 fecsimText$ = "This Example VB WINDOWS Equipment Function program"
 fecsimText$ = fecsimText$ + nl$ + "Contains two equipment functions (WINSINE and WINCOS)"
 fecsimText$ = fecsimText$ + nl$ + "each with properties SINE, COSINE, and TEST"
 fecsimText$ = fecsimText$ + nl$ + "In general, each equipment function should be bound"
 fecsimText$ = fecsimText$ + nl$ + "to its own VB program, so that they can be started"
 fecsimText$ = fecsimText$ + nl$ + "and stopped independently ..."
 
  ' fake the data:
  For i% = 0 To NumValues%
    sinbuf(i%) = 512 * (Sin(6.28 * CSng(i%) / CSng(NumValues%)) + 1)
    noise(i%) = 10 * Rnd
  Next
  rc% = FILLSRVSTRUCT("TEST1", Len(t1(0)), MAX_TEST1%, CF_NULL)
  If rc% Then MsgBox "Register TEST1: " + RPCERROR(rc%)
  
  ' fill in our test structure:
  For i% = 0 To MAX_TEST1% - 1
    t1(i%).a(0) = i% + 1: t1(i%).a(1) = i% + 2: t1(i%).a(2) = i% + 3
    t1(i%).b(0) = i% + 1: t1(i%).b(1) = i% + 2
    t1(i%).c = i% + 1
    t1(i%).d = "This is struct : " + Str$(i%)
  Next

End Sub

Sub prt_Click ()
fecsim.PrintForm
End Sub

Sub Timer1_Timer ()
Static ptr%
Static scnt%
Static almData%(3) ' 6 bytes of device-specific alarm data
Static interim&
Static initdone As Integer
If Not initdone Then
'  rc% = SendPMTrigger("hpvac", "Hey")
'  If rc% Then MsgBox "PM TRIGGER: " + RPCERROR(rc%)
  initdone = True
End If

'simulate data readout:
For i% = 0 To NumValues% - 1
  If dataMode = TRAVELING Then   ' Travelling sine curve
    dbuf(i%) = sinbuf((ptr% + i%) Mod NumValues%)
  Else                           ' sine curve with noise
    dbuf(i%) = sinbuf(i%) + noise((ptr% + i%) Mod NumValues%)
  End If
Next
ptr% = (ptr% + 16) Mod NumValues%

ut& = UNIXTIME
If ut& <= interim& Then Exit Sub
interim& = ut&
' update the structured data:
scnt% = (scnt% + 1) Mod 1000
For i% = 0 To MAX_TEST1% - 1
    t1(i%).a(0) = i% + scnt% + 1: t1(i%).a(1) = i% + scnt% + 2: t1(i%).a(2) = i% + scnt% + 3
    t1(i%).b(0) = i% + scnt% + 1: t1(i%).b(1) = i% + scnt% + 2
    t1(i%).c = i% + scnt% + 1
    t1(i%).d = "This is struct : " + Str$(i%)
Next


' first clear alarms and see who comes back:
For i% = 0 To 9: Call ClearAlarm("WINSINE", i%): Next
m% = Int(10 * Rnd) ' pick a module from 0 to 9
For i% = 0 To 3: almData%(i%) = i% + m%: Next ' just put something in the array

' generate 2 alarms:
rc% = SetAlarm("WINSINE", m%, sedac_error%, almData%(0))
rc% = SetAlarm("WINSINE", m%, hardware_in_serious_trouble%, almData%(0))

End Sub

