VERSION 5.00
Object = "{4727FED0-D8EC-11D0-B104-0000E80D9CC1}#1.0#0"; "srv.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1170
   ClientLeft      =   8550
   ClientTop       =   5685
   ClientWidth     =   5085
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1170
   ScaleWidth      =   5085
   Begin SRVLib.Srv Srv1 
      Left            =   270
      Top             =   120
      _Version        =   65536
      _ExtentX        =   873
      _ExtentY        =   926
      _StockProps     =   64
      ExportName      =   "NTSINE"
      EqpName         =   "SINEQM"
      EqpNumberModules=   100
   End
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   960
      Top             =   180
   End
   Begin VB.Label status 
      BackColor       =   &H000000FF&
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   720
      Width           =   1455
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   555
      Left            =   1650
      TabIndex        =   0
      Top             =   120
      Width           =   2295
   End
   Begin VB.Menu dbg 
      Caption         =   "Debug"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Const MAX_TEST1% = 20
Private Const TRAVELING = 0
Private Const SIGNAL = 1
Private Const hardware_in_serious_trouble% = 512
Private Const NumValues% = 1024
Dim sinbuf(NumValues%) As Single
Dim rArray(NumValues%) As Double
Dim wArray(NumValues%) As Double
Dim dbuf(NumValues%) As Single
Dim noise(NumValues%) As Single
Dim dataMode  As Integer
Private Type Test1Struct
  a(2) As Single
  B(1) As Long
  c As Integer
  Reserved As Integer
  d As String * 32
End Type
Dim t1(MAX_TEST1%) As Test1Struct
Dim msdata As String
Dim spectrum As DSPECTRUM
Private Const ms1$ = "Now you see it"
Private Const ms2$ = "Now you don't"
Private Sub dbg_Click()
If dbg.Caption = "Debug" Then
  dbg.Caption = "Debug Off"
  DebugServer (4)
Else
  dbg.Caption = "Debug"
  DebugServer (0)
End If
End Sub

Private Sub Form_Load()

Call initServer

'rc% = DebugServer(2)
Srv1.Enabled = True
If Srv1.EqpStatus Then MsgBox "ERR: " + str$(Srv1.EqpStatus)

'"Extended" Property Registration:

rc% = Srv1.EqpRegisterPropertyEx("SINE", NumValues%, CF_DOUBLE, "", NumValues%, CF_DOUBLE, "", CA_READ + CA_WRITE, "[0:1000 bozos]Sine function from Winfec")
rc% = Srv1.EqpRegisterPropertyEx("SINESPECTRUM", 0, CF_NULL, "", NumValues%, CF_SPECTRUM, "", CA_READ, "[0:1000 bozos]Sine function from Winfec")
rc% = Srv1.EqpRegisterPropertyEx("TEST", NumValues%, CF_DOUBLE, "", NumValues%, CF_DOUBLE, "", CA_READ + CA_WRITE, "[0:1000 jumbos]Test function from Winfec")
rc% = Srv1.EqpRegisterPropertyEx("ECHO", NumValues%, CF_DOUBLE, "", NumValues%, CF_DOUBLE, "", CA_READ + CA_WRITE, "Echo function from Winfec")
rc% = Srv1.EqpRegisterPropertyEx("STRUCTTEST", MAX_TEST1%, CF_STRUCT, "TEST1", MAX_TEST1%, CF_STRUCT, "TEST1", CA_READ + CA_WRITE, "Struct function from Winfec")
rc% = Srv1.EqpRegisterPropertyEx("ERRTEST", 1, CF_DOUBLE, "", 1, CF_DOUBLE, "", CA_READ + CA_WRITE, "Error test from Winfec")
rc% = Srv1.EqpRegisterPropertyEx("MODE", 1, CF_SHORT, "", 1, CF_SHORT, "", CA_READ + CA_WRITE, "Data Simulation mode")
rc% = Srv1.EqpRegisterPropertyEx("MSG", 0, CF_NULL, "", 80, CF_TEXT, "", CA_READ, "String Message")

If rc% < 0 Then MsgBox "RegisterProperty ERR: " + str$(rc%)
For i = 0 To 99
  rc% = Srv1.EqpRegisterModule("SINE" + Trim$(str$(i)), i)
Next
If rc% Then MsgBox "RegisterModule ERR: " + str$(rc%)

InitStat% = SRVSTATUS
If InitStat% Then
  status.BackColor = RED
  status.Caption = RPCERROR(InitStat%)
Else
  status.BackColor = GREEN
  status.Caption = "Running ..."
End If

End Sub


Private Sub Form_Unload(Cancel As Integer)
Srv1.Enabled = False
rc% = DebugServer(0)
End Sub

Sub initServer()
 Dim fecname$, expname$, imgfile$
 
  ' fake the data:
  For i% = 0 To NumValues%
    sinbuf(i%) = 512 * (Sin(6.2832 * CSng(i%) / CSng(NumValues%)) + 1)
    noise(i%) = 10 * Rnd
  Next
  rc% = FILLSRVSTRUCT("TEST1", Len(t1(0)), MAX_TEST1%, CF_NULL)
  If rc% Then MsgBox "Register TEST1: " + RPCERROR(rc%)
  
  ' fill in our test structure:
  For i% = 0 To MAX_TEST1% - 1
    t1(i%).a(0) = i% + 1: t1(i%).a(1) = i% + 2: t1(i%).a(2) = i% + 3
    t1(i%).B(0) = i% + 1: t1(i%).B(1) = i% + 2
    t1(i%).c = i% + 1
    t1(i%).d = "This is struct : " + str$(i%)
  Next
' either read from file "fecid.csv" or user API :
fecname$ = Environ$("COMPUTERNAME")
If Left$(fecname$, 5) <> "ACCNT" Then
  rc% = RegisterFecNameEx(fecname$, "test", "rm 502", "none", "P.Duval", 0, "TEST")
End If
Srv1.EqpName = "SINEQM"
' usually, set this statically in the 'Srv' OCX control.
' Since everyone copies and starts this same example, make sure everyone gets a
' unique name:
expname$ = UCase$(Environ$("USERNAME")) + "SINE"
If Left$(expname$, 6) = "ACCNT_" Then expname$ = Right$(expname$, Len(expname$) - 6)
Srv1.ExportName = expname$
End Sub
Private Sub Srv1_EqpFcn(ByVal devName As String, ByVal devProperty As String, ByVal outArrayLen As Long, ByVal inArrayLen As Long, ByVal devAccess As Integer)
Static msgcnt%
Static seed As Byte
Dim buflen&, i As Long
Dim clnName As String * 16
Dim clnAddr As String * 20
Static sz As Integer
devNr% = Srv1.EqpGetModuleNumber(devName)
If devNr% < 0 Then
    Srv1.EqpSetCompletion illegal_equipment_number, ""
    Exit Sub
End If
'GetCallerInfo clnName, clnAddr
cc% = Srv1.GetCallerInformation(clnName, clnAddr)
'Label1.Caption = "dev nr : " + Str$(devNr%)
s$ = "dev name : " + devName + " (" + str$(devNr%) + ")"
s$ = s$ + vbNewLine + "client: " + Trim$(clnName) + " [" + Trim$(clnAddr) + "]"
Label1.Caption = s$

Select Case devProperty
  Case "MSG"
     If outArrayLen > 80 Then
       Srv1.EqpSetCompletion illegal_read_write, ""
       Exit Sub
     End If
     msdata = IIf(msgcnt% = 0, ms1$, ms2$)
     msgcnt% = (msgcnt% + 1) Mod 2
     Srv1.EqpSendData msdata
     feclog (msdata)
     
  Case "SINE":
     For i = 0 To outArrayLen - 1: rArray(i) = dbuf(i): Next
     Srv1.EqpSendData rArray

  Case "SINESPECTRUM":
     BARR spectrum.str(), "This is another sine curve"
     lt& = UNIXTIME
     spectrum.ts = lt&
     spectrum.inc = 16
     For i = 0 To outArrayLen - 1: spectrum.spectrum(i) = dbuf(i): Next
     Srv1.EqpSendDataEx spectrum.str, 100
  
  Case "TEST":
    If (devAccess And CA_WRITE) Or outArrayLen = 0 Then
      Srv1.EqpSetCompletion illegal_read_write, ""
      Exit Sub
    End If
    If inArrayLen > 1 Then Srv1.EqpRecvData wArray
    For i = inArrayLen To NumValues% - 1: wArray(i) = 0: Next
    For i = 0 To outArrayLen - 1: rArray(i) = wArray(i) + i: Next
    sz = (sz + 1) Mod 20           ' test sending less back than was asked for
    Srv1.EqpSendDataEx rArray, sz
  
  Case "ECHO":

   If (devAccess And CA_WRITE) Or outArrayLen = 0 Then
       Srv1.EqpSetCompletion illegal_read_write, ""
     Exit Sub
   End If
   If inArrayLen >= 1 Then Srv1.EqpRecvData wArray
   
   For i = 0 To outArrayLen - 1: rArray(i) = wArray(i): Next
   Srv1.EqpSendData rArray

  Case "STRUCTTEST":
   
   If inArrayLen > 0 Then
     Srv1.EqpRecvData t1(0).a(0)
   End If
   If outArrayLen > 0 Then
     Srv1.EqpSendData t1(0).a(0)
   End If
  
  Case "ERRTEST": ' set my own personal error
    Srv1.EqpSetCompletion 512, "This is a test error"
    Exit Sub

  Case "MODE": ' set the data mode (TRAVELLING or SIGNAL)
   If inArrayLen = 1 Then
     If (devAccess And CA_WRITE) <> CA_WRITE Then
       Srv1.EqpSetCompletion illegal_read_write, ""
       Exit Sub
     End If
     Srv1.EqpRecvData mode%
     If mode% >= 0 And mode% < 2 Then dataMode% = mode%
   End If
   If outArrayLen = 1 Then
     Srv1.EqpSendData dataMode%
   End If

  Case Else:
    
    Srv1.EqpSetCompletion illegal_property, ""
End Select

Srv1.EqpSetCompletion 0, "" ' success

End Sub

Private Sub Timer1_Timer()
Static ptr%
Static scnt%
Static almData%(3) ' 6 bytes of device-specific alarm data

'simulate data readout:
For i% = 0 To NumValues% - 1
  If dataMode = TRAVELING Then   ' Travelling sine curve
    dbuf(i%) = sinbuf((ptr% + i%) Mod NumValues%)
  Else                           ' sine curve with noise
    dbuf(i%) = sinbuf(i%) + noise((ptr% + i%) Mod NumValues%)
  End If
Next
ptr% = (ptr% + 16) Mod NumValues%

' update the structured data:
scnt% = (scnt% + 1) Mod 1000
For i% = 0 To MAX_TEST1% - 1
    t1(i%).a(0) = i% + scnt% + 1: t1(i%).a(1) = i% + scnt% + 2: t1(i%).a(2) = i% + scnt% + 3
    t1(i%).B(0) = i% + scnt% + 1: t1(i%).B(1) = i% + scnt% + 2
    t1(i%).c = i% + scnt% + 1
    t1(i%).d = "This is struct : " + str$(i%)
Next


' first clear alarms and see who comes back:
For i% = 0 To 9: Srv1.EqpClearAlarm i%: Next
m% = Int(10 * Rnd) ' pick a module from 0 to 9
For i% = 0 To 3: almData%(i%) = i% + m%: Next ' just put something in the array

' generate 2 alarms:
rc% = Srv1.EqpSetAlarm(m%, sedac_error%, CADDR(almData%(0)), 0)
rc% = Srv1.EqpSetAlarm(m%, hardware_in_serious_trouble%, CADDR(almData%(0)), 0)

End Sub


