# Makefile for client test program - PKTR rpc calls
# Version 20.03.95
# Insert the defs for your machine
# SUN:    CC = CC         CCL = CC
# SGI,OSF CC = cc         CCL = cc
# ULT     CC = gcc -c -g  CCL = gcc -g
# HP:     CC = cc -Aa     CCL = cc

INCL = /usr/include/tine
LIBS = /usr/lib
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/servdef.h \
	${INCL}/errors.h \
	${INCL}/rpctypes.h \
	${INCL}/rpcdefs.h \
	${INCL}/almsrv.h

CC = cc -c -Aa -I${INCL}
CCL = CC
LM = -lsocket -lnsl

mexcln: mexcln.o mexlib.o ${LIBS}/libtine.a
	${CCL} -o mexcln mexlib.o ${LIBS}/libtine.a mexcln.o ${LM}

mexlib.o:  mexlib.c netmex.h ${HDRS}
	${CC} mexlib.c

mexcln.o:  mexcln.c ${HDRS}
	${CC} mexcln.c

clean:
	rm *.o
