# Makefile for client test program - PKTR rpc calls
# Version 20.03.95
# Insert the defs for your machine
# SUN:    CC = CC         CCL = CC         LM = 
# SGI     CC = cc         CCL = cc         LM = -lm
# OSF     CC = cc         CCL = cc         LM = -lm
# LINUX   CC = cc         CCL = cc         LM = -lm
# ULT     CC = gcc -c -g  CCL = gcc -g     LM = 
# HP:     CC = cc -Aa     CCL = cc         LM = -lM
# SOL 2.4 CC = CC         CCL = CC         LM = -lsocket -lnsl
INCL = /usr/include/tine
LIBS = /usr/lib
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/servdef.h \
	${INCL}/errors.h \
	${INCL}/rpctypes.h \
	${INCL}/rpcdefs.h \
	${INCL}/almsrv.h

CC = cc -c -Aa -I${INCL}
CCL = CC
LM = -lsocket -lnsl

mexsrv: mexsrv.o keyeqm.o mydata.o ${LIBS}/libtine.a
	${CCL} -o mexsrv mexsrv.o keyeqm.o mydata.o ${LIBS}/libtine.a ${LM}

mexsrv.o:  mexsrv.c ${HDRS}
	${CC} mexsrv.c

keyeqm.o: keyeqm.c ${HDRS}
	${CC} keyeqm.c

mydata.o: mydata.c netmex.h
	${CC} mydata.c


clean:
	rm *.o
