package TINE;

/**
 * @brief Alias for INTINTINTINT
 *
 * Useful for passing hardware address information (e.g. line, crate, module, subaddress)
 */
public final class ADDRESS extends INTINTINTINT
{
  public ADDRESS() { i1val = 0; i2val = 0; i3val = 0; i4val = 0;}  
  public ADDRESS(int i) { i1val = i; i2val = 0; i3val = 0; i4val = 0;}  
  public ADDRESS(int i1,int i2,int i3, int i4) { i1val = i1; i2val = i2; i3val = i3; i4val = i4;}  
}
