package TINE;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
public final class DBLINT
{
  public double dval;
  public int ival;
  public static int sizeInBytes = 12;
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public DBLINT() {dval = 0; ival = 0; }  
  public DBLINT(float f) { dval = f; ival = 0; }  
  public DBLINT(double d) { dval = d; ival = 0; }  
  public DBLINT(int i) { ival = i; }  
  public DBLINT(float f,int i) { dval = f; ival = i; }  
  public DBLINT(double d,int i) { dval = d; ival = i; }  
  public byte[] toByteArray()
  {
	try
	{
		dBuffer.reset();
		DataOutputStream ds = new DataOutputStream(dBuffer);
		byte[] b = Swap.Double(dval);
		ds.write(b,0,8);
		ds.writeInt(Swap.Long(ival));
		ds.close();
	}
	catch (IOException e)
	{
	  e.printStackTrace();
//	  System.exit(1);
	}
	hByteArray = dBuffer.toByteArray();
	return hByteArray;
  }  
  public void toStruct()
  {
	try
	{
		ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
		DataInputStream ds = new DataInputStream(dis);
		byte[] b = new byte[8];
		ds.read(b,0,8);
		dval = Swap.Double(b);
		ival = Swap.Long(ds.readInt());
		ds.close(); dis.close();
	}
	catch (IOException e)
	{
	  e.printStackTrace();
//	  System.exit(1);
	}	 
  }  
}