package TINE;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public final class FECAddr
{
  public String Name = new String(new StringBuffer(21));
  public byte[] Network = new byte[4];
  public byte[] Node = new byte[6];
  public byte[] ImmediateAddress = new byte[6];
  public String IP = new String(new StringBuffer(16));
  public byte PortOffset;
  public byte[] IPh_addr = new byte[4];
  public short  Prot;
  public static int sizeInBytes = (21+16+21+2);
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public byte[] toByteArray()
  {
	try
	{
		dBuffer.reset();
		DataOutputStream ds = new DataOutputStream(dBuffer);
		byte[] bstr = new byte[21];
		byte[] tmp  = Name.getBytes();
		for (int i=0; i<21; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
		ds.write(bstr,0,21);
		ds.write(Network,0,4);
		ds.write(Node,0,6);
		ds.write(ImmediateAddress,0,6);
		tmp = IP.getBytes();
		for (int i=0; i<16; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
		ds.write(bstr,0,16);
		ds.writeByte(PortOffset);
		ds.write(IPh_addr,0,6);
		ds.writeShort(Swap.Short(Prot));
		ds.close();	
	}
	catch (IOException e)
	{
	  e.printStackTrace();
	  System.exit(1);
	}	 
	hByteArray = dBuffer.toByteArray();
	return hByteArray;
  }  
  public void toStruct()
  {
	try
	{
		ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
		DataInputStream ds = new DataInputStream(dis);
		byte[] bstr = new byte[21];
		ds.read(bstr,0,21);
		Name = new String(bstr);
		ds.read(Network,0,4);
		ds.read(Node,0,6);
		ds.read(ImmediateAddress,0,6);
		ds.read(bstr,0,16);
		IP = new String(bstr);
		PortOffset = ds.readByte();
		ds.read(IPh_addr,0,4);
		Prot = Swap.Short(ds.readShort());
		ds.close(); dis.close();
	}
	catch (IOException e)
	{
	  e.printStackTrace();
	  System.exit(1);
	}	 
  }  
}