package TINE;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
public class FLTFLT
{
  public float f1val;
  public float f2val;
  public static int sizeInBytes = 8;
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public FLTFLT() {f1val = 0; f2val = 0; }  
  public FLTFLT(float f) { f1val = f; f2val = 0; }  
  public FLTFLT(float f1,float f2) { f1val = f1; f2val = f2; }  
  public byte[] toByteArray()
  {
    try
    {
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      byte[] b = Swap.Float(f1val);
      ds.write(b,0,4);
      b = Swap.Float(f2val);
      ds.write(b,0,4);
      ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }    
  public void toStruct()
  {
    try
    {
      ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
      DataInputStream ds = new DataInputStream(dis);
      byte[] b = new byte[4];
      ds.read(b,0,4);
      f1val = Swap.Float(b);
      ds.read(b,0,4);
      b = new byte[4];
      f2val = Swap.Float(b);
      ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }  
  }    
}
