package TINE;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
public final class FLTINTINT
{
  public float f1val;
  public int i1val;
  public int i2val;
  public static int sizeInBytes = 12;
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public FLTINTINT() { f1val = 0; i1val = 0; i2val = 0; }  
  public FLTINTINT(float f) { f1val = f; i1val = 0; i2val = 0; }  
  public FLTINTINT(int i) { f1val = 0; i1val = i; i2val = 0; }  
  public FLTINTINT(float f1,int i1,int i2) { f1val = f1; i1val = i1; i2val = i2; }  
  public byte[] toByteArray()
  {
    try
    {
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      byte[] b = Swap.Float(f1val);
      ds.write(b,0,4);
      ds.writeInt(Swap.Long(i1val));
      ds.writeInt(Swap.Long(i2val));
      ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }    
  public void toStruct()
  {
    try
    {
      ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
      DataInputStream ds = new DataInputStream(dis);
      byte[] b = new byte[4];
      ds.read(b,0,4);
      f1val = Swap.Float(b);
      i1val = Swap.Long(ds.readInt());
      i2val = Swap.Long(ds.readInt());
      ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }  
  }    
}