package TINE;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public final class NAME16FI
{
  public String name;
  public int ival;
  public float fval;
  public static int sizeInBytes = 24;
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public NAME16FI() {name = new String(new StringBuffer(16)); ival = 0; fval =0;}  
  public NAME16FI(String Name) { name = Name; ival = 0; fval = 0;}  
  public NAME16FI(String Name,int i) { name = Name; ival = i; fval = 0;}  
  public NAME16FI(String Name,int i,float f) { name = Name; ival = i; fval = f;}  
  public byte[] toByteArray()
  {
    try
    {
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      byte[] bname = name.getBytes();
      byte[] b = new byte[16];
      for (int i=0; i<16 && i<bname.length; i++) b[i] = bname[i];
      ds.write(b,0,b.length);
      byte[] fb = Swap.Float(fval);
      ds.write(fb,0,4);
      ds.writeInt(Swap.Long(ival));
      ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }  
  public void toStruct()
  {
    try
    {
      ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
      DataInputStream ds = new DataInputStream(dis);
      byte[] b = new byte[sizeInBytes];
      ds.read(b,0,16);
      int len = 0; for (int i=0; i<16 && b[i] != 0; i++, len++);
      name = new String(b,0,len);
      byte[] fb = new byte[4];
      ds.read(fb,0,4);
      fval = Swap.Float(fb);
      ival = Swap.Long(ds.readInt());
      ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }  
  }  
}