package TINE;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public final class NAME48I
{
  public String name;
  public int ival;
  public static int sizeInBytes = 52;
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public NAME48I() {name = new String(new StringBuffer(48)); ival = 0; }  
  public NAME48I(String Name) { name = Name; ival = 0; }  
  public NAME48I(String Name,int i) { name = Name; ival = i; }  
  public byte[] toByteArray()
  {
    try
    {
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      byte[] bname = name.getBytes();
      byte[] b = new byte[48];
      for (int i=0; i<48 && i<bname.length; i++) b[i] = bname[i];
      ds.write(b,0,b.length);
      ds.writeInt(Swap.Long(ival));
      ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }  
  public void toStruct()
  {
    try
    {
      ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
      DataInputStream ds = new DataInputStream(dis);
      byte[] b = new byte[sizeInBytes];
      ds.read(b,0,48);
      int len = 0; for (int i=0; i<48 && b[i] != 0; i++, len++);
      name = new String(b,0,len);
      ival = Swap.Long(ds.readInt());
      ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }  
  }  
}
