//: TLink.java
package TINE;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
final class Theader
{
  private String username = new String(new StringBuffer(16));
  private short  protocol;
  private short  numInPacket;
  static final short  hdrSizeInBytes = 2 + 16 + 2 + 2; // network header size
  private short totalSizeInBytes;
  ByteArrayOutputStream dBuffer;
  Theader(String u)
  {
    username = u.toUpperCase();
    protocol = 5;
    numInPacket = 1;
    dBuffer = new ByteArrayOutputStream(hdrSizeInBytes);
  }  
  short getTotalSizeInBytes() { return totalSizeInBytes; }  
  void prepare(short msgsize)  // prepare outgoing ...
  {
    totalSizeInBytes = (short)(msgsize + hdrSizeInBytes);
    try
    {
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      ds.writeShort(Swap.Short(totalSizeInBytes));
      byte[] bstr = new byte[16];
      byte[] tmp  = username.getBytes();
      for (int i=0; i<16 && i<tmp.length; i++) bstr[i] = tmp[i];
      ds.write(bstr,0,16);
      ds.writeShort(Swap.Short(protocol));
      ds.writeShort(Swap.Short(numInPacket));
      ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }	 
  }
  void prepare(byte[] data, int length)  // prepare incoming ...
  {
    int bytesread = 0;
    short len;
    try
    {
      ByteArrayInputStream dinBuffer = new ByteArrayInputStream(data);
      DataInputStream ds = new DataInputStream(dinBuffer);
      // overall message length:
      totalSizeInBytes = Swap.Short(ds.readShort());
      bytesread = 2;
      while (bytesread < hdrSizeInBytes)
      {
        byte[] bstr = new byte[16];
        ds.read(bstr,0,16);
        protocol = Swap.Short(ds.readShort());
        numInPacket = Swap.Short(ds.readShort());
      }
      ds.close();
      dinBuffer.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
  }      
}