package TINE;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
public final class USTRING
{
  public int ival;
  public float f1val;
  public float f2val;
  public int tm;
  public String str;
  public static int sizeInBytes = 96;
  ByteArrayOutputStream dBuffer;
  byte[] hByteArray;
  public USTRING() {f1val = 0; f2val = 0; ival = 0; tm  = 0; str = "";}  
  public USTRING(float f1,String s) {f1val = f1; f2val = 0; ival = 0; tm  = 0; str = s;}  
  public USTRING(float f1, float f2,String s) {f1val = f1; f2val = f2; ival = 0; tm  = 0; str = s;}  
  public USTRING(int i,String s) {f1val = 0; f2val = 0; ival = i; tm  = 0; str = s;}  
  public USTRING(int i,float f1,float f2,int tm,String s) {f1val = f1; f2val = f2; ival = i; this.tm  = tm; str = s;}  
  public byte[] toByteArray()
  {
    try
    {
      dBuffer = new ByteArrayOutputStream(sizeInBytes);
    	dBuffer.reset();
    	DataOutputStream ds = new DataOutputStream(dBuffer);
    	byte[] b;
    	ds.writeInt(Swap.Long(ival));
    	b = Swap.Float(f1val); ds.write(b,0,4);
    	b = Swap.Float(f2val); ds.write(b,0,4);
    	ds.writeInt(Swap.Long(tm));
    	ds.write(str.getBytes());
//    	ds.write(b,0,str.length());
      b = new byte[80];
      ds.write(b,0,80-str.length());     
    	ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }    
  public void toStruct()
  {
    try
    {
    	ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
    	DataInputStream ds = new DataInputStream(dis);
    	ival = Swap.Long(ds.readInt());
    	byte[] b = new byte[80];
    	ds.read(b,0,4); f1val = Swap.Float(b);
    	ds.read(b,0,4); f2val = Swap.Float(b);
    	tm = Swap.Long(ds.readInt());
    	ds.read(b,0,80);
      int i;
      for (i=0; i<80 && b[i] != 0; i++);
      str = (new String(b)).substring(0,i);
    	ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }	 
  }    
}