# Makefile for client test program - PKTR rpc calls
# Version 20.03.95
# Insert the defs for your machine
# SUN:    CC = CC         CCL = CC         LM = 
# SGI,OSF CC = cc         CCL = cc         LM = -lm
# ULT     CC = gcc -c -g  CCL = gcc -g     LM = 
# HP:     CC = cc -Aa     CCL = cc         LM = -lM
# SOL 2.4 CC = CC         CCL = CC         LM = -lsocket -lnsl

INCL = /usr/TINE/include
LIBS = /usr/TINE/lib
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/servdef.h \
	${INCL}/errors.h \
	${INCL}/rpctypes.h \
	${INCL}/rpcdefs.h \
	${INCL}/almsrv.h

CC = g++ -c -g -I${INCL}
CC = cc -c -g -I${INCL}
CCL = cc -g
LM = -lm

checkdb: checkdb.o archbase.o ${LIBS}/rpclib.a
	${CCL} -o checkdb checkdb.o archbase.o ${LIBS}/rpclib.a ${LM}
	chmod a+s checkdb

checkdb.o: checkdb.c archive.h
	${CC} checkdb.c

archbase.o: archbase.c archive.h fecdef.h ${HDRS}
	${CC} archbase.c 

clean:
	rm *.o
