VERSION 5.00
Begin VB.Form FORM_defineNewMode 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "New Console Mode"
   ClientHeight    =   1770
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4005
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1770
   ScaleWidth      =   4005
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox TEXT_newMode 
      CausesValidation=   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   435
      Left            =   720
      TabIndex        =   2
      Top             =   720
      Width           =   2475
   End
   Begin VB.CommandButton CMD_ok 
      Caption         =   "&Ok"
      Height          =   375
      Left            =   3060
      TabIndex        =   1
      Top             =   1380
      Width           =   855
   End
   Begin VB.CommandButton CMD_cancel 
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   60
      TabIndex        =   0
      Top             =   1320
      Width           =   855
   End
   Begin VB.Label LABEL_head 
      Alignment       =   2  'Center
      Caption         =   "Enter new mode name:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   0
      TabIndex        =   3
      Top             =   360
      Width           =   3975
   End
End
Attribute VB_Name = "FORM_defineNewMode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub CMD_cancel_Click()
    Unload Me
End Sub

Private Sub CMD_ok_Click()
    terminateEdit
End Sub


Public Sub terminateEdit()
    Dim i As Integer
    Dim l As Integer
    
    l = Len(Trim(TEXT_newMode.text))
    
    If ((l > 16) Or (l < 1)) Then
        TEXT_newMode.SetFocus
        Exit Sub
    End If
       
    For i = 0 To UBound(ConsoleModes)
        If getName16String(ConsoleModes(i).name) = "" Or getName16String(ConsoleModes(i).name) = "Any" Then
            With ConsoleModes(i)
                Call setName16(.name, Trim(TEXT_newMode.text))
                .nProcs = 0
            End With
            Call FORM_consoleDaemon.setCurrentConsoleMode(getName16String(ConsoleModes(i).name), False)
            Call FORM_consoleDaemon.loadModesMenu
            Unload Me
            Exit Sub
        End If
    Next
    Unload Me

End Sub

Private Sub Form_Activate()
    Dim i As Integer
    
    TEXT_newMode.SetFocus
    For i = 0 To UBound(ConsoleModes)
        If getName16String(ConsoleModes(i).name) = "" Then Exit Sub
    Next
    
    CMD_cancel.Visible = False
    TEXT_newMode.Visible = False
    With LABEL_head
        .ForeColor = vbRed
        .caption = "No space for next mode"
    End With
    CMD_ok.Left = (Width - CMD_ok.Width) / 2
End Sub


Private Sub TEXT_newMode_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then terminateEdit
End Sub
