VERSION 5.00
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "MSHFLXGD.OCX"
Begin VB.Form FORM_procsDetails 
   Caption         =   "Form1"
   ClientHeight    =   8505
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9855
   LinkTopic       =   "Form1"
   ScaleHeight     =   8505
   ScaleWidth      =   9855
   StartUpPosition =   3  'Windows Default
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid MSHF 
      Height          =   4695
      Left            =   60
      TabIndex        =   0
      Top             =   420
      Width           =   7455
      _ExtentX        =   13150
      _ExtentY        =   8281
      _Version        =   393216
      _NumberOfBands  =   1
      _Band(0).Cols   =   2
   End
End
Attribute VB_Name = "FORM_procsDetails"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Activate()
        
    If FormProcessDetailsShown Then Exit Sub
               
    initMSHF
    
    getProcessAndWindowInfo
    displayProcessAndWindowInfo
    
    FormProcessDetailsShown = True
End Sub
    

Private Sub initMSHF()
    Dim i As Integer
    
    With MSHF
        .Clear
        .Rows = 200
        .Cols = 15
        .FixedCols = 1
        .FixedRows = 1
        
        .AllowUserResizing = flexResizeColumns
        .TextMatrix(0, 0) = " # "
        .TextMatrix(0, 1) = "Size     "
        .TextMatrix(0, 2) = "Usage"
        .TextMatrix(0, 3) = " PID   "
        .TextMatrix(0, 4) = " DefaultHeapID "
        .TextMatrix(0, 5) = " ModuleID "
        .TextMatrix(0, 6) = " Number of Threads "
        .TextMatrix(0, 7) = " Number of Visible Windows"
        .TextMatrix(0, 8) = " Handles of Visible Windows                                                                "
        .TextMatrix(0, 9) = " ParentPID "
        .TextMatrix(0, 10) = " pcPriClassBase "
        .TextMatrix(0, 11) = " Flags"
        .TextMatrix(0, 12) = " ExeFile                 "
        .TextMatrix(0, 13) = " Command line " + Space(MAX_ARG_LEN)
        .TextMatrix(0, 14) = " Path " + Space(MAX_PATH)
    End With
    
    Call AutoFitFlexGrid(MSHF, MSHF.Cols)
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    FormProcessDetailsShown = False
End Sub

Private Sub Form_Resize()
    On Error GoTo err_handler
    If WindowState = vbMinimized Then Exit Sub
  
    With MSHF
        .Width = ScaleWidth - .Left - 50
        .Height = ScaleHeight - .Top - 50
    End With
    
err_handler:
End Sub


' Make the columns fit their data.
Private Sub AutoFitFlexGrid(ByVal flx As MSHFlexGrid, hideColumns As Integer)
    Dim r As Long, i As Long
    Dim cell_wid As Single, col_wid As Single

    With flx
        .Redraw = False
        For i = 0 To .Cols - 1
            col_wid = 0
            For r = 0 To flx.Rows - 1
                cell_wid = Me.TextWidth(flx.TextMatrix(r, i))
                If col_wid < cell_wid Then col_wid = cell_wid
            Next r
            .ColWidth(i) = col_wid + 120
        Next i
        For i = hideColumns To .Cols - 1
            .ColWidth(i) = 0
        Next
        .Redraw = True
    End With
End Sub


Public Sub displayProcessAndWindowInfo()
    Dim i As Integer, j As Integer
    Dim r As Integer
    
    MSHF.Rows = NRunningProcesses + 1
    
    For i = 0 To NRunningProcesses - 1
        With RunningProcesses(i).procEntry
            r = i + 1
            MSHF.TextMatrix(r, 0) = i + 1
            MSHF.TextMatrix(r, 1) = str(.dwSize)
            MSHF.TextMatrix(r, 2) = str(.cntUsage)
            MSHF.TextMatrix(r, 3) = str(.th32ProcessID)
            MSHF.TextMatrix(r, 4) = str(.th32DefaultHeapID)
            MSHF.TextMatrix(r, 5) = str(.th32ModuleID)
            MSHF.TextMatrix(r, 6) = str(.cntThreads)
            MSHF.TextMatrix(r, 7) = str(RunningProcesses(i).nVisibleWindows)
            MSHF.TextMatrix(r, 8) = ""
            For j = 0 To RunningProcesses(i).nVisibleWindows - 1
                MSHF.TextMatrix(r, 8) = MSHF.TextMatrix(r, 8) + " " + str(RunningProcesses(i).visibleWindows(j).handle) + "(" + str(RunningProcesses(i).visibleWindows(j).parentWindowHandle) + ")"
            Next
            MSHF.TextMatrix(r, 9) = str(.th32ParentProcessID)
            MSHF.TextMatrix(r, 10) = str(.pcPriClassBase)
            MSHF.TextMatrix(r, 11) = str(.dwFlags)
            MSHF.TextMatrix(r, 12) = .szExeFile
            MSHF.TextMatrix(r, 13) = RunningProcesses(i).arguments
            MSHF.TextMatrix(r, 14) = RunningProcesses(i).path
        End With
    Next
    
End Sub
