VERSION 5.00
Object = "{3C5F82B2-2B3E-11D1-B429-00AA004115AF}#2.0#0"; "acop.ocx"
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form FecChecker 
   Caption         =   "Device Server Checker"
   ClientHeight    =   5715
   ClientLeft      =   60
   ClientTop       =   375
   ClientWidth     =   7605
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5715
   ScaleWidth      =   7605
   StartUpPosition =   3  'Windows Default
   Begin VB.OptionButton SelfTestOption 
      Caption         =   "Selected"
      Height          =   315
      Index           =   1
      Left            =   180
      TabIndex        =   13
      Top             =   660
      Width           =   1095
   End
   Begin VB.OptionButton SelfTestOption 
      Caption         =   "Configured"
      Height          =   315
      Index           =   0
      Left            =   180
      TabIndex        =   12
      Top             =   240
      Value           =   -1  'True
      Width           =   1095
   End
   Begin VB.ComboBox StoredConfigCombo 
      Height          =   315
      Left            =   1380
      Style           =   2  'Dropdown List
      TabIndex        =   11
      Top             =   240
      Width           =   1935
   End
   Begin VB.CommandButton Command5 
      Caption         =   "Show Report"
      Height          =   495
      Left            =   6180
      TabIndex        =   10
      Top             =   2340
      Width           =   1335
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Edit Test"
      Height          =   435
      Left            =   6180
      TabIndex        =   9
      Top             =   1800
      Width           =   1335
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Information"
      Height          =   435
      Left            =   6180
      TabIndex        =   8
      Top             =   180
      Width           =   1335
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Specific Test"
      Height          =   435
      Left            =   6180
      TabIndex        =   6
      Top             =   1260
      Width           =   1335
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Standard Test"
      Height          =   435
      Left            =   6180
      TabIndex        =   5
      Top             =   720
      Width           =   1335
   End
   Begin ACOPLib.ACOP ACOP1 
      Height          =   315
      Left            =   5700
      TabIndex        =   4
      Top             =   240
      Visible         =   0   'False
      Width           =   315
      _Version        =   131072
      _ExtentX        =   556
      _ExtentY        =   556
      _StockProps     =   47
      ForeColor       =   0
      BackColor       =   16777215
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      XAxisLabel      =   ""
      YAxisLabel      =   ""
      Status          =   ""
      RandomData      =   0   'False
      LeadingEdgeColor=   -2147483630
      CursorMarkerColor=   -2147483630
   End
   Begin VB.ComboBox DeviceNameList 
      Height          =   315
      Left            =   4440
      TabIndex        =   3
      Top             =   660
      Width           =   1665
   End
   Begin MSFlexGridLib.MSFlexGrid resultsGrid 
      Height          =   3255
      Left            =   180
      TabIndex        =   2
      Top             =   2340
      Width           =   5895
      _ExtentX        =   10398
      _ExtentY        =   5741
      _Version        =   393216
      AllowUserResizing=   1
   End
   Begin VB.ComboBox DeviceServerList 
      Height          =   315
      Left            =   2700
      Sorted          =   -1  'True
      TabIndex        =   1
      Text            =   "DeviceServerList"
      Top             =   660
      Width           =   1695
   End
   Begin VB.ComboBox DeviceContextList 
      Height          =   315
      Left            =   1380
      TabIndex        =   0
      Text            =   "DeviceContext"
      Top             =   660
      Width           =   1275
   End
   Begin VB.Label CheckerLabel 
      BorderStyle     =   1  'Fixed Single
      ForeColor       =   &H000000C0&
      Height          =   1215
      Left            =   180
      TabIndex        =   7
      Top             =   1080
      Width           =   5895
   End
End
Attribute VB_Name = "FecChecker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim dc() As String
Dim ndc As Integer
Dim ds() As String
Dim nds As Integer
Dim dn() As String
Dim ndev As Integer
Dim prp() As String, prpSiz() As Integer, prpTyp() As Integer
Dim nprp As Integer
Dim bblob(16384) As Byte
Dim bblobRef(16384) As Byte
Dim infoHeader As String
Dim CheckListTimeout As Long
Dim gCheckListCompletionCode As Long
Dim gCheckListItem As Integer
Dim gReportFileName As String

Function AddToReport(ByVal txt As String, ByVal addDate As Boolean) As Integer

If Len(gReportFileName) = 0 Then
gReportFileName = Environ$("TEMP") + "\" + Trim$(str(UNIXTIME())) + ".txt"
End If
If addDate Then txt = Format(Now) + " : " + txt
Open gReportFileName For Append As 1
  Print #1, txt
Close 1
End Function

Function fillInProcNames()
Dim a$, c$, tok$
Dim ss() As String
Dim p As Integer, i As Integer, n As Integer
Dim header_done As Boolean
Dim dsc_col As Integer, fn_col As Integer, con_col As Integer, srv_col As Integer
Dim fn As String

fn = dbPath + "\procedures.csv"

On Error GoTo fillInProcNamesError
i = getDatabaseSize(fn)
If i <= 0 Then GoTo fillInProcNamesError
ReDim ProcList(i)
nProcList = i
Open fn For Input Access Read Shared As #1
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And tok$ <> ":" And Len(tok$) > 0 Then
    If Not header_done Then
      header_done = True
      dsc_col = colptr(a$, "Description")
      fn_col = colptr(a$, "FileName")
      con_col = colptr(a$, "Context")
    Else
      If fn_col >= 0 Then ProcList(n).fileName = getcol(a$, fn_col)
      If dsc_col >= 0 Then ProcList(n).dsc = getcol(a$, dsc_col)
      If con_col >= 0 Then ProcList(n).context = getcol(a$, con_col)
      n = n + 1
    End If
  End If
Loop While Not EOF(1)
Close 1
nProcList = n

For i = 0 To nProcList - 1
  fn = dbPath + "\" + ProcList(i).fileName
  n = getDatabaseSize(fn)
  If n > 0 Then
    header_done = False
    ReDim ProcList(i).srvLst(n)
    Open fn For Input Access Read Shared As #1
    n = 0
    Do
      Line Input #1, a$
      tok$ = Left$(a$, 1)
      If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And tok$ <> ":" And Len(tok$) > 0 Then
        If Not header_done Then
          header_done = True
          srv_col = colptr(a$, "Server")
        Else
          If srv_col >= 0 Then ProcList(i).srvLst(n) = getcol(a$, srv_col)
          n = n + 1
        End If
      End If
    Loop While Not EOF(1)
    Close 1
    ProcList(i).nsrvs = n
  Else
    ProcList(i).nsrvs = 0
  End If
Next

Exit Function

fillInProcNamesError:
fillInProcNames = no_such_file
Exit Function
End Function

Function fillInTestParams(context As String, server As String, device As String)
Dim a$, c$, tok$
Dim ss() As String
Dim p As Integer, i As Integer, n As Integer
Dim header_done As Boolean
Dim dsc_col As Integer, prp_col As Integer, dev_col As Integer, isz_col As Integer
Dim osz_col As Integer, ifm_col As Integer, ofm_col As Integer, dat_col As Integer
Dim acc_col As Integer, ref_col As Integer
Dim fn As String

fn = dbPath + context + "-" + server + ".csv"

On Error GoTo fillInTestParamsError
i = getDatabaseSize(fn)
If i <= 0 Then GoTo fillInTestParamsError
ReDim CheckList(i)
nCheckList = i
Open fn For Input Access Read Shared As #1
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And tok$ <> ":" And Len(tok$) > 0 Then
    If Not header_done Then
      header_done = True
      dsc_col = colptr(a$, "Description")
      prp_col = colptr(a$, "Property")
      dev_col = colptr(a$, "Device")
      isz_col = colptr(a$, "InputSize")
      osz_col = colptr(a$, "OutputSize")
      ifm_col = colptr(a$, "InputFormat")
      ofm_col = colptr(a$, "OutputFormat")
      dat_col = colptr(a$, "Data")
      ref_col = colptr(a$, "Reference")
      acc_col = colptr(a$, "Access")
    Else
      If prp_col >= 0 Then
        CheckList(n).prp = getcol(a$, prp_col)
      Else
        fillInTestParams = file_error
        Exit Function
      End If
      If dsc_col >= 0 Then CheckList(n).dsc = getcol(a$, dsc_col) Else CheckList(n).dsc = CheckList(n).prp
      If dev_col >= 0 Then CheckList(n).dev = getcol(a$, dev_col) Else CheckList(n).dev = "#0"
      If isz_col >= 0 Then CheckList(n).sizIn = Val(getcol(a$, isz_col))
      If ifm_col >= 0 Then CheckList(n).fmtIn = getFormatFromString(getcol(a$, ifm_col)) + CF_DOUBLE
      If osz_col >= 0 Then CheckList(n).sizOut = Val(getcol(a$, osz_col))
      If ofm_col >= 0 Then CheckList(n).fmtOut = getFormatFromString(getcol(a$, ofm_col)) + CF_DOUBLE
      If dat_col >= 0 Then CheckList(n).dataIn = getcol(a$, dat_col)
      If ref_col >= 0 Then CheckList(n).dataRef = getcol(a$, ref_col)
      If acc_col >= 0 Then CheckList(n).acc = getcol(a$, acc_col) Else CheckList(n).acc = "READ"
      n = n + 1
    End If
  End If
Loop While Not EOF(1)
Close 1
nCheckList = n
fillInTestParams = 0
Exit Function

fillInTestParamsError:
Close 1
fillInTestParams = no_such_file
Exit Function
End Function
Function fillInTestParamsFromServer(context As String, server As String, device As String) As Integer
Dim a$, c$, tok$
Dim ss() As String
Dim p As Integer, i As Integer, n As Integer
Dim header_done As Boolean
Dim dsc_col As Integer, prp_col As Integer, dev_col As Integer, isz_col As Integer
Dim osz_col As Integer, ifm_col As Integer, ofm_col As Integer, dat_col As Integer
Dim acc_col As Integer, ref_col As Integer
Dim ds As String
Dim rc As Integer
Dim dout As DBLK, din As DBLK

ds = "/" + context + "/" + server + "/#0"
dout.dArrayLength = 16384: dout.dFormat = CF_TEXT
din.dArrayLength = 0: din.dFormat = CF_NULL
rc = EXECLINKEx(ds, "SRVSELFTEST", dout, bblob(0), din, Null, CA_READ, 800)
If rc Then GoTo fillInTestParamsFromServerError
On Error GoTo fillInTestParamsFromServerError
c$ = BSTR(bblob)
ss = Split(c$, Chr(10))
i = UBound(ss)
If i <= 0 Then GoTo fillInTestParamsFromServerError
ReDim CheckList(i)
nCheckList = i
For i = 0 To nCheckList - 1
  a$ = ss(i)
  tok$ = TrimString(Left$(a$, 1))
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And tok$ <> ":" And Len(tok$) > 0 Then
    If Not header_done Then
      header_done = True
      dsc_col = colptr(a$, "Description")
      prp_col = colptr(a$, "Property")
      dev_col = colptr(a$, "Device")
      isz_col = colptr(a$, "InputSize")
      osz_col = colptr(a$, "OutputSize")
      ifm_col = colptr(a$, "InputFormat")
      ofm_col = colptr(a$, "OutputFormat")
      dat_col = colptr(a$, "Data")
      ref_col = colptr(a$, "Reference")
      acc_col = colptr(a$, "Access")
    Else
      If prp_col >= 0 Then
        CheckList(n).prp = getcol(a$, prp_col)
      Else
        fillInTestParamsFromServer = file_error
        Exit Function
      End If
      If dsc_col >= 0 Then CheckList(n).dsc = getcol(a$, dsc_col) Else CheckList(n).dsc = CheckList(n).prp
      If dev_col >= 0 Then CheckList(n).dev = getcol(a$, dev_col) Else CheckList(n).dev = "#0"
      If isz_col >= 0 Then CheckList(n).sizIn = Val(getcol(a$, isz_col))
      If ifm_col >= 0 Then CheckList(n).fmtIn = getFormatFromString(getcol(a$, ifm_col)) + CF_DOUBLE
      If osz_col >= 0 Then CheckList(n).sizOut = Val(getcol(a$, osz_col))
      If ofm_col >= 0 Then CheckList(n).fmtOut = getFormatFromString(getcol(a$, ofm_col)) + CF_DOUBLE
      If dat_col >= 0 Then CheckList(n).dataIn = getcol(a$, dat_col)
      If ref_col >= 0 Then CheckList(n).dataRef = getcol(a$, ref_col)
      If acc_col >= 0 Then CheckList(n).acc = getcol(a$, acc_col) Else CheckList(n).acc = "READ"
      n = n + 1
    End If
  End If
Next
nCheckList = n
fillInTestParamsFromServer = 0
Exit Function

fillInTestParamsFromServerError:
Close 1
fillInTestParamsFromServer = no_such_file
Exit Function

End Function

Function getAccessMode(ByVal accStr As String) As String
getAccessMode = "READ"
If InStr(accStr, "WRITE") > 0 Then getAccessMode = "WRITE"
If InStr(accStr, "POLL") > 0 Then getAccessMode = "POLL"
If InStr(accStr, "REFRESH") > 0 Then getAccessMode = "REFRESH"
End Function
Function getAccessTimeout(ByVal accStr As String) As Long
Dim ss() As String, s As String
Dim i As Integer
getAccessTimeout = 1000
ss = Split(accStr, "[")
If UBound(ss) < 1 Then Exit Function
s = ss(1)
ss = Split(s, "]")
s = ss(0)
ss = Split(s, "=")
For i = LBound(ss) To UBound(ss) Step 2
  If InStr(UCase(ss(i)), "TIMEOUT") > 0 And i < UBound(ss) Then
    getAccessTimeout = Val(ss(i + 1))
  End If
Next
End Function


Function getDatabasePath() As String
Dim fn As String
Dim fs, f, s
Dim dbpth As String

On Error GoTo getDatabasePathErr
Set fs = CreateObject("Scripting.FileSystemObject")
fn = App.ExeName + ".exe"
Set f = fs.GetFile(fn)
getDatabasePath = "..\database\"
Exit Function
getDatabasePathErr:
getDatabasePath = App.Path + "\..\database\"
Exit Function
End Function


Function GetServerInfo(ByVal devcontxt As String, ByVal devsrv As String) As String
Dim devnam As String, txt As String
Dim rc As Long
Dim n As Integer, i As Integer
Dim sver(31) As Byte
Dim aver(31) As Byte
Dim stim(31) As Byte
Dim adat(31) As Byte
Dim dout As DBLK, din As DBLK

devnam = "/" & devcontxt & "/" & devsrv & "/#0"

din.dArrayLength = 0
din.dFormat = CF_NULL

dout.dArrayLength = 32
dout.dFormat = CF_TEXT
rc = EXECLINKEx(devnam, "SRVVERSION", dout, sver(0), din, Null, CA_READ, 500)
If rc = link_not_open Or rc = connection_timeout Then
  txt = "srv vers: unavailable -> " + RPCERROR(rc) + vbNewLine
  txt = txt + " srv start: unavailable -> " + RPCERROR(rc) + vbNewLine
  txt = txt + "app vers: unavailable -> " + RPCERROR(rc) + vbNewLine
  txt = txt + " app date: unavailable -> " + RPCERROR(rc) + vbNewLine
  GetServerInfo = txt
  Exit Function
End If
If rc Then BARR sver, "pre 3.12"

dout.dArrayLength = 32
rc = EXECLINKEx(devnam, "APPVERSION", dout, aver(0), din, Null, CA_READ, 500)
If rc Then BARR aver, "unavailable"

dout.dArrayLength = 32
rc = EXECLINKEx(devnam, "SRVSTARTTIME", dout, stim(0), din, Null, CA_READ, 500)
If rc Then BARR stim, "unavailable"

dout.dArrayLength = 32
rc = EXECLINKEx(devnam, "APPDATE", dout, adat(0), din, Null, CA_READ, 500)
If rc Then BARR adat, "unavailable"

txt = " srv vers: " + BSTR(sver) + vbNewLine
txt = txt + " srv start: " + BSTR(stim) + vbNewLine
txt = txt + " app vers: " + BSTR(aver) + vbNewLine
txt = txt + " app date: " + BSTR(adat) + vbNewLine

GetServerInfo = txt

End Function

Function initSelfText(ByVal devcon As String, ByVal devsrv As String, ByVal devnam As String) As Integer
Dim rc As Integer
Dim fn As String

If Len(infoHeader) = 0 Then infoHeader = GetServerInfo(devcon, devsrv)

rc = fillInTestParamsFromServer(devcon, devsrv, devnam)
CheckerLabel.Caption = infoHeader + "Specific test commands from SRVSELFTEST"
If rc <> 0 Then
  fn = dbPath + devcon + "-" + devsrv + ".csv"
  rc = fillInTestParams(devcon, devsrv, devnam)
  CheckerLabel.Caption = infoHeader + "Specific test commands from " + fn
End If
If rc Then
  CheckerLabel.Caption = infoHeader + fn + " : " + RPCERROR(rc)
End If
AddToReport "--------------------------------------------------------------", False
AddToReport "Self-test for /" + devcon + "/" + devsrv, False
AddToReport CheckerLabel.Caption, False
AddToReport "------- Time ------:----- Action -----:------- Results -------", False

initSelfText = rc
End Function

Sub initStdTest(ByVal devcon As String, ByVal devsrv As String, ByVal devnam As String)
Dim dnam As String
Dim rc As Long
Dim n As Integer, i As Integer, nprp As Integer

If Len(infoHeader) = 0 Then infoHeader = GetServerInfo(devcon, devsrv)

dnam = "/" & devcon & "/" & devsrv & "/" & devnam
rc = GetEquipmentDevicePropertyInformation(dnam, prp(), prpSiz(), prpTyp(), nprp)
If rc Then Exit Sub
n = 0
ReDim CheckList(nprp)
For i = 0 To nprp - 1
  If InStr(prp(i), "*") = 0 And prpSiz(i) > 0 Then
    CheckList(n).dsc = prp(i)
    CheckList(n).prp = prp(i)
    CheckList(n).dev = DeviceNameList.text
    CheckList(n).sizOut = prpSiz(i)
    CheckList(n).fmtOut = prpTyp(i)
    CheckList(n).acc = "READ"
    n = n + 1
  End If
Next
nCheckList = n
CheckerLabel.Caption = infoHeader + "Standard test for " + str(n) + " READ properties"
AddToReport "Standard test for read properties of /" + devcon + "/" + devsrv, False
AddToReport CheckerLabel.Caption, False
AddToReport "------- Time ------:----- Action -----:------- Results -------", False

End Sub

Function parseStringToData(bdata() As Byte, ByVal fmt As Integer, ByVal s As String) As Long
Dim i As Integer, n As Integer, siz As Integer
Dim ss() As String
Dim iVal As Integer
Dim lval As Long
Dim fval As Single
Dim dval As Double
Dim bval(63) As Byte

ss = Split(s, " ")
n = UBound(ss) + 1
If n > UBound(bdata) Then n = UBound(bdata)
Select Case fmt
  Case CF_BYTE:
    For i = 0 To n - 1
      bdata(i) = Val(ss(i)) Mod 255
    Next
  Case CF_SHORT:
    For i = 0 To n - 1
      iVal = Val(ss(i)) Mod 32767
      MEMCPY bdata(i * 2), iVal, 2
    Next
  Case CF_LONG:
    For i = 0 To n - 1
      lval = Val(ss(i))
      MEMCPY bdata(i * 4), lval, 4
    Next
  Case CF_FLOAT:
    For i = 0 To n - 1
      fval = Val(ss(i))
      MEMCPY bdata(i * 4), fval, 4
    Next
  Case CF_DOUBLE:
    For i = 0 To n - 1
      dval = Val(ss(i))
      MEMCPY bdata(i * 8), dval, 8
    Next
  Case CF_NAME8, CF_NAME16, CF_NAME32, CF_NAME48, CF_NAME64:
    siz = GetFormatSize(fmt)
    For i = 0 To n - 1
      BARR bval, ss(i)
      MEMCPY bdata(i * siz), bval(0), siz
    Next
  Case CF_TEXT:
    BARR bdata, s
    n = Len(s)
  Case Else:
    parseStringToData = 0
    Exit Function
End Select
parseStringToData = n
End Function

Sub RunFecCheck(ByVal context As String, ByVal server As String)
Dim nchecks As Integer, rc As Long
Dim sizOut As Long, sizIn As Long, sz As Long
Dim fmtsiz As Integer
Dim sts As String, msg As String
Dim n As Integer, i As Integer
Dim ID As Long
Dim useSynchronousLink As Boolean

'nchecks = UBound(CheckList) - LBound(CheckList) + 1
nchecks = nCheckList

ACOP1.DeviceContext = context
ACOP1.DeviceGroup = server

resultsGrid.Clear
resultsGrid.Rows = nchecks + 1
resultsGrid.Row = 0
resultsGrid.col = 0
resultsGrid.ColWidth(0) = 2000
resultsGrid.text = " Action "
resultsGrid.col = 1
resultsGrid.ColWidth(1) = 4000
resultsGrid.text = " Results "
n = 0
For i = 0 To nchecks - 1
  rc = 0
  resultsGrid.col = 0
  resultsGrid.Row = n + 1
  resultsGrid.text = CheckList(n).dsc
  ACOP1.DeviceProperty = CheckList(n).prp
  ACOP1.DeviceName = CheckList(n).dev
  ACOP1.accessMode = getAccessMode(CheckList(n).acc)
  CheckListTimeout = getAccessTimeout(CheckList(n).acc)
  sizOut = CheckList(n).sizOut
  If sizOut > 0 Then fmtsiz = GetFormatSize(CheckList(n).fmtOut)
  If fmtsiz <= 0 Then sizOut = 0
  If sizOut > 0 Then
    If sizOut > (16384 / fmtsiz) Then sizOut = (16384 / fmtsiz)
    fmtsiz = 0
  End If
  sizIn = CheckList(n).sizIn
  If sizIn > 0 Then fmtsiz = GetFormatSize(CheckList(n).fmtIn)
  If fmtsiz <= 0 Then sizIn = 0
  If sizIn > 0 Then
    If sizIn > (16384 / fmtsiz) Then sizIn = (16384 / fmtsiz)
    sz = parseStringToData(bblob, CheckList(n).fmtIn, CheckList(n).dataIn)
    If sz <> sizIn Then
      sts = "Input data : parse error"
      rc = argument_list_error
    End If
  End If
  useSynchronousLink = (ACOP1.accessMode = "READ" Or ACOP1.accessMode = "WRITE")
  If useSynchronousLink Then ACOP1.AccessRate = CheckListTimeout
  If rc = 0 Then
    resultsGrid.col = 1
retryLink:
    gCheckListCompletionCode = -1
    gCheckListItem = n
    If Len(CheckList(n).dataRef) > 0 Then
      sz = parseStringToData(bblobRef, CheckList(n).fmtOut, CheckList(n).dataRef)
    End If
    If sizIn > 0 And sizOut > 0 Then  ' read/write
      If useSynchronousLink Then
        rc = ACOP1.Execute(bblob(0), sizOut, CheckList(n).fmtOut, bblob(0), sizIn, CheckList(n).fmtIn)
      Else
        ID = ACOP1.AttachLink(bblob(0), sizOut, CheckList(n).fmtOut, bblob(0), sizIn, CheckList(n).fmtIn)
        If ID < 0 Then
          rc = ID
        Else
          WaitForAsyncCompletion CheckListTimeout
          rc = gCheckListCompletionCode
        End If
      End If
    ElseIf sizIn > 0 And sizOut = 0 Then  ' write only
      rc = ACOP1.Execute(, , , bblob(0), sizIn, CheckList(n).fmtIn)
    Else                                  ' read only
      If useSynchronousLink Then
        rc = ACOP1.Execute(bblob(0), sizOut, CheckList(n).fmtOut)
      Else
        ID = ACOP1.AttachLink(bblob(0), sizOut, CheckList(n).fmtOut)
        If ID < 0 Then
          rc = ID
        Else
Debug.Print "starting wait ", gCheckListCompletionCode, bblob(2), bblob(3)
          WaitForAsyncCompletion CheckListTimeout
          rc = gCheckListCompletionCode
        End If
      End If
    End If
    If rc = operation_timeout Then
      sts = "timed out waiting for reference"
    Else
      sts = ACOP1.Status
    End If
    If rc = 0 Then
      sts = "Success"
      If Len(CheckList(n).dataRef) > 0 And sizOut > 0 Then
        fmtsiz = GetFormatSize(CheckList(n).fmtOut)
        If MEMCMP(bblob(0), bblobRef(0), fmtsiz * sizOut) <> 0 Then
          rc = invalid_data
          sts = "Target not met !"
        Else
          sts = sts + " (Target met)"
        End If
      End If
    Else
      msg = "/" + ACOP1.DeviceContext + "/" + ACOP1.DeviceGroup + "/" + ACOP1.DeviceName + "[" + ACOP1.DeviceProperty + "]"
      msg = msg + "  ->  " + sts
      If MsgBox(msg, vbRetryCancel, "Link Error") = vbRetry Then GoTo retryLink
    End If
  End If
  resultsGrid.col = 1
  resultsGrid.CellForeColor = IIf(rc = 0, vbBlack, vbRed)
  resultsGrid.text = sts
  AddToReport CheckList(n).dsc + " : " + sts, True
  n = n + 1
Next

End Sub

Sub WaitForAsyncCompletion(ByVal timeout As Long)
Dim starttime As Long, interim As Long
Dim cnt As Integer
starttime = UNIXTIME()
timeout = timeout / 1000
resultsGrid.CellForeColor = vbBlue
resultsGrid.text = "Waiting ."
Do
  Sleep 100
  DoEvents
  interim = UNIXTIME()
  If interim > starttime + timeout Then gCheckListCompletionCode = operation_timeout
  cnt = cnt + 1
  If (cnt Mod 10) = 0 Then resultsGrid.text = resultsGrid.text + "."
Loop While gCheckListCompletionCode = -1
ACOP1.CloseLink
End Sub

Private Sub ACOP1_Receive(ByVal LinkIndex As Long, ByVal StatusCode As Long)
Dim n As Integer, fmtsiz As Integer

Debug.Print "Received status : ", StatusCode
If StatusCode <> 0 Then
  If (StatusCode = illegal_property) Or (StatusCode = illegal_equipment_number) Then
    gCheckListCompletionCode = StatusCode
  End If
  Exit Sub
End If
n = gCheckListItem
If Len(CheckList(n).dataRef) > 0 Then  ' poll until a reference data set is reached
  fmtsiz = GetFormatSize(CheckList(n).fmtOut)
  If MEMCMP(bblob(0), bblobRef(0), fmtsiz * CheckList(n).sizOut) <> 0 Then Exit Sub
End If
gCheckListCompletionCode = 0 ' link returns success and/or reference data set reached ...
End Sub

Private Sub Command1_Click()
gReportFileName = ""
initStdTest DeviceContextList.text, DeviceServerList.text, DeviceNameList.text
RunFecCheck DeviceContextList.text, DeviceServerList.text
End Sub
Private Sub Command2_Click()
Dim i As Integer, n As Integer
gReportFileName = ""
If SelfTestOption(1).Value Then
  If initSelfText(DeviceContextList.text, DeviceServerList.text, DeviceNameList.text) = 0 Then
    RunFecCheck DeviceContextList.text, DeviceServerList.text
  End If
Else
  n = StoredConfigCombo.ListIndex
  For i = 0 To ProcList(n).nsrvs - 1
    infoHeader = ""
    If initSelfText(ProcList(n).context, ProcList(n).srvLst(i), "#0") = 0 Then
      RunFecCheck ProcList(n).context, ProcList(n).srvLst(i)
    End If
  Next
End If
End Sub
Private Sub Command3_Click()
If Len(infoHeader) = 0 Then infoHeader = GetServerInfo(DeviceContextList.text, DeviceServerList.text)
CheckerLabel.Caption = infoHeader
End Sub

Private Sub Command4_Click()
  CheckScripter.Show 1
End Sub

Private Sub Command5_Click()
Dim cmdstr As String
cmdstr = "Notepad " + gReportFileName
Shell cmdstr, vbNormalFocus
End Sub

Private Sub DeviceContextList_Click()
Dim rc As Integer, i As Integer
rc = GetEquipmentDeviceServers(DeviceContextList.text, "", ds(), nds)
If rc Then Exit Sub
DeviceServerList.Clear
For i = 0 To nds - 1
  DeviceServerList.AddItem ds(i)
Next
DeviceServerList.ListIndex = 0

End Sub


Private Sub DeviceServerList_Click()
Dim rc As Integer, ndev As Integer, i As Integer, n As Integer
Dim fmtsiz As Integer, siz As Integer
Dim sts As String
Dim devnam As String
Dim dout As DBLK

DeviceNameList.Clear
rc = GetEquipmentDeviceNames(DeviceServerList.text, dn(), ndev)
If rc Then Exit Sub
For i = 0 To ndev - 1
  DeviceNameList.AddItem dn(i)
Next
DeviceNameList.ListIndex = 0
infoHeader = ""
End Sub

Private Sub Form_Load()
Dim rc As Integer, i As Integer

resultsGrid.Row = 0
resultsGrid.col = 0
resultsGrid.ColWidth(0) = 2000
resultsGrid.text = " Action "
resultsGrid.col = 1
resultsGrid.ColWidth(1) = 4000
resultsGrid.text = " Results "

rc = GetEquipmentDeviceContexts(dc(), ndc)
If rc Then Exit Sub
For i = 0 To ndc - 1
  DeviceContextList.AddItem dc(i)
Next
DeviceContextList.ListIndex = 0

dbPath = getDatabasePath

fillInProcNames

For i = 0 To nProcList - 1
  StoredConfigCombo.AddItem ProcList(i).dsc
Next
If nProcList > 0 Then StoredConfigCombo.ListIndex = 0

End Sub


