VERSION 5.00
Object = "{A8B3B723-0B5A-101B-B22E-00AA0037B2FC}#1.0#0"; "GRID32.OCX"
Begin VB.Form globals 
   Appearance      =   0  'Flat
   BackColor       =   &H00808000&
   Caption         =   "Globals"
   ClientHeight    =   1365
   ClientLeft      =   210
   ClientTop       =   480
   ClientWidth     =   2910
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Icon            =   "GLOBALS.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1365
   ScaleWidth      =   2910
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   1290
      Top             =   -180
   End
   Begin MSGrid.Grid GlobalsGrid 
      Height          =   1335
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2895
      _Version        =   65536
      _ExtentX        =   5106
      _ExtentY        =   2355
      _StockProps     =   77
      BackColor       =   16777215
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
End
Attribute VB_Name = "globals"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim glbname$(NUMEQP), glbfmt%(NUMEQP), glbsiz%(NUMEQP), nglobals%, globalsize%

Private Sub Form_Load()
globfile$ = CDBPATH$ + "nglobals.csv"
i% = 0
On Error GoTo GlobalsError
Open globfile$ For Input Access Read Shared As #1
Do
    Line Input #1, a$
    tok$ = Left$(a$, 1)
    If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And Len(a$) > 7 Then
      If Not done Then
        key_col = colptr(a$, "KEYWORD")
        fmt_col = colptr(a$, "FORMAT")
        siz_col = colptr(a$, "SIZE")
        done = True
      Else
        glbname$(i%) = getcol(a$, key_col)
        fmtstr$ = getcol(a$, fmt_col)
        fmtval% = Val(fmtstr)
        If fmtval% < CF_DOUBLE Then
          fmtstr$ = UCase(fmtstr$)
          Select Case fmtstr$
           Case "BYTE": fmtval% = CF_BYTE
           Case "SHORT", "INT", "INTEGER": fmtval% = CF_SHORT
           Case "LONG": fmtval% = CF_LONG
           Case "FLOAT": fmtval% = CF_FLOAT
           Case "DOUBLE": fmtval% = CF_DOUBLE
           Case "CHAR": fmtval% = CF_TEXT
           Case "NAME8", "STRING8", "CHAR8": fmtval% = CF_CHAR8
           Case "NAME16", "STRING16", "CHAR16": fmtval% = CF_CHAR16
           Case "NAME32", "STRING32", "CHAR32": fmtval% = CF_CHAR32
           Case "CHAR16FI", "NAMEFI": fmtval% = CF_CHAR16FI
           Case "STRUCT": vmtval% = CF_STRUCT
          End Select
        End If
        glbfmt%(i%) = fmtval%
        sizstr$ = getcol(a$, siz_col)
        glbsiz%(i%) = Val(sizstr$)
        If glbsiz%(i%) > globalsize% Then globalsize% = glbsiz%(i%)
        i% = i% + 1
        If i% > NUMEQP Then Exit Do
      End If
    End If
  Loop While Not EOF(1)
  Close 1

GlobalsError:
nglobals% = i%
GlobalsGrid.Rows = nglobals% + 1
GlobalsGrid.Cols = globalsize% + 2
GlobalsGrid.Row = 0
GlobalsGrid.col = 0: GlobalsGrid.text = "Parameter"
GlobalsGrid.col = 1: GlobalsGrid.text = "Value"
GlobalsGrid.ColWidth(0) = 1200
GlobalsGrid.ColWidth(1) = 2400
For i% = 2 To globalsize% + 1
  GlobalsGrid.ColWidth(i%) = 2400
Next i%
For i% = 0 To nglobals% - 1
  GlobalsGrid.Row = i% + 1
  GlobalsGrid.col = 0: GlobalsGrid.text = glbname$(i%)
Next i%
globals.Height = (nglobals% + 1) * 240 + 800
globals.Left = Screen.Width - globals.Width
globals.Top = Screen.Height - globals.Height
End Sub

Private Sub Form_Resize()
GlobalsGrid.Height = globals.ScaleHeight - GlobalsGrid.Top * 2
End Sub

Private Sub Timer1_Timer()
Dim st As String * 32
For i% = 0 To nglobals% - 1
  GlobalsGrid.Row = i% + 1
  Select Case glbfmt%(i%)
    Case CF_DOUBLE:
      rc% = GETGLOBAL(glbname$(i%), ddat#(0), glbsiz%(i%), CF_DOUBLE)
      For j% = 1 To glbsiz%(i%)
        GlobalsGrid.col = j%
        dd# = IIf(rc%, -1, ddat#(j% - 1))
        GlobalsGrid.text = Format$(dd#, "####0.000")
      Next j%
    Case CF_INTEGER:
      rc% = GETGLOBAL(glbname$(i%), idat%(0), glbsiz%(i%), CF_INTEGER)
      For j% = 1 To glbsiz%(i%)
        GlobalsGrid.col = j%
        id% = IIf(rc%, -1, idat%(j% - 1))
        GlobalsGrid.text = str$(id%)
      Next j%
    Case CF_LONG:
      rc% = GETGLOBAL(glbname$(i%), ldat&(0), glbsiz%(i%), CF_LONG)
      For j% = 1 To glbsiz%(i%)
        GlobalsGrid.col = j%
        ld& = IIf(rc%, -1, ldat&(j% - 1))
        GlobalsGrid.text = str$(ld&)
      Next j%
    Case CF_FLOAT:
      rc% = GETGLOBAL(glbname$(i%), fdat!(0), glbsiz%(i%), CF_FLOAT)
      For j% = 1 To glbsiz%(i%)
        GlobalsGrid.col = j%
        fd! = IIf(rc%, -1, fdat!(j% - 1))
        GlobalsGrid.text = str$(fd!)
      Next j%
    Case CF_CHAR8:
      rc% = GETGLOBAL(glbname$(i%), bdat(0), glbsiz%(i%), CF_CHAR8)
      For j% = 1 To glbsiz%(i%)
        GlobalsGrid.col = j%
        If rc% Then st = "-1" Else Call Bytes2String(st, bdat((j% - 1) * 8), 8)
        GlobalsGrid.text = st
      Next j%
    Case CF_CHAR16:
      rc% = GETGLOBAL(glbname$(i%), bdat(0), glbsiz%(i%), CF_CHAR16)
      For j% = 1 To glbsiz%(i%)
        GlobalsGrid.col = j%
        If rc% Then st = "-1" Else Call Bytes2String(st, bdat((j% - 1) * 16), 16)
        GlobalsGrid.text = st
      Next j%
    Case CF_CHAR32:
      rc% = GETGLOBAL(glbname$(i%), bdat(0), glbsiz%(i%), CF_CHAR32)
      For j% = 1 To glbsiz%(i%)
        GlobalsGrid.col = j%
        If rc% Then st = "-1" Else Call Bytes2String(st, bdat((j% - 1) * 32), 32)
        GlobalsGrid.text = st
      Next j%
    
    End Select
Next i%
End Sub

