Declare Function Address Lib "tinesv16.dll" (r As Any) As Long
Declare Function CADDR Lib "tinesv16.dll" (r As Any) As Long
Declare Function UTIME Lib "tinesv16.dll" () As Long
Declare Sub ASCTIME Lib "tinesv16.dll" (ByVal dat$, ByVal timestamp&)
Declare Function DebugServer Lib "tinesv16.dll" (ByVal level%) As Integer
Declare Function RegisterProperty Lib "tinesv16.dll" (ByVal eqname$, ByVal prop$, ByVal siz%, ByVal fmt%, ByVal acc%, ByVal desc$) As Integer
Declare Function RegisterPropertyEx Lib "tinesv16.dll" (ByVal eqm$, ByVal prop$, ByVal sizIn%, ByVal fmtIn%, ByVal tagIn$, ByVal sizOut%, ByVal fmtOut%, ByVal tagOut$, ByVal acc%, ByVal dsc$) As Integer
Declare Function RegisterModuleName Lib "tinesv16.dll" (ByVal eqname$, ByVal devname$, ByVal devnr%) As Integer
Declare Function GetDeviceNumber Lib "tinesv16.dll" (ByVal eqname$, ByVal devname$) As Integer
Declare Function GetModuleNumber Lib "tinesv16.dll" Alias "GetDeviceNumber" (ByVal eqname$, ByVal devname$) As Integer
Declare Sub GetDeviceName Lib "tinesv16.dll" (ByVal eqname$, ByVal devnum%, ByVal devname$)
Declare Sub GetModuleName Lib "tinesv16.dll" Alias "GetDeviceName" (ByVal eqname$, ByVal devnum%, ByVal devname$)
Declare Function GetPropertyId Lib "tinesv16.dll" (ByVal eqname$, ByVal property$) As Integer
Declare Function RegisterSeverity Lib "tinesv16.dll" (ByVal almCode&, ByVal almSeverity%) As Integer
Declare Function SetAlarm Lib "tinesv16.dll" (ByVal EqpName$, ByVal devnr%, ByVal almCode&, almData As Any) As Integer
Declare Sub ClearAlarm Lib "tinesv16.dll" (ByVal EqpName$, ByVal devnr%)
Declare Function SetMinimumPollingRate Lib "tinesv16.dll" (ByVal mpr%) As Integer
Declare Sub SETRPCERROR Lib "tinesv16.dll" (ByVal errCode%, ByVal errStr$)
Declare Function FILLSRVSTRUCT Lib "tinesv16.dll" (ByVal tag$, ByVal addr%, ByVal size%, ByVal fmt%) As Integer


' ================================
'   RPC Error Definitions
' ================================
Global Const success% = 0
Global Const illegal_line% = 1
Global Const illegal_format% = 2
Global Const illegal_arithmetic% = 3
Global Const ambiguous% = 4
Global Const illegal_delimiter% = 5
Global Const zero_divide% = 6
Global Const WA_full% = 7
Global Const non_existent% = 8
Global Const wrong_type% = 9
Global Const link_exhausted% = 10
Global Const not_properly% = 11
Global Const un_allocated% = 12
Global Const no_such_line% = 13
Global Const illegal_shuffle% = 14
Global Const if_error% = 15
Global Const escape_typed% = 16
Global Const ask_error% = 18
Global Const argument_list_error% = 20
Global Const file_error% = 21
Global Const use_stream_transport% = 22
Global Const dimension_error% = 23
Global Const square_root_negative% = 24
Global Const buffer_too_small% = 25
Global Const string_too_long% = 26
Global Const ipx_socket_error% = 27
Global Const net_read_error% = 28
Global Const not_ready% = 29
Global Const log_negative% = 31
Global Const device_not_connected% = 32
Global Const unauthorised_action% = 33
Global Const hardware_error% = 34
Global Const illegal_equipment_number% = 35
Global Const illegal_property% = 36
Global Const out_of_range% = 37
Global Const not_implemented% = 38
Global Const no_such_computer% = 39
Global Const string_filled% = 40
Global Const syntax_error% = 41
Global Const no_such_file% = 42
Global Const file_already_exists% = 43
Global Const no_file_space% = 44
Global Const link_not_open% = 45
Global Const remitted_data_lost% = 46
Global Const end_of_file% = 47
Global Const archive_busy% = 48
Global Const server_name_in_use% = 49
Global Const no_such_column% = 50
Global Const out_of_client_memory% = 51
Global Const def_area_full% = 52
Global Const def_syntax% = 53
Global Const illegal_string_set% = 54
Global Const serr1% = 54
Global Const string_function_failure% = 55
Global Const serr2% = 55
Global Const Sif_error% = 57
Global Const Sask_error% = 58
Global Const string_expected% = 59
Global Const out_of_local_memory% = 60
Global Const out_of_shared_memory% = 61
Global Const invalid_structure_tag% = 62
Global Const invalid_index% = 63
Global Const illegal_equipment_name% = 64
Global Const link_error% = 65
Global Const code_failure% = 66
Global Const bracket_missing% = 67
Global Const wrong_hexa% = 68
Global Const wrong_octal% = 69
Global Const illegal_character% = 70
Global Const illegal_operator% = 71
Global Const not_allowed% = 72
Global Const illegal_read_write% = 73
Global Const out_of_memory% = 74
Global Const out_of_server_memory% = 74
Global Const database_not_loaded% = 75
Global Const illegal_command% = 76
Global Const resources_exhausted% = 77
Global Const file_not_open% = 78
Global Const sedac_error% = 79
Global Const no_such_loop% = 80
Global Const driver_not_installed% = 82
Global Const port_not_available% = 83
Global Const scan_error% = 84
Global Const no_high_voltage% = 85
Global Const non_existent_elem% = 86
Global Const non_existent_fec% = 87
Global Const non_existent_client% = 88
Global Const cannot_lock% = 89
Global Const not_running% = 90
Global Const not_posted% = 91
Global Const not_accepted% = 92
Global Const operation_timeout% = 93
Global Const illegal_protocol% = 94
Global Const gpib_error% = 95
Global Const rs232_error% = 96
Global Const operation_busy% = 97
Global Const connection_timeout% = 98
Global Const illegal_mode% = 99
Global Const not_owner% = 100
Global Const not_defined% = 101
Global Const net_write_error% = 102
Global Const invalid_data% = 103
Global Const software_error% = 104
Global Const access_denied% = 105
Global Const tcp_not_supported% = 106
Global Const ipx_not_supported% = 107
Global Const host_not_resolved% = 108
Global Const tcp_connect_error% = 109
Global Const tcp_socket_error% = 110
Global Const fpss_error% = 111
Global Const fpss_timeout% = 112
Global Const fpss_overflow% = 113
Global Const pocal_error% = 114
Global Const max_alarms_exceeded% = 115
Global Const not_exported% = 116
Global Const is_switching% = 117
Global Const at_limit% = 118

Function vbRegisterProperty (EqpName$, EqpProperty$, inArray() As Variant, outArray() As Variant, accessMode As Variant, description As Variant) As Integer
Dim numIn%, numOut%, fmtIn%, fmtOut%
Dim acc%, dsc$, cc%

numIn% = UBound(inArray) - LBound(inArray) + 1
Select Case VarType(inArray(0))
  Case 2:     fmtIn% = CF_INTEGER
  Case 3:     fmtIn% = CF_LONG
  Case 4:     fmtIn% = CF_SINGLE
  Case 5:     fmtIn% = CF_DOUBLE
  Case 8:     fmtIn% = CF_TEXT
  Case Else:  fmtIn% = CF_NULL
End Select
numOut% = UBound(outArray) - LBound(outArray) + 1
Select Case VarType(outArray(0))
  Case 2:     fmtOut% = CF_INTEGER
  Case 3:     fmtOut% = CF_LONG
  Case 4:     fmtOut% = CF_SINGLE
  Case 5:     fmtOut% = CF_DOUBLE
  Case 8:     fmtOut% = CF_TEXT
  Case Else:  fmtOut% = CF_NULL
End Select
If VarType(accessMode) = 2 Then
  acc% = accessMode
Else
  acc% = CA_READ
End If
If VarType(descripton) = 8 Then
  dsc$ = description
Else
  dsc$ = "no description given"
End If

cc% = RegisterPropertyEx(EqpName$, EqpProperty$, numIn%, fmtIn%, "", numOut%, fmtOut%, "", acc%, dsc$)
If cc% >= 0 Then
  ' we're not usually interested in the property Id in the VB world
  vbRegisterProperty = 0
Else
  ' return a positive error code
  vbRegisterProperty = -cc%
End If
End Function

