Attribute VB_Name = "modWD_nt"
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'   -------  modWD_nt.bas  ------------------
'   make sure tine.bas is also included in the project so that DBLK and
'   the system formats and access modes are defined
'   as m_pc_name below, use the 'fecname' (something like HEEKOLLI.5, for instance)
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function getWDNameFromFECName(fecname As String) As String
  Dim wd_name As String, fname As String
  Dim p As Integer
  ' assume the <fecname> = <computername>.<nr> naming scheme
  fname = TrimString(fecname)
  p = InStr(fname, ".")
  If p > 0 Then 'this is the systematics everyone should be following
    p = p - 1
    wd_name = Left$(fname, p) + "_WD"
  Else          'somebody has 'done his own thing' so try this
    If Left$(fname, 5) = "ACCNT" Then fname = Right(fname, Len(fname) - 5)
    wd_name = fname + "_WD"
  End If
  getWDNameFromFECName = wd_name
End Function

Function wd_restart(m_pc_name As String) As Integer
  Dim wd_name As String, fname As String, dsname As String
  Dim bname(16) As Byte
  Dim rc As Integer, p As Integer
  Dim din As DBLK, dout As DBLK
  ' assume the <fecname> = <computername>.<nr> naming scheme
  fname = TrimString(m_pc_name)
  p = InStr(fname, ".")
  If p > 0 Then 'this is the systematics everyone should be following
    p = p - 1
    wd_name = Left$(fname, p) + "_WD"
  Else          'somebody has 'done his own thing' so try this
    If Left$(fname, 5) = "ACCNT" Then fname = Right(fname, Len(fname) - 5)
    wd_name = fname + "_WD"
  End If
  dsname = "/SERVICE/" + wd_name
  dout.dArrayLength = Len(fname): dout.dFormat = CF_BYTE
  din.dArrayLength = Len(fname): din.dFormat = CF_BYTE
  BARR bname(), fname
  rc = T_EXECLINK(dsname, "STOP", dout, bname(0), din, bname(0), CA_WRITE + CA_READ, 1000)
  If rc Then
    wd_restart = rc
    Exit Function
  End If
  dout.dArrayLength = Len(fname): dout.dFormat = CF_BYTE
  din.dArrayLength = Len(fname): din.dFormat = CF_BYTE
  BARR bname(), fname
  rc = T_EXECLINK(dsname, "START", dout, bname(0), din, bname(0), CA_WRITE + CA_READ, 1000)
  wd_restart = rc
End Function
Function wd_reboot(m_pc_name As String) As Integer
  Dim wd_name As String, fname As String, dsname As String
  Dim blong As Long
  Dim rc As Integer, p As Integer
  Dim din As DBLK, dout As DBLK
  ' assume the <fecname> = <computername>.<nr> naming scheme
  fname = TrimString(m_pc_name)
  p = InStr(fname, ".")
  If p > 0 Then 'this is the systematics everyone should be following
    p = p - 1
    wd_name = Left$(fname, p) + "_WD"
  Else          'somebody has 'done his own thing' so try this
    If Left$(fname, 5) = "ACCNT" Then fname = Right(fname, Len(fname) - 5)
    wd_name = fname + "_WD"
  End If
  dsname = "/SERVICE/" + wd_name
  dout.dArrayLength = 1: dout.dFormat = CF_LONG
  din.dArrayLength = 1: din.dFormat = CF_LONG
  rc = T_EXECLINK(dsname, "REBOOTPC", dout, blong, din, blong, CA_WRITE + CA_READ, 1000)
  wd_reboot = rc
End Function

