#include "prolog.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include "servdef.h"
#include "rpctypes.h"
#include "errors.h"

extern int nofeclog;
extern int ListenForGlobals;
extern int ListenForMCasts;
extern int defaultClientTimeout;
int tget(char *dev,char *prp);
int thistory(char *context,char *keyword,char *devname,char *stoptime,char *depth);
int main(int argc, char *argv[])
{
  int cc,i;
  char *context=NULL, *keyword=NULL, *device=NULL, *stoptime="NOW", *depth="1 DAY";
  char tmpdev[32];
  switch (argc)
  {
    case 2:
      keyword = argv[1];
      break;
    case 3:
      keyword = argv[1];
      depth = argv[2];
      break;
    case 4:
      keyword = argv[1];
      stoptime = argv[2];
      depth = argv[3];
      break;
    case 5:
      context = argv[1];
      keyword = argv[2];
      stoptime = argv[3];
      depth = argv[4];
      break;
    case 6:
      context = argv[1];
      keyword = argv[2];
      device = argv[3];
      stoptime = argv[4];
      depth = argv[5];
      for (i=0; i<(int)strlen(device) && isdigit(device[i]); i++);
      if (i == (int)strlen(device)) 
      {
        sprintf(tmpdev,"#%s",device);
        device = tmpdev;
      }
      break;
    default:
      printf("Usage thistory <context> <keyword> <device name> <stop time> <depth>\n");
      exit(1);
  }
  MaxNumConnections = 3;
  ListenForGlobals = ListenForMCasts = FALSE;
  MaxPollingRate = MinPollingRate = 50;
  defaultClientTimeout = 50;
  nofeclog = TRUE;
//  printf("\n");
  if ((cc=thistory(context,keyword,device,stoptime,depth)) != 0)
    printf("error : %s\n",erlst[cc]);
  printf("\n");
  return cc;
}
