#include "project.def"
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <dos.h>
#include <math.h>
#include <alloc.h>
#include <signal.h>
#include <io.h>
#include <fcntl.h>
#include <share.h>
#include <sys\stat.h>
#include <nwipxspx.h>
#ifdef NOVELL
#include <nwcaldef.h>
#include <nwcalls.h>
#endif
#ifdef WINSOCK
#include <winsock.h>
#else
#define WINDOWS
#include <sys/socket.h>
#endif
#include "errors.h"
#include "database.h"
#include "rpcsrv.h"

time_t RPCtimestamp;
int ControlNet = 0;  // Kluge this for now
int WaitForWEP = -1;
int AcquireNetGlobalsOnStartup = 0;
void OutputToDebugFile(char far *routine, char far *txt);
char szDebugFile[82];
int getNextLinkID(void);
short OpenLink(HWND hWnd,char far *devName,char far *devprop,
               DBLK far *dout,DBLK far *din,void far *datain,
	       short access,long timer,short mode);
short ExecLinkEx(char far *devname,char far *devprop,
                 DBLK far *dout,void far *dataout,DBLK far *din,void far *datain,
                 short access,long timeout);
short ExecLink(char far *devname,char far *devprop,
               DBLK far *dout,void far *dataout,DBLK far *din,
               void far *datain,short access);

BYTE rpc_socket[2] = {RPC_SOCKET,RPC_SOCKET};
const BYTE brdcst_socket[2] = {BRDCST_SOCKET,BRDCST_SOCKET};
BYTE reg_socket[2] = {REG_SOCKET,REG_SOCKET};
const BYTE mcast_socket[2] = {MCAST_SOCKET,MCAST_SOCKET};
HANDLE hDLL,hDLLWnd;
int nUDPsets;
struct fd_set conset;
int TimeLeft = 0;
WORD SPXsocket;
WORD ASYsocket,CNSsocket;
WORD PnPsocket;
int SyncSocket = 0;
int MCastConsumerSocket = 0;
int ListenForMCasts = TRUE;
int ListenForIPXGlobals =  FALSE;
DWORD IPXTaskID,SPXTaskID;
HANDLE hWorkArea = hNULL;
HANDLE hWinsockLib = hNULL;
HANDLE hSpxipxLib = hNULL;
BYTE far *WorkArea;
unsigned long WorkAreaSize = WORK_SIZE;
SPXECB far *rcvECB[NUM_RCV_ECB];
SPXECB far *sndECB;
SPXECB far *conECB;
IPXECB far *cnsECB[NUM_CNS_ECB];
IPXECB far *glbECB[NUM_GLB_ECB];
IPXECB far *PCECB;
IPXECB far *asyECB;
IPXECB far *pnpECB;
IPXECB far *mcstECB[NUM_MCST_ECB];
HANDLE hSPXIPXMemPool = hNULL;
BYTE far *SPXIPXMemPool = NULL;
int ConsumerSocket = 0;
int GlobalSocket = 0;
struct sockaddr_in prod_name;

BrdcstListStruct far *BrdcstList;
HANDLE hBrdcstList;
int nglobals;

// ESR Function pointers:
FARPROC lpfnIncomingUDP,lpfnIncomingIPX,
        lpfnIncomingGlobalIPX,lpfnIncomingIPXMCast;

//-----------> make this dynamic !!!!
linkType link [MAXHOTLINKS];

extern int debug;
int initialized = 0, DBinitialized = 0,numLinks = 1;
int TimerID=1;
char username[17];
char myipaddr[17];
#ifdef NOVELL
NWCONN_NUM userConnNr;
NWCONN_HANDLE hConn;
#endif
extern void soperror(char far *txt);

int loadBroadcastDBase(void);
int getNextLinkID();
int checkNet(char *myipaddr);

int noclientlog = TRUE;
char logbuf[256];
int clnlog(char far *text)
{
  int hfp,cc=0,len;
  FILE far *fp = NULL;
  static time_t interimtime;

  if (noclientlog) return 0;
  if (text == NULL || (len=_fstrlen(text)) == 0) return 0;
  if (text[len-1] == '\n') text[len-1] = 0;
  if ((hfp=sopen("c:\\database\\client.log",O_RDWR|O_TEXT|O_APPEND,SH_DENYNO,S_IREAD|S_IWRITE)) == -1)
    ccerr(file_error);
  if ((fp=fdopen(hfp,"a+t")) == NULL) ccerr(file_error);

  _fstrcpy(logbuf,text);
  _fstrcat(logbuf," ");
  time(&interimtime);
  _fstrcat(logbuf,(char far *)ctime(&interimtime));

  fwrite(logbuf,_fstrlen(logbuf),1,fp);

err:
  if (fp) fclose(fp);
  return cc;
}

FILE far *fpDebugFile = NULL;
#define BUFLEN 2304
char txtbuffer[BUFLEN+26]; // make sure the last ctime() fits
void output(char far *txt)
{
  static int RectInitialized = 0;
  static HANDLE hDC;
  static RECT Rect;
  static linesout = 0;
  int len;
  static time_t t;
  char far *c;

  if (!IsWindowVisible(hDLLWnd)) return;
  if ((len=_fstrlen(txt)) == 0) return;
  while (_fstrlen(txtbuffer) + len > BUFLEN || linesout > 30)
  {
    if ((c=_fstrchr(txtbuffer,'\n')) == NULL) return;
    _fstrcpy(txtbuffer,++c);
    linesout--;
  }
  strcat(txtbuffer,txt);
  if (!RectInitialized)
  {
    RectInitialized = 1;
    hDC = GetDC(hDLLWnd);
    GetClientRect(hDLLWnd, (LPRECT) &Rect);
    FillRect(hDC,&Rect,GetStockObject(WHITE_BRUSH));
  }
  if (txtbuffer[(len=_fstrlen(txtbuffer)-1)] != '\n') return;
  linesout++; time(&t);
  wsprintf(&txtbuffer[len]," %s",ctime(&t));
  FillRect(hDC,&Rect,GetStockObject(WHITE_BRUSH));
  DrawText(hDC,txtbuffer,-1,&Rect,DT_LEFT);
  if (debug > 2)
  {
    OutputToDebugFile("output",txt);
  }
}
// WSA cover routines :
int loaded(void)
{
  static WSADATA wsaData;
  static int WSAinitialized = -1;

  if ((hWinsockLib=LoadLibrary("winsock.dll")) == hNULL) output("Can't load winsock\n");
  if (WSAinitialized == -1) WSAinitialized = WSAStartup(0x0101,&wsaData) ? 0 : 1;
  if (WSAinitialized ==  0 && debug) soperror("WSAStartup");
  return WSAinitialized;
}
int GetErrno(void) { return WSAGetLastError();}
int soioctl(int s,long cmd,char far *mode)
{
  return ioctlsocket(s,cmd,(u_long far *)mode);
}
int soclose(int s)
{
  int cc;
  cc = closesocket(s);
  if (cc) clnlog("closesocket error");
  return cc;
}
int TCPGetResource(void)
{
  int cc;
  static WSADATA wsaData;
  if ((cc=WSAStartup(0x0101,&wsaData)) != 0 && debug) soperror("WSAStartup");
  return cc;
}
int TCPFreeResource(void)
{
  int cc;
  if ((cc=WSACleanup()) != 0 && debug) soperror("WSACleanup");
  return cc;
}
void GetDebugFilePath(void)
{
  char far *ptr;
  if      ((ptr=getenv("RPCDEBUGFILE")) != NULL) _fstrncpy(szDebugFile,ptr,80);
  else if ((ptr=getenv("TEMP")) != NULL)
  {
    _fstrncpy(szDebugFile,ptr,68);
    _fstrcat(szDebugFile,"\\rpcdbg.txt");
  }
  else _fstrcpy(szDebugFile,"C:\\rpcdbg.txt");
}
DWORD getmyipaddr(void)
{
  static char hname[30];
  static LPHOSTENT hent;
  static SOCKADDR_IN stlclAddr;
  static SOCKADDR_IN strmtAddr;
  SOCKET hSock;
  int nRet=sizeof(SOCKADDR);

  stlclAddr.sin_addr.s_addr = INADDR_ANY;
  if (gethostname(hname,30) != SOCKET_ERROR)
  {
    if ((hent=gethostbyname((LPSTR)hname)) != NULL)
    {
      stlclAddr.sin_addr.s_addr = *((u_long FAR *)(hent->h_addr));
    }
  }
  if (stlclAddr.sin_addr.s_addr == INADDR_ANY)
  {
    if ((hSock=socket(AF_INET, SOCK_DGRAM, 0)) != INVALID_SOCKET)
    {
      strmtAddr.sin_family = AF_INET;
      strmtAddr.sin_port = htons(IPPORT_ECHO);
      strmtAddr.sin_addr.s_addr = inet_addr("128.127.50.1");
      if (connect(hSock,(LPSOCKADDR)&strmtAddr,sizeof(SOCKADDR)) != SOCKET_ERROR)
      {
        getsockname(hSock,(LPSOCKADDR)&stlclAddr,&nRet);
      }
      closesocket(hSock);
    }
  }
  return stlclAddr.sin_addr.s_addr;
}
HANDLE hStructList = hNULL;
struct structStruct far *structList = NULL;
struct structStruct far *getStructFromTag(char far *tag)
{
  HANDLE hS;
  struct structStruct far *s;

  if (tag == NULL || _fstrlen(tag) == 0) return NULL;
  for (hS=hStructList; hS; hS=s->hNext)
  {
    s = (struct structStruct far *)DeReference(hS);
    if (!_fstrncmp(s->name,tag,8)) break;
  }
  if (s && (s->rawlen == 0 || s->size == 0)) return NULL;
  return s;
}
struct structStruct far *findstruct(char far *tag)
{
  HANDLE hS;
  struct structStruct far *s;

  for (hS=hStructList; hS; hS=s->hNext)
  {
    s = (struct structStruct far *)DeReference(hS);
    if (!_fstrncmp(s->name,tag,8)) return s;
  }
  if ((hS=GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,sizeof(struct structStruct))) != hNULL)
  {
    s = (struct structStruct far *)DeReference(hS);
    _fstrncpy(s->name,tag,8);
    s->rawlen = 0;
    s->hNext = hStructList;
    hStructList = hS;
    return s;
  }
  return NULL;
}

char txtbuf[128];
#define soerr(s)  {_fstrcat(txtbuf,s); goto err;}
int matherr (struct exception far *a)
{
  switch( a->type)
  {
   case DOMAIN:
   case SING:
   case OVERFLOW:
   case UNDERFLOW:
   case TLOSS:
       a->retval = 0;
  }
  return 0;
}
void KillClientTimer(HWND hWnd)
{
  static int done = 0;
  if (done) return;
  done = 1;
  KillTimer(hWnd,1);
}
long FAR PASCAL _export EQPDLLWndProc(HWND hWnd, WORD iMessage, WORD wParam, LONG lParam)
{
  int cc=0;
  static int rcvSemaphore = 0;
  static int TimerSemaphore = 0, SyncSemaphore = 0;

  switch (iMessage)
  {
    case WM_INITAPPLICATION:
      return initApplication();
    case WM_RPCDEBUG:
      if (debug > 2) fpDebugFile=fopen(szDebugFile,"w");
      else
      {
        if (fpDebugFile) fclose(fpDebugFile);
        fpDebugFile = NULL;
      }
      break;
    case WM_LOCKLINK:    // lock the Mutex in this thread
      return 0;
    case WM_GETLINKID: return getNextLinkID();
    case WM_REMOVELINK:  // used with sychronous calls
      RemoveRPC(wParam);
      if (wParam == 0) SyncSemaphore = 0; // release semaphore
      break;
    case WM_CREATELINK:  // put entry into elem table
      if ((cc=CreateElem(wParam)) != 0) return cc;
      break;
    case WM_RCVPKT_UDP:        // WSA implementation
      FD_SET(ConsumerSocket,&conset);
      GetUDPData(ConsumerSocket);
      break;
    case WM_RCVPKT_UDPGLB:
      FD_SET(GlobalSocket,&conset);
      GetGlobalUDP();
      break;
    case WM_RCVPKT_UDPBCST:
      FD_SET(MCastConsumerSocket,&conset);
      GetUDPData(MCastConsumerSocket);
      break;
    case WM_RCVPKT:     // net IRQ callback
      if (rcvSemaphore) break;
      rcvSemaphore = 1;
      switch (wParam)
      {
         case IPX:
           switch ((int)lParam)
           {
             case 3: GetGlobalIPX(); break;
             case 4: GetIPXData(NUM_CNS_ECB,cnsECB); break;
             case 5: GetIPXData(NUM_MCST_ECB,mcstECB); break;
             default: break;
           }
           break;
         case UDP:
           GetUDPData(ConsumerSocket);
           break;
         default :
           rcvSemaphore = 0;
           return DefWindowProc (hWnd, iMessage, wParam, lParam);
      }
      rcvSemaphore = 0;
      break;
    case WM_TIMER:       // Stream-type hot-links and alarm checks
       if (TimerSemaphore) break;
       TimerSemaphore = 1;
       rcvSemaphore = 0;
       //DoRPC();
       CheckConnections();
       CheckSubscriptions();
       Cleanup();
       TimerSemaphore = 0;
       break;
    case WM_QUERYENDSESSION:
    case WM_ENDSESSION:
    case WM_QUIT:
    case WM_DESTROY:
       FreeApplication();
       KillClientTimer(hWnd);
    default:
       return DefWindowProc (hWnd, iMessage, wParam, lParam);
  }
  return NULL;
}
int CreateDLLWindow(void)
{
  static WNDCLASS wndclass;
  static char  lpszWN[] = "EQP16 Window";

  wndclass.style         = CS_GLOBALCLASS;  // essential style!!
  wndclass.lpfnWndProc   = (long FAR PASCAL (*)()) EQPDLLWndProc;
  wndclass.cbClsExtra    = 0;
  wndclass.cbWndExtra    = 0;
  wndclass.hInstance     = hDLL;
  wndclass.hIcon         = LoadIcon (hNULL, IDI_APPLICATION);
  wndclass.hCursor       = LoadCursor (hNULL, IDC_ARROW);
  wndclass.hbrBackground = GetStockObject (WHITE_BRUSH);
  wndclass.lpszMenuName  = hNULL;
  wndclass.lpszClassName = lpszWN;

  if (!RegisterClass(&wndclass)) return -1;

  if (!(hDLLWnd = CreateWindow (
           lpszWN, lpszWN,               // lpClassName, lpWindowName
           WS_OVERLAPPEDWINDOW,          // dwStyle
           CW_USEDEFAULT, CW_USEDEFAULT, // X, Y
           CW_USEDEFAULT, CW_USEDEFAULT, // nWidth, nHeight
           hNULL, hNULL,                 // hWndParent, hMenu
           hDLL,                         // hInstance
           (LPSTR)""                     // createstruct
    ) ) ) return -1;

  return 0;
}
#pragma argsused
int FAR PASCAL LibMain(HANDLE hInstance,WORD wDataSegment,WORD wHeapSize,LPSTR lpszCmdLine )
{
  HCURSOR OldCurs;
  unsigned int i;
  char far *ptr;
#ifdef NOVELL
  static CONNECT_INFO connInfo;
#endif
  hDLL = hInstance;
  if (wHeapSize != 0) UnlockData (0);
  GlobalCompact(-1);
  signal(SIGFPE,SIG_IGN);  // ignore domain errors if they occur

  if (CreateDLLWindow()) return 0;
  WaitCurs = LoadCursor(NULL,IDC_WAIT);
  if ((hSpxipxLib=LoadLibrary("nwipxspx.dll")) == hNULL) output("Can't load nwipxspx\n");

  for (i=1; i<MAXHOTLINKS; i++) link[i].active=0;

  if ((ptr=getenv("DEINIT")) != NULL) WaitForWEP = 0;

  if      ((ptr=getenv("CONTROLUSER")) != NULL) _fstrncpy(username,ptr,16);
  else if ((ptr=getenv("CONTROLNAME")) != NULL) _fstrncpy(username,ptr,16);
  else if ((ptr=getenv("OS")) != NULL && !_fstrcmp(ptr,"Windows_NT"))
  {
   if      ((ptr=getenv("LOGINAME")) != NULL) _fstrncpy(username,ptr,16);
   else if ((ptr=getenv("LOGINNAME")) != NULL) _fstrncpy(username,ptr,16);
   else _fstrcpy(username,"WIN16");
   username[16] = 0; _fstrupr(username);
  }
  else
  {
   if (NWGetDefaultConnectionID(&hConn) ||
      NWGetConnectionStatus(hConn,&connInfo,sizeof(connInfo)) )
   {
     MessageBox(hNULL, "Can't get Connection Information !","",IDOK);
     return 0;
   }
   userConnNr = connInfo.connNumber;
   _fstrncpy(username,connInfo.clientName,16);
  }

  OldCurs=SetCursor(WaitCurs);
  if ((i=SendMessage(hDLLWnd,WM_INITAPPLICATION,0,0)) != 0)
//  if ((i=initApplication()) != 0)
  {
    _fstrcpy(txtbuf,"init err: "); _fstrcat(txtbuf,erlst[i]);
    MessageBox(GetFocus(),txtbuf,"",IDOK);
  }
  GetDebugFilePath();

  SetCursor(OldCurs);
  return 1;
}
int initApplication(void)
{
  int cc = 0;
  if (initialized) return 0;
  if ((cc=AllocateAndAssignMemory()) != 0) return cc;
  if ((cc=initTCP()) != 0) MessageBox(GetFocus(),"TCP not loaded!","",IDOK);
  if ((cc=initSPX()) != 0) MessageBox(GetFocus(),"IPX not loaded!","",IDOK);
  if (!(DBinitialized=initDataBase() ? 0 : 1))
    MessageBox(GetFocus(),"Database not loaded!","",IDOK);
  initialized = 1;
  initNetGlobals();
  return cc;
}
void FreeApplication()
{
  int i;
  static int done = 0;

  if (done) return;
  if (!initialized) return;
  initialized=0; done = 1;
  RemoveRPC(-1);

  if (IPXloaded)
  {
    clnlog("de-init IPX");
    for (i=0; i<NUM_RCV_ECB; i++) IPXCancelEvent(SPXTaskID,(ECB far *)rcvECB[i]);
    IPXCloseSocket(SPXTaskID,rcvECB[0]->ecb.socketNumber);
    for (i=0; i<NUM_GLB_ECB; i++) IPXCancelEvent(IPXTaskID,(ECB far *)glbECB[i]);
    IPXCloseSocket(IPXTaskID,glbECB[0]->ecb.socketNumber);
    for (i=0; i<NUM_CNS_ECB; i++) IPXCancelEvent(IPXTaskID,(ECB far *)cnsECB[i]);
    IPXCloseSocket(IPXTaskID,cnsECB[0]->ecb.socketNumber);
    IPXCloseSocket(IPXTaskID,asyECB->ecb.socketNumber);
    IPXCloseSocket(IPXTaskID,pnpECB->ecb.socketNumber);
    if (ListenForMCasts) 
    {
      for (i=0; i<NUM_MCST_ECB; i++) IPXCancelEvent(IPXTaskID,(ECB far *)mcstECB[i]);
      IPXCloseSocket(IPXTaskID,mcstECB[0]->ecb.socketNumber);
    }
    IPXSPXDeinit(SPXTaskID);
    IPXSPXDeinit(IPXTaskID);
    FreeLibrary(hSpxipxLib);
  }
  if (DBinitialized)
  {
    GlobalFree(hRPCData); GlobalFree(hRPCFec);
  }
  for (i=0; i<nglobals; i++) GlobalFree(BrdcstList->hData);
  GlobalFree(hBrdcstList);

  if (TCPloaded)
  {
    clnlog("de-init IP");
    if (ConsumerSocket) soclose(ConsumerSocket);
    if (ListenForMCasts) soclose(MCastConsumerSocket);
    if (SyncSocket) soclose(SyncSocket);
    if (GlobalSocket) soclose(GlobalSocket);
//    while (!WSACleanup());
    WSACleanup();
    FreeLibrary(hWinsockLib);
  }

//  DestroyWindow (hDLLWnd);

  GlobalUnfix(hSPXIPXMemPool);
  GlobalFree(hSPXIPXMemPool);
  GlobalFree(hWorkArea);

  if (fpDebugFile) fclose(fpDebugFile);
}
// ==================================================
//       DLL initialization routines
// ==================================================
DataBaseElemsStruct BrdcstListElems[]={
  {"",sizeof(BrdcstListStruct),NULL},
  {"KEYWORD",STR,NULL},
  {"FORMAT",STR,NULL},
  {"SIZE",INT,NULL},
  {"PERIOD_MAX",INT,NULL},
  {""}
};
int AllocateAndAssignMemory(void)
{
  int i,cc=0,placeholder = 0;
  char far *ptr;

  lpfnIncomingIPX = (FARPROC)IncomingIPX;
  lpfnIncomingIPXMCast = (FARPROC)IncomingIPXMCast;
  lpfnIncomingGlobalIPX = (FARPROC)IncomingGlobalIPX;
  if (!(hSPXIPXMemPool=GlobalAlloc(GMEM_FIXED|GMEM_DDESHARE,SPXIPXMemPoolSize)))
    return out_of_client_memory;
  GlobalFix(hSPXIPXMemPool);
  SPXIPXMemPool = (BYTE far *)DeReference(hSPXIPXMemPool);

  for (i=0; i<NUM_RCV_ECB; i++)
  {
   rcvECB[i] = (SPXECB far *)&SPXIPXMemPool[placeholder];
   placeholder += sizeof(SPXECB);
  }
  sndECB = (SPXECB far *)&SPXIPXMemPool[placeholder];
  placeholder += sizeof(SPXECB);
  conECB = (SPXECB far *)&SPXIPXMemPool[placeholder];
  placeholder += sizeof(SPXECB);
  for (i=0; i<NUM_CNS_ECB; i++)
  {
    cnsECB[i] = (IPXECB far *)&SPXIPXMemPool[placeholder];
    placeholder += sizeof(IPXECB);
  }
  for (i=0; i<NUM_GLB_ECB; i++)
  {
    glbECB[i] = (IPXECB far *)&SPXIPXMemPool[placeholder];
    placeholder += sizeof(IPXECB);
  }
  for (i=0; i<NUM_MCST_ECB; i++)
  {
    mcstECB[i] = (IPXECB far *)&SPXIPXMemPool[placeholder];
    placeholder += sizeof(IPXECB);
  }
  PCECB = (IPXECB far *)&SPXIPXMemPool[placeholder];
  placeholder += sizeof(IPXECB);
  asyECB = (IPXECB far *)&SPXIPXMemPool[placeholder];
  placeholder += sizeof(IPXECB);
  pnpECB = (IPXECB far *)&SPXIPXMemPool[placeholder];
  placeholder += sizeof(IPXECB);

  if (!(hWorkArea=GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,WorkAreaSize)))
   return out_of_client_memory;

  ControlDBpath[0] = 0;
  if ((ptr=getenv("CONTROLDB")) != NULL) _fstrcpy(ControlDBpath,ptr);

//  if ((nglobals=loadBroadcastDBase()) < 0)
//  {
//    cc = -nglobals;
//    nglobals = 0;
//    return cc;
//  }
  _fstrcpy(BrdcstListElems[0].ColName,ControlDBpath);
  _fstrcat(BrdcstListElems[0].ColName,"NGLOBALS.CSV");
  if ((i=GetDataBaseSize(BrdcstListElems[0].ColName)) > 0)
  {
   if (!(hBrdcstList=GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,sizeof(BrdcstListStruct)*i)))
     ccerr(out_of_client_memory);
   BrdcstList=(BrdcstListStruct far *)DeReference(hBrdcstList);
   BrdcstListElems[1].offset = OFFSETIN(BrdcstListStruct,keyword);
   BrdcstListElems[2].offset = OFFSETIN(BrdcstListStruct,formatString);
//   BrdcstListElems[2].offset = OFFSETIN(BrdcstListStruct,format);
   BrdcstListElems[3].offset = OFFSETIN(BrdcstListStruct,size);
   BrdcstListElems[4].offset = OFFSETIN(BrdcstListStruct,heartbeat);
   for (i=1; i<5; i++) BrdcstListElems[i].handle = hBrdcstList;
   if ((nglobals=ReadDataBase(BrdcstListElems)) <= 0) nglobals = 0;
  }
  for (i=0; i<nglobals; i++)
  {
    _fstrupr(BrdcstList[i].formatString);
    BrdcstList[i].format = ftoi(BrdcstList[i].formatString);
    if ( !(BrdcstList[i].hData=GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE,
         BrdcstList[i].size*getFormatSize(BrdcstList[i].format))) )
    {
      nglobals = 0;
      ccerr(out_of_client_memory);
    }
   BrdcstList[i].brdcstTime = 0L;
  }

  if (!SetTimer(hDLLWnd,1,SYSTEM_DELAY,(FARPROC)NULL))
  {
   MessageBox(hNULL, "Can't set Timer !","",IDOK);
   ccerr(out_of_client_memory);
  }
err: return cc;
}
#define outerr(txt) { _fstrcpy(buf,txt); goto err; }
int initSPX(void)
{
# ifndef WINNT
  static WORD maxCon,availCon;
  static BYTE major,minor;
# endif
  static WORD IPXsocket;
  char buf[48];
  int i,cc;

  IPXTaskID = SPXTaskID = 0xFFFFFFFFL;
  if ((cc=IPXInitialize(&IPXTaskID,NUM_CNS_ECB+NUM_GLB_ECB+1,sizeof(IPXECB))) != 0)
   outerr("IPXInitialize");
# ifndef WINNT
  if ((cc=SPXInitialize(&SPXTaskID,NUM_RCV_ECB+2,sizeof(SPXECB),
            &major,&minor,&maxCon,&availCon)) != 0)
   outerr("SPXInitialize");
# else
  SPXTaskID = IPXTaskID;
# endif

  IPXsocket = 0;
  if ((cc=IPXOpenSocket(SPXTaskID,&IPXsocket,(BYTE)0)) != 0)
   outerr("IPXOpenSocket (RCV)");

  for (i=0; i<NUM_RCV_ECB; i++)          /* create sequenced packet ECBs */
  {
   initSPXECB(rcvECB[i],IPXsocket);
   SPXListenForSequencedPacket(SPXTaskID,(ECB far *)rcvECB[i]);
  }
  initSPXECB(sndECB,IPXsocket);
  initSPXECB(conECB,IPXsocket);
  SPXsocket = IPXsocket;

  IPXsocket = 0;
  if ((cc=IPXOpenSocket(IPXTaskID,&IPXsocket,0)) != 0)
   outerr("IPXOpenSocket (CNS)");
  for (i=0; i<NUM_CNS_ECB; i++)
  {
   initIPXECB(cnsECB[i],IPXsocket);
   cnsECB[i]->ecb.ESRAddress=(void (far *)())lpfnIncomingIPX;
   IPXListenForPacket(IPXTaskID,(ECB far *)cnsECB[i]);
  }
  initIPXECB(PCECB,IPXsocket);
  CNSsocket = IPXsocket;

  IPXsocket = 0;
  if ((cc=IPXOpenSocket(IPXTaskID,&IPXsocket,0)) != 0)
   outerr("IPXOpenSocket (ASY)");
  initIPXECB(asyECB,IPXsocket);
  ASYsocket = IPXsocket;

  IPXsocket = 0;
  if ((cc=IPXOpenSocket(IPXTaskID,&IPXsocket,0)) != 0)
   outerr("IPXOpenSocket (PNP)");
  initIPXECB(pnpECB,IPXsocket);
  PnPsocket = IPXsocket;
  if (ListenForIPXGlobals)
  {
    IPXsocket = *(WORD far *)brdcst_socket;
    if ((cc=IPXOpenSocket(IPXTaskID,&IPXsocket,0)) != 0 && cc != 0xff)
     outerr("IPXOpenSocket (GLB)");
    for (i=0; i<NUM_GLB_ECB; i++)
    {
     initIPXECB(glbECB[i],IPXsocket);
     glbECB[i]->ecb.ESRAddress=(void (far *)())lpfnIncomingGlobalIPX;
     IPXListenForPacket(IPXTaskID,(ECB far *)glbECB[i]);
    }
  }
  if (ListenForMCasts)           /* if FEC needs to listen for mcasts */
  {
    IPXsocket = *(WORD far *)mcast_socket;
    if ((cc=IPXOpenSocket(IPXTaskID,&IPXsocket,0)) != 0 && cc != 0xff)
      outerr("IPXOpenSocket (MCST)");
    for (i=0; i<NUM_MCST_ECB; i++)
    {
      initIPXECB(mcstECB[i],IPXsocket);
      mcstECB[i]->ecb.ESRAddress=(void (far *)())lpfnIncomingIPXMCast;
      IPXListenForPacket(IPXTaskID,(ECB far *)mcstECB[i]);
    }
  }
  IPXloaded = 1;
  return 0;
err:
  IPXCloseSocket(SPXTaskID,rcvECB[0]->ecb.socketNumber);
  IPXCloseSocket(IPXTaskID,*(WORD far *)brdcst_socket);
  IPXCloseSocket(IPXTaskID,cnsECB[0]->ecb.socketNumber);
  IPXCloseSocket(IPXTaskID,asyECB->ecb.socketNumber);
  IPXCloseSocket(IPXTaskID,mcstECB[0]->ecb.socketNumber);
  IPXSPXDeinit(SPXTaskID);
  IPXSPXDeinit(IPXTaskID);
  wsprintf(txtbuf,"%s: %d (%x)",buf,cc,cc);
  MessageBox(hNULL,txtbuf,"",IDOK);
  return ipx_socket_error;
}
char *HERAeqm = GLOBALSRC;
int AcquireNetGlobal(int i)
{
  int cc;
  BYTE far *data;

  data = (BYTE far *)DeReference(BrdcstList[i].hData);
  cc = RPC(HERAeqm,1,BrdcstList[i].keyword,BrdcstList[i].size,
         data,BrdcstList[i].size*getFormatSize(BrdcstList[i].format),
         BrdcstList[i].format);
  BrdcstList[i].brdcstTime = time(NULL);
  return cc;
}
void initNetGlobals(void)
{
  int i;

  if (AcquireNetGlobalsOnStartup) for (i=0; i<nglobals; i++) AcquireNetGlobal(i);
  return;
}
int initTCP(void)
{
  char far *ptr;

  if ((ptr=getenv("TCP")) != NULL || (ptr=getenv("FTP")) != NULL)
  {
    if (!_fstrcmp(ptr,"NONE"))
    {
      debug = 0;
      ListenForIPXGlobals = TRUE;
      return 0;
    }
  }
  _fstrcpy(txtbuf,"UDP: ");
  if (!loaded()) soerr("loaded");
  if (listenUDP(&ConsumerSocket,0)) soerr("listenUDP");
  if (WSAAsyncSelect(ConsumerSocket,hDLLWnd,WM_RCVPKT_UDP,FD_READ))
    soerr("select");
  if (listenUDP(&SyncSocket,0)) soerr("listenUDP");
  if (listenUDP(&GlobalSocket,GCAST_PORT))
  {
    ListenForIPXGlobals = TRUE;
    soerr("UDP GLOBALS");
  }
  else
  {
    if (WSAAsyncSelect(GlobalSocket,hDLLWnd,WM_RCVPKT_UDPGLB,FD_READ))
      soerr("select");
  }

  if (ListenForMCasts)
  {
    if (listenUDP(&MCastConsumerSocket,MCAST_PORT))
    {
      ListenForMCasts = 0; soerr("UDP MCAST socket");
    }
    else
    {
      if (WSAAsyncSelect(MCastConsumerSocket,hDLLWnd,WM_RCVPKT_UDPBCST,FD_READ))
        soerr("select");
    }
  }
  TCPloaded = 1;

  return 0;
err: soperror(txtbuf);
  MessageBox(GetFocus(),txtbuf,"",IDOK);
  return -1;
}

#ifndef UDP_CLN_PORT
# define UDP_CLN_PORT 8050
#endif
#ifndef UDP_CLN_RANGE
# define UDP_CLN_RANGE 400
#endif

int listenUDP(int far *s,unsigned short port)
{
  static struct sockaddr_in sck_name;
  static int optval = 1, optlen = 2;
  static UINT32 mode = 1;
  unsigned short udpport;
  static unsigned short nextFreePort = UDP_CLN_PORT;

  _fstrcpy(txtbuf,"UDP: ");
  if ((*s=socket(PF_INET,SOCK_DGRAM,0)) == INVALID_SOCKET) soerr("socket");
  if (port != 0)
  {
    if (setsockopt(*s,SOL_SOCKET,SO_REUSEADDR,(char far *)&optval,optlen))
      soerr("REUSEADDR");
  }
  _fmemset(&sck_name,0,sizeof(sck_name));
  sck_name.sin_addr.s_addr = 0;
  sck_name.sin_family = AF_INET;
  udpport = port ? port : nextFreePort;
//  udpport = port;
  if (udpport == 0) goto portbound;
bindport:
  sck_name.sin_port = htons(udpport);
  if (bind(*s,(struct sockaddr far *)&sck_name,sizeof(sck_name)))
  {
    if (port == 0 && udpport++ < UDP_CLN_PORT + UDP_CLN_RANGE) goto bindport;
    soerr("bind");
  }
  if (port == 0) nextFreePort = udpport + 1;
portbound:
  if (soioctl(*s,FIONBIO,(char far *)&mode)) soerr("NONBLOCKING");

  return 0;
err: soperror(txtbuf);
  soclose(*s);
  return -1;
}

// ====================================================
//       DLL export routines:
// ====================================================
int FAR PASCAL _export GETUSER(char far *name)
{
  _fstrcpy(name,username);
  return 0;
}

int FAR PASCAL _export LOADDLL(void) { return RPCNumRecsRead; }
int FAR PASCAL _export EQPDEINIT(void)
{
  if (WaitForWEP) return 0;
  SendMessage(hDLLWnd,WM_QUIT,0,0);
  DestroyWindow (hDLLWnd);
  return 0;
}

void FAR PASCAL _export CLNDEINIT(void)
{
  static int done = 0;
  if (done) return; else done = 1;
  SendMessage(hDLLWnd,WM_QUIT,0,0);
  DestroyWindow (hDLLWnd);
}
#pragma argsused
int FAR PASCAL _export WEP (int bSystemExit)
{
  CLNDEINIT();
  return 0;
}

int FAR PASCAL _export RPC(char far *name, int EqNo, char far *prop,
        int size, void far *data, int datasize, int format)
{
  return syncAsyncRPC(name,EqNo,prop,size,data,datasize,format,3000);
}
int FAR PASCAL _export S_RPC(char far *name, int EqNo, char far *prop,
        int size, void far *data, int datasize, int format)
{
  return syncAsyncRPC(name,EqNo,prop,size,data,datasize,format,RPC_TIMEOUT);
}
int FAR PASCAL _export A_RPC (HWND hVBWnd, char far *name, int EqNo, char far *prop,
        int size, int format)
{
  return Subscribe(hVBWnd,hNULL,name,EqNo,prop,0L,size,format,CM_SINGLE);
}
int FAR PASCAL _export SA_RPC (char far *name, int EqNo, char far *prop,
        int size, void far *data, int datasize, int format)
{
  return syncAsyncRPC(name,EqNo,prop,size,data,datasize,format,RPC_TIMEOUT);
}

int FAR PASCAL _export SUBSCRIBE (HWND hVBWnd, char far *name, int EqNo,
          char far *prop, long timer, int size, int format,int mode)
{
  return Subscribe(hVBWnd,hNULL,name,EqNo,prop,timer,size,format,mode);
}

int FAR PASCAL _export LINKDATA (HWND hVBWnd, char far *name, int EqNo,
          char far *prop, long timer, int size, int format,int mode)
{
  return Subscribe(hNULL,hVBWnd,name,EqNo,prop,timer,size,format,mode);
}

int FAR PASCAL _export HOTRPC (HWND hVBWnd, char far *name, int EqNo,
          char far *prop, long timer, int size, int format)
{
  return Subscribe(hVBWnd,hNULL,name,EqNo,prop,timer,size,format,CM_POLL);
}
int FAR PASCAL _export RPCGETLASTERR(char far *errstr)
{
  if (errstr == NULL) return argument_list_error;
  if (IsBadWritePtr(errstr,PREFIX+RPCERR_SIZE)) return buffer_too_small;
  _fstrncpy(errstr,RPCLastErrorString,PREFIX+RPCERR_SIZE);
  return 0;
}
int FAR PASCAL _export GETGLOBAL(char far *keyword, void far *VBbuf, int size, int format)
{
  int cc = 0,i,j,fmtsize;
  char far *data;

  for (i=0; i<nglobals; i++)
  {
   if (!_fstricmp(keyword,BrdcstList[i].keyword))
   {
     if (time(NULL) > BrdcstList[i].brdcstTime + BrdcstList[i].heartbeat*2)
      return not_running; // raise alarm
     data = GlobalLock(BrdcstList[i].hData);
     if (format == BrdcstList[i].format)
     {
       if (size < 1 || size > BrdcstList[i].size) ccerr(dimension_error);
       fmtsize = getFormatSize(format);
       _fmemcpy(VBbuf,data,size*fmtsize);
     }
     else if (format == CF_FLOAT)
     {
       if (size < 1 || size > BrdcstList[i].size) ccerr(dimension_error);
       switch (BrdcstList[i].format)
       {
         case CF_SHORT:
           for (j=0; j<size; j++) ((float far *)VBbuf)[j] = ((short far *)data)[j];
           break;
         case CF_LONG:
           for (j=0; j<size; j++) ((float far *)VBbuf)[j] = ((long far *)data)[j];
           break;
         case CF_DOUBLE:
           for (j=0; j<size; j++) ((float far *)VBbuf)[j] = ((double far *)data)[j];
           break;
         default:
           cc = illegal_format; break;
       }
     }
     else if (format == CF_TEXT)
     {
       if (size < 1) ccerr(dimension_error);
       switch (BrdcstList[i].format)
       {
         case CF_NAME16:
           if (size > 16) size = 16;
           _fstrncpy((char far *)VBbuf,(char far *)data,size);
           break;
         case CF_NAME32:
           if (size > 32) size = 32;
           _fstrncpy((char far *)VBbuf,(char far *)data,size);
           break;
         case CF_NAME8:
           if (size > 8) size = 8;
           _fstrncpy((char far *)VBbuf,(char far *)data,size);
           break;
         default:
           cc = illegal_format; break;
       }
     }
     else
     {
       cc = illegal_format;
     }
err:
     GlobalUnlock(BrdcstList[i].hData);
     return cc;
   }
  }
  return non_existent;
}

int FAR PASCAL _export PUTRPC (int i, void far *VBbuf)
{
  ElemDataStruct far *e;
  HANDLE hElem;
  void far *buf;

  if (VBbuf == NULL) return illegal_delimiter;
  if (i > MAXHOTLINKS || i < 0) return argument_list_error;
  if (!link[i].active) return ask_error;
  hElem = link[i].hElem;
  if (hElem == NULL) return un_allocated;       // invalid elem handle?
  e = (ElemDataStruct far *)DeReference(hElem);

  buf = (void far *)DeReference(e->hDataIn);
  _fmemcpy(buf,VBbuf,(size_t)e->sizeIn*fmtsizeof(e->formatIn));

  return 0;                                             // success
}
int FAR PASCAL _export GETRPCDATAEx(int i, void far *VBbuf,time_t far *timestamp,long far *datasize)
{
  short flg,rc,cc=0;
  ElemDataStruct far *e;
  HANDLE hElem;
  void far *buf;
  UINT16 dsize;

  if (VBbuf == NULL) ccerr(buffer_too_small);
  if (i > MAXHOTLINKS || i < 0) ccerr(argument_list_error);
  if (!link[i].active) ccerr(ask_error);
  hElem = link[i].hElem;
  if (hElem == NULL) ccerr(un_allocated);       // invalid elem handle?
  e = (ElemDataStruct far *)DeReference(hElem);
  if (e->mode <= CM_SINGLE && e->lockCount <= 0) ccerr(device_not_connected);
  if (timestamp != NULL) *timestamp = e->RPCtimestamp;
  dsize = e->sizeOut*fmtsizeof(e->formatOut);
  if (e->formatOut == CF_SPECTRUM) dsize += 96;
  if ((flg=link[i].dataFlg) > 0 && (flg & CE_SENDDATA)) flg = -1; // return code with data
  switch (flg)
  {
    case -not_posted:
      if (VBbuf && dsize) _fmemset(VBbuf,0,dsize);
      rc = -1;
      break;
    case  0:
    case -1:
      cc = (e->CompCode & 0x0fff);   // no new data -> use current error code
      buf = (void far *)DeReference(e->hDataOut);
      _fmemcpy(VBbuf,buf,(size_t)dsize);
      flg = 0; // read or not read -> let this be success
      if (datasize != NULL) *datasize = (long)e->lastDataSize;
	  default:
      if (e->mode <= SINGLE) e->lockCount--;
      link[i].dataFlg = 0;   // mark link as read
      rc = e->CompCode;
      break;
  }
err:
  if (cc) rc = cc;
  return rc;
}
int FAR PASCAL _export GETRPCDATA(int i, void far *VBbuf,time_t far *timestamp)
{
  return GETRPCDATAEx(i,VBbuf,timestamp,NULL);
}
int FAR PASCAL _export GETRPC (int i, void far *VBbuf)
{
  return GETRPCDATA(i,VBbuf,NULL);
}
int FAR PASCAL _export CLOSERPC (HWND hVBWnd, int i)
{
  int rc = 0;

  if (i > MAXHOTLINKS || i < 1 || !link[i].active) return 1;
  if ( GetWindowWord(hVBWnd,GWW_HINSTANCE)
     == GetWindowWord (link[i].hVBWnd, GWW_HINSTANCE) )
  {
    RemoveRPC(i);
  }
  return rc;
}
int FAR PASCAL _export CLOSELINK (HWND hVBWnd, int i)
{
  int rc = 0;

  if (i > MAXHOTLINKS || i < 1 || !link[i].active) return 1;
  if ( GetWindowWord(hVBWnd,GWW_HINSTANCE)
     == GetWindowWord (link[i].hVBXWnd, GWW_HINSTANCE) )
  {
    RemoveRPC(i);
  }
  return rc;
}
int FAR PASCAL _export RPCERR(int errn, char far *errstr)
{
  int errno = errn & 0x0fff;
  if (errno < 0 || errno >= numErr)
  {
   _fstrcpy(errstr,"Error Not Defined");
   return -1;
  }
  if (_fstrlen(erlst[errno]) > 80) return -2;
  _fstrcpy(errstr,erlst[errno]);
  return 0;
}
int FAR PASCAL _export RPCDBG(int dbg)
{
//  return 0;  // wsprintf doesn't work due to some memory model nonsense
  if (dbg >= 0) debug = dbg;
  ShowWindow(hDLLWnd,debug ? SW_SHOW : SW_HIDE);
  return debug;
}
int FAR PASCAL _export FILLSTRUCT (char far *tag, short addr, short size, short fmt)
{
  struct structStruct far *s;
  if ((s=findstruct(tag)) == NULL) return out_of_local_memory;
  if (fmt == CF_NULL)
  {
    s->num = size;
    s->size = addr;
    s->rawlen = s->size;
    return 0;
  }
  return illegal_format;
}
long FAR PASCAL _export GETSTRUCTSIZE (char far *tag)
{
  struct structStruct far *s=getStructFromTag(tag);
  return s == NULL ? 0 : (long) s->size;
}
int FAR PASCAL _export OPENLINK (HWND hWnd, char far *devName,char far *devProperty,
                                 DBLK far *dout,DBLK far *din,void far *datain,
	                         short access,long timer,short mode)
{
  return OpenLink(hWnd,devName,devProperty,dout,din,datain,access,timer,mode);
}

int FAR PASCAL _export EXECLINK (char far *devname,char far *devprop,DBLK far *dout,void far *dataout,DBLK far *din,void far *datain,short access)
{
  return ExecLinkEx(devname,devprop,dout,dataout,din,datain,access,RPC_TIMEOUT*1000);
}
int FAR PASCAL _export EXECLINKEx (char far *devname,char far *devprop,DBLK far *dout,void far *dataout,DBLK far *din,void far *datain,short access,long timeout)
{
  return ExecLinkEx(devname,devprop,dout,dataout,din,datain,access,timeout);
}
int FAR PASCAL _export PUTRPCDATA (int i, void far *VBbuf,int size,int format)
{
  ElemDataStruct far *e;
  HANDLE hElem;
  void far *buf;
  UINT16 dsize;
  HANDLE hNew;

  if (VBbuf == NULL) return illegal_delimiter;
  if (i > MAXHOTLINKS || i < 0) return invalid_index;
  if (!link[i].active) return ask_error;
  hElem = link[i].hElem;
  if (hElem == NULL) return un_allocated;       // invalid elem handle?
  e = (ElemDataStruct far *)DeReference(hElem);
  if ((dsize=size*fmtsizeof(format)) == 0) return argument_list_error;

  if (e->hDataIn == hNULL)
  {
    if ((e->hDataIn=GlobalAlloc(GMEM_MOVEABLE,dsize)) == hNULL)
      return out_of_client_memory;
  }
  else if (dsize > e->sizeIn*fmtsizeof(e->formatIn))
  {
    if ((hNew=GlobalReAlloc(e->hDataIn,dsize,GMEM_MOVEABLE)) == hNULL)
      return out_of_client_memory;
    e->hDataIn = hNew;
  }
  e->sizeIn = size;
  e->formatIn = format;
  buf = (void far *)DeReference(e->hDataIn);
  _fmemcpy(buf,VBbuf,(size_t)dsize);
  e->BytesTotal = dsize;
  e->BytesRemaining = dsize;
  e->numblksIn = dsize/e->datamtu + (dsize%e->datamtu ? 1 : 0);
  e->nextDataSize = MIN(e->datamtu,e->BytesTotal);

  return 0;                                             // success
}
