'==========================================================
'==                                                      ==
'==        Global constants of general use               ==
'==                                                      ==
'==========================================================

Global Const CF_TEXT2 = 1 ' this old idiocy will disappear
                          ' when there are no more pre-Release 3.0
                          ' programs
Global Const CF_DOUBLE = 512
Global Const CF_INTEGER = 513
Global Const CF_SHORT = 513
Global Const CF_BYTE = 514
Global Const CF_LONG = 515
Global Const CF_TEXT = 516
Global Const CF_FLOAT = 517
Global Const CF_POCALBLK = 518
Global Const CF_STRUCT = 519
Global Const CF_STRING8 = 520
Global Const CF_CHAR8 = 520
Global Const CF_NAME8 = 520
Global Const CF_CHAR16 = 521
Global Const CF_NAME16 = 521
Global Const CF_STRING16 = 521
Global Const CF_CHAR16FI = 522
Global Const CF_BIT = 523
Global Const CF_HITTS = 524
Global Const CF_STRING32 = 525
Global Const CF_NAME32 = 525
Global Const CF_CHAR32 = 525
Global Const CF_FI = 526
Global Const CF_FLTINT = 526
Global Const CF_II = 527
Global Const CF_INTINT = 527
Global Const CF_LI = 527
Global Const CF_LNGINT = 527
Global Const CF_DI = 528
Global Const CF_DBLINT = 528
Global Const CF_SI = 529
Global Const CF_SHTINT = 529
Global Const CF_TDS = 530
Global Const CF_STRING48 = 531
Global Const CF_NAME48 = 531
Global Const CF_CHAR48 = 531
Global Const CF_CHAR8I = 532
Global Const CF_NAME8I = 532
Global Const CF_CHAR16I = 533
Global Const CF_NAME16I = 533
Global Const CF_CHAR32I = 534
Global Const CF_NAME32I = 534
Global Const CF_CHAR48I = 535
Global Const CF_NAME48I = 535
Global Const CF_USTRING = 536
Global Const CF_XYS = 537
Global Const CF_FFI = 537
Global Const CF_FLTFLTINT = 537
Global Const CF_FII = 538
Global Const CF_FLTINTINT = 538
Global Const CF_FIS = 538
Global Const CF_FILTER = 539
Global Const CF_IFFF = 539
Global Const CF_INTFLTFLTFLT = 539
Global Const CF_SPECTRUM = 540
Global Const CF_ADDRESS = 541
Global Const CF_IIII = 541
Global Const CF_INTINTINTINT = 541
Global Const CF_WINDOW = 542
Global Const CF_TTII = 542
Global Const CF_POINT = 543
Global Const CF_FF = 543
Global Const CF_XY = 543
Global Const CF_FLTFLT = 543
Global Const CF_TDSI = 544
Global Const CF_INTFLTSHTSHT = 544
Global Const CF_BOOLEAN = 545
Global Const CF_IIFF = 546
Global Const CF_INTINTFLTFLT = 546
Global Const CF_FWINDOW = 546
Global Const CF_FIFI = 547
Global Const CF_FLTINTFLTINT = 547
Global Const CF_CHAR64 = 548
Global Const CF_NAME64 = 548
Global Const CF_CHAR64I = 549
Global Const CF_NAME64I = 549

Global Const CF_NULL = 767

Global Const CM_NULL = 0
Global Const CM_CANCEL = 0
Global Const CM_SINGLE = 1
Global Const CM_REFRESH = 2
Global Const CM_POLL = 3


Global Const CA_NULL = &H0
Global Const CA_READ = &H1
Global Const CA_WRITE = &H2
Global Const CA_ASYNC = &H4
Global Const CA_SYNC = &H8
Global Const CA_FIRST = &H40
Global Const CA_LAST = &H80

Type FSTRUCT
  date As Integer
  time As Integer
  name As String * 8
End Type

Type FLTINT
  fval As Single
  ival As Long
End Type

Type SHTINT
  sval As Integer
  ival As Long
End Type

Type DBLINT
  dval As Double
  ival As Long
End Type

Type NAME8
  nam As String * 8
End Type

Type NAME16
  nam As String * 16
End Type

Type NAME32
  nam As String * 32
End Type

Type NAME48
  nam As String * 48
End Type

Type NAME64
  nam As String * 64
End Type

Type PropertyQueryType
  prpName As String * 32
  prpDesc As String * 32
  prpSize As Integer
  prpFormat As String * 1
  prpAccess As String * 1
End Type

'==========================================================
'==                                                      ==
'==         network routines for data acquisition        ==
'==                                                      ==
'==========================================================
Type DBLK
  dArrayLength As Long
  dFormat As Integer
  reserved As Integer
  dTag As String * 8
End Type

Type RPCTEXT
  text As String * 80
End Type

Type RPCSTRING
  text As String * 256
End Type

Dim netuser As String * 16
Declare Function RPC Lib "tinecl16.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal datasize%, ByVal fmt%) As Integer
Declare Function EXECLINK Lib "tinecl16.dll" (ByVal devname$, ByVal devprop$, dout As DBLK, dataout As Any, din As DBLK, datain As Any, ByVal acc%) As Integer
Declare Function EXECLINKEx Lib "tinecl16.dll" (ByVal devname$, ByVal devprop$, dout As DBLK, dataout As Any, din As DBLK, datain As Any, ByVal acc%, ByVal timeout&) As Integer
Declare Function HOTRPC Lib "tinecl16.dll" (ByVal hWnd%, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal tim&, ByVal num%, ByVal fmt%) As Integer
Declare Function CLOSERPC Lib "tinecl16.dll" (ByVal hWnd%, ByVal ID%) As Integer
Declare Function CLOSELINK Lib "tinecl16.dll" (ByVal hWnd%, ByVal ID%) As Integer
Declare Function GETRPC Lib "tinecl16.dll" (ByVal ID%, dat As Any) As Integer
Declare Function GETRPCDATA Lib "tinecl16.dll" (ByVal ID%, dat As Any, ts&) As Integer
Declare Function GETRPCSTRDATA Lib "tinecl16.dll" Alias "GETRPCDATA" (ByVal ID%, ByVal dat As String, ts&) As Integer
Declare Function PUTRPC Lib "tinecl16.dll" (ByVal ID%, dat As Any) As Integer
Declare Function PUTRPCDATA Lib "tinecl16.dll" (ByVal ID%, dat As Any, ByVal siz%, ByVal fmt%) As Integer
Declare Function PUTRPCSTRDATA Lib "tinecl16.dll" Alias "PUTRPCDATA" (ByVal ID%, ByVal dat As String, ByVal siz%, ByVal fmt%) As Integer
Declare Function RPCERR Lib "tinecl16.dll" (ByVal errno%, ByVal errStr$) As Integer
Declare Function GETGLOBAL Lib "tinecl16.dll" (ByVal keyword$, dat As Any, ByVal size%, ByVal fmt%) As Integer
Declare Function GETUSER Lib "tinecl16.dll" (ByVal user$) As Integer
Declare Function SUBSCRIBE Lib "tinecl16.dll" (ByVal hWnd%, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal tim&, ByVal num%, ByVal fmt%, ByVal mode%) As Integer
Declare Function A_RPC Lib "tinecl16.dll" (ByVal hWnd%, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, ByVal fmt%) As Integer
Declare Function SA_RPC Lib "tinecl16.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal datasize%, ByVal fmt%) As Integer
Declare Function S_RPC Lib "tinecl16.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal datasize%, ByVal fmt%) As Integer
Declare Function OPENLINK Lib "tinecl16.dll" (ByVal hWnd%, ByVal devname$, ByVal devProperty$, dout As DBLK, din As DBLK, datain As Any, ByVal acc%, ByVal pollrate&, ByVal mode%) As Integer

' --------------------------------------------------------
' | to get the client username, you can also use the call:
' |
' |     user$ = username()
' |
' --------------------------------------------------------

' -----------------------------------------
' | Hot Link example (Asynchronous Call): |
' -----------------------------------------
'
' -----------------------------------------
' | 1). Register Link (e.g. in form_load) |
' -----------------------------------------
'      hotID% = HOTRPC(form1.hWnd, EQP$, EqNo%, prop$, 5000, 100, CF_INTEGER)
' OR:
'      hotID% = SUBSCRIBE(form1.hWnd, EQP$, EqNo%, prop$, 5000, 100, CF_INTEGER, CM_REFRESH)
'
' '    registers a Hot Link for:
' '       equipment function EQP$, equipment number EqNo%,
' '       property prop$, polling rate 5000 milliseconds,
' '       equipment size of 100 data elements,
' '       data element format CF_INTEGER
' '    SUBSCRIBE is a more general routine in that you can
' '       also specify the data acquisition mode:
' '       CM_SINGLE  - is a one-shot (i.e. COLD link)
' '                    asynchronous call
' '       CM_REFRESH - specifies a polling rate to the FEC
' '                    but receives data only when they have
' '                    changed (with a heartbeat of 60 sec)
' '                    good for status calls, etc.
' '       CM_POLL    - receives data at the given polling
' '                    rate.
' '       CM_CANCEL  - cancels the subscription
' '    HOTRPC   is identical to SUBSCRIBE with CM_POLL
' '    CLOSERPC is identical to SUBSCRIBE with CM_CANCEL
'
' -----------------------------------------
' | 2). In the paint routine of given form
' |     (here form1) include:
' -----------------------------------------
'
'      If hotID% > 0 Then
'        hotrc% = GETRPC(hotID%, dat%(0))
'        Select Case hotrc%
'          Case Is > 0: rpcerrbox.visible = True 'signal RPC error
'          Case 0: rpcerrbox.visible = False
'                  call updateData               'called when there are new data
'        End Select
'      End If
'
' '    retrieves the incoming data and puts them into array
' '    dat%(), beginning at dat%(0).  You must insure that
' '    dat%() is large enought to hold the amount of data
' '    you request
'
' --------------------------------------------------------
' | rpcerrbox is a picture box with a red RPC icon        |
' | when clicked you can give the most recent return code:|
' --------------------------------------------------------
'
'     rc% = RPCERR(hotrc%, errstr)
'     If rc% Then
'        MsgBox "RPC return code Not defined!"
'     Else
'        MsgBox "RPC error : " + RPCERROR(rc%)
'     End If
'
' ----------------------------------------
' | in form_unload() be sure to include: |
' ----------------------------------------
'
'    If CLOSERPC(form1.hWnd, hotID%) Then
'       msgbox"Error closing hot link!"
'    End If
'    End
'
'
' ----------------------------------------
' | Cold Link Example (Synchronous Call): |
' ----------------------------------------
'
'    rc% = RPC(EQP$, EqNo%, prop$, NPOINTS, dat%(0), 8 * NPOINTS, CF_DOUBLE)
'    If rc% Then
'      MsgBox EQP$ + " : " +RPCERROR(rc%)
'    Else
'      Call updataData
'    End If
'
'==========================================================
'==
'==              Net Globals
'==
'==========================================================

Global HPENERGY As Integer   'Hera Proton energy
Global HPCURRENT As Double   'Hera Proton Beam Current
Global HPTAU     As Double   'Hera Proton Beam Lifetime
Global HEENERGY As Integer   'Hera Electron energy
Global HECURRENT As Double   'Hera Electron Beam Current
Global HETAU     As Double   'Hera Electron Beam Lifetime

' The associated get routines are:
'     HERAGetEnergy(typ$)
'     HERAGetCurrent(typ$)
'     HERAGetLifetime(typ$)
' where typ$ is either "PROTON" or "ELECTRON"
' the above varables are then updated
'
' e.g. To get the current HERA Proton magnet energy:
'
'    rc% = HERAGetEnergy("PROTON")
'    If rc% Then
'      rc% = RPCERR(rc%, errstr)
'      MsgBox "RPC Error : " + errstr
'    Else
'      MsgBox "Then energy in HERA P is: " + str$(HPENERGY)
'    End If
'

'==========================================================
'==
'==              Server Routines
'==
'==========================================================

Declare Function Address Lib "tinesv16.dll" (r As Any) As Long
Declare Function CADDR Lib "tinesv16.dll" (r As Any) As Long
Declare Function CSTRADDR Lib "tinesv16.dll" Alias "CADDR" (ByVal r As String) As Long
Declare Function UTIME Lib "tinesv16.dll" () As Long
Declare Sub ASCTIME Lib "tinesv16.dll" (ByVal dat$, ByVal timestamp&)
Declare Function DebugServer Lib "tinesv16.dll" (ByVal level%) As Integer
Declare Function DebugLog Lib "tinesv16.dll" (ByVal level%) As Integer
Declare Function RegisterProperty Lib "tinesv16.dll" (ByVal eqm$, ByVal prop$, ByVal siz%, ByVal fmt%, ByVal acc%, ByVal desc$) As Integer
Declare Function RegisterPropertyEx Lib "tinesv16.dll" (ByVal eqm$, ByVal prop$, ByVal sizIn%, ByVal fmtIn%, ByVal tagIn$, ByVal sizOut%, ByVal fmtOut%, ByVal tagOut$, ByVal acc%, ByVal dsc$) As Integer
Declare Function RegisterModuleName Lib "tinesv16.dll" (ByVal eqm$, ByVal devname$, ByVal devnr%) As Integer
Declare Function GetDeviceNumber Lib "tinesv16.dll" (ByVal eqm$, ByVal devname$) As Integer
Declare Function GetModuleNumber Lib "tinesv16.dll" Alias "GetDeviceNumber" (ByVal eqm$, ByVal devname$) As Integer
Declare Sub GetDeviceName Lib "tinesv16.dll" (ByVal eqm$, ByVal devnum%, ByVal devname$)
Declare Sub GetModuleName Lib "tinesv16.dll" Alias "GetDeviceName" (ByVal eqm$, ByVal devnum%, ByVal devname$)
Declare Function GetPropertyId Lib "tinesv16.dll" (ByVal eqm$, ByVal prop$) As Integer
Declare Function RegisterSeverity Lib "tinesv16.dll" (ByVal almCode&, ByVal almSeverity%) As Integer
Declare Function SetAlarm Lib "tinesv16.dll" (ByVal eqm$, ByVal devnr%, ByVal almCode&, almData As Any) As Integer
Declare Sub ClearAlarm Lib "tinesv16.dll" (ByVal eqm$, ByVal devnr%)
Declare Function SetMinimumPollingRate Lib "tinesv16.dll" (ByVal mpr%) As Integer
Declare Sub SETRPCERROR Lib "tinesv16.dll" (ByVal errCode%, ByVal errStr$)
Declare Function FILLSRVSTRUCT Lib "tinesv16.dll" (ByVal tag$, ByVal addr%, ByVal size%, ByVal fmt%) As Integer
Declare Function RedirectProperty Lib "tinesv16.dll" (ByVal eqm$, ByVal prop$, ByVal rdr$) As Integer
Declare Function ScheduleProperty Lib "tinesv16.dll" (ByVal eqm$, ByVal prop$) As Integer
Declare Sub setSystemPresetMemory Lib "tinesv16.dll" (ByVal vboolean%)


' ================================
'   RPC Error Definitions
' ================================
Global Const success% = 0
Global Const illegal_line% = 1
Global Const illegal_format% = 2
Global Const illegal_arithmetic% = 3
Global Const ambiguous% = 4
Global Const illegal_delimiter% = 5
Global Const zero_divide% = 6
Global Const WA_full% = 7
Global Const non_existent% = 8
Global Const wrong_type% = 9
Global Const link_exhausted% = 10
Global Const not_properly% = 11
Global Const un_allocated% = 12
Global Const no_such_line% = 13
Global Const illegal_shuffle% = 14
Global Const if_error% = 15
Global Const escape_typed% = 16
Global Const ask_error% = 18
Global Const argument_list_error% = 20
Global Const file_error% = 21
Global Const use_stream_transport% = 22
Global Const dimension_error% = 23
Global Const square_root_negative% = 24
Global Const buffer_too_small% = 25
Global Const string_too_long% = 26
Global Const ipx_socket_error% = 27
Global Const net_read_error% = 28
Global Const not_ready% = 29
Global Const log_negative% = 31
Global Const device_not_connected% = 32
Global Const unauthorised_action% = 33
Global Const hardware_error% = 34
Global Const illegal_equipment_number% = 35
Global Const illegal_property% = 36
Global Const out_of_range% = 37
Global Const not_implemented% = 38
Global Const no_such_computer% = 39
Global Const string_filled% = 40
Global Const syntax_error% = 41
Global Const no_such_file% = 42
Global Const file_already_exists% = 43
Global Const no_file_space% = 44
Global Const link_not_open% = 45
Global Const remitted_data_lost% = 46
Global Const end_of_file% = 47
Global Const archive_busy% = 48
Global Const server_name_in_use% = 49
Global Const no_such_column% = 50
Global Const out_of_client_memory% = 51
Global Const def_area_full% = 52
Global Const def_syntax% = 53
Global Const illegal_string_set% = 54
Global Const serr1% = 54
Global Const string_function_failure% = 55
Global Const serr2% = 55
Global Const Sif_error% = 57
Global Const Sask_error% = 58
Global Const string_expected% = 59
Global Const out_of_local_memory% = 60
Global Const out_of_shared_memory% = 61
Global Const invalid_structure_tag% = 62
Global Const invalid_index% = 63
Global Const illegal_equipment_name% = 64
Global Const link_error% = 65
Global Const code_failure% = 66
Global Const bracket_missing% = 67
Global Const wrong_hexa% = 68
Global Const wrong_octal% = 69
Global Const illegal_character% = 70
Global Const illegal_operator% = 71
Global Const not_allowed% = 72
Global Const illegal_read_write% = 73
Global Const out_of_memory% = 74
Global Const out_of_server_memory% = 74
Global Const database_not_loaded% = 75
Global Const illegal_command% = 76
Global Const resources_exhausted% = 77
Global Const file_not_open% = 78
Global Const sedac_error% = 79
Global Const no_such_loop% = 80
Global Const driver_not_installed% = 82
Global Const port_not_available% = 83
Global Const scan_error% = 84
Global Const no_high_voltage% = 85
Global Const non_existent_elem% = 86
Global Const non_existent_fec% = 87
Global Const non_existent_client% = 88
Global Const cannot_lock% = 89
Global Const not_running% = 90
Global Const not_posted% = 91
Global Const not_accepted% = 92
Global Const operation_timeout% = 93
Global Const illegal_protocol% = 94
Global Const gpib_error% = 95
Global Const rs232_error% = 96
Global Const operation_busy% = 97
Global Const connection_timeout% = 98
Global Const illegal_mode% = 99
Global Const not_owner% = 100
Global Const not_defined% = 101
Global Const net_write_error% = 102
Global Const invalid_data% = 103
Global Const software_error% = 104
Global Const access_denied% = 105
Global Const tcp_not_supported% = 106
Global Const ipx_not_supported% = 107
Global Const host_not_resolved% = 108
Global Const tcp_connect_error% = 109
Global Const tcp_socket_error% = 110
Global Const fpss_error% = 111
Global Const fpss_timeout% = 112
Global Const fpss_overflow% = 113
Global Const pocal_error% = 114
Global Const max_alarms_exceeded% = 115
Global Const not_exported% = 116
Global Const is_switching% = 117
Global Const at_limit% = 118
Global Const get_subscription_id% = 119
Global Const renegotiate_contract% = 120
Global Const server_redirection% = 121

Global Const CE_SENDDATA = &H4000

Function colptr (s$, colstr$) As Integer
Dim ncommas As Integer
Dim pos As Long

ncommas = 0: tmpstr$ = s$
pos = InStr(tmpstr$, ",") - 1
If pos = -1 Then pos = Len(tmpstr$)
While (pos >= 0) And (Trim(UCase(Left$(tmpstr$, pos))) <> Trim(UCase(colstr$)))
  ncommas = ncommas + 1
  tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
  pos = InStr(tmpstr$, ",") - 1
  If pos = -1 Then pos = Len(tmpstr$)
Wend
colptr = ncommas
End Function

Function getcol (s$, col%) As String
Dim ncommas As Integer
Dim pos As Long

ncommas = 0: tmpstr$ = s$
pos = InStr(tmpstr$, ",") - 1
If pos = -1 Then pos = Len(tmpstr$)
While (pos >= 0) And (ncommas <> col%)
  ncommas = ncommas + 1
  tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
  pos = InStr(tmpstr$, ",") - 1
  If pos = -1 Then pos = Len(tmpstr$)
Wend
getcol = IIf(ncommas = col%, Left$(tmpstr$, pos), "")
End Function

Function GETCURRENT () As Double
Static er As String * 80
rc% = GETGLOBAL("HPCur", HPCURRENT, 1, CF_DOUBLE)
If rc% = 0 Then
  GETCURRENT = HPCURRENT
Else
  rc% = RPCERR(rc%, er$)
  MsgBox "GETCURRENT: " + er$
End If
End Function

Function GETENERGY () As Integer
Static er As String * 80
rc% = GETGLOBAL("HPENERGY", HPENERGY, 1, CF_INTEGER)
If rc% = 0 Then
  GETENERGY = HPENERGY
Else
  rc% = RPCERR(rc%, er$)
  MsgBox "GETENERGY: " + er$
End If
End Function

Function HERAGetCurrent (ByVal t$)
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPCur", HPCURRENT, 1, CF_DOUBLE)
       If HPCur < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HECur", HECURRENT, 1, CF_DOUBLE)
       If HECur < 0 Then rc% = 91 ' not_posted
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetCurrent = rc%
End Function

Function HERAGetEnergy (ByVal t$) As Integer
Static hemagen As Single
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPENERGY", HPENERGY, 1, CF_INTEGER)
       If HPENERGY < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HEMAGEN", hemagen, 1, CF_FLOAT)
       HEENERGY = CInt(hemagen)
       If HEENERGY < 0 Then rc% = 91
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetEnergy = rc%
End Function

Function HERAGetLifetime (ByVal t$)
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPtau", HPTAU, 1, CF_DOUBLE)
       If HPTAU < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HEtau", HETAU, 1, CF_DOUBLE)
       If HETAU < 0 Then rc% = 91 ' not_posted
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetLifetime = rc%
End Function

Function RPCERROR (ByVal rc%) As String
Static RPCErrorString As String * 80
If rc% = 0 Then
  RPCERROR = "Success"
Else
  If RPCERR(rc%, RPCErrorString) Then
    RPCERROR = "Error not defined"
  Else
    RPCERROR = RPCErrorString
  End If
End If
End Function

Function SendPMTrigger (subsys As String, cmt As String) As Integer
Dim devname$
Dim dbin As DBLK, dbout As DBLK
Dim rpccmt As RPCSTRING ' 256 character string
Dim triggerlevel%, pmtime&
' Input data (to send):
dbin.dArrayLength = 1
dbin.dFormat = CF_SHORT
triggerlevel% = 1 ' later user -1 to indicate a more critical trigger
' Output data (to receive):
dbout.dArrayLength = 1
dbout.dFormat = CF_LONG
' sub system to receive the trigger
devname$ = "STORAGE/" + LCase(subsys)
rc% = EXECLINK(devname$, "TRIGGER", dbout, pmtime&, dbin, triggerlevel%, CA_WRITE)
If rc% Then
  SendPMTrigger = rc%
  Exit Function
End If
' now send comment :
' append the assigned Post Mortem time to comment ...
cmt = cmt & " @" & Trim$(Str$(pmtime&))
' Input data (to send):
dbin.dArrayLength = Len(cmt)
dbin.dFormat = CF_TEXT
rpccmt.text = cmt
' Output data (to receive): NONE
dbout.dArrayLength = 0
dbout.dFormat = CF_NULL
rc% = EXECLINK(devname$, "ANNOTATE", dbout, 0, dbin, rpccmt, CA_WRITE)
If rc% Then
  SendPMTrigger = rc%
  Exit Function
End If
SendPMTrigger = 0
End Function

Function username () As String
cc% = GETUSER(netuser$)
username = Left$(netuser$, InStr(netuser$, Chr(0)) - 1)
End Function

