#ifndef _DATABASE_H_
#define _DATABASE_H_

#include "rpcdefs.h"

#define LOOPBACKADDR "127.0.0.1"

#define STR 0
#define INT 1
#define FLT 2
#define HEX 3

typedef struct
{
	char ColName[40];
	long Type;
	int offset;
	HANDLE handle;
}DataBaseElemsStruct;

typedef struct
{
  char os[12];
  char desc[64];
  char loc[32];
  char hdw[48];
  char resp[32];
} RPCFecExStruct;
extern RPCFecExStruct RPCFecEx;

extern char ControlDBpath[80];

int ReadDataBase(DataBaseElemsStruct *elems);
int SearchDataBase(DataBaseElemsStruct *elems,char *searchstr,char *colname);
int GetDataBaseProperties(char *properties,int size,char  *file);
int SearchDataBaseFromFile(char *filename,char *searchstr,char *colname,
						   char *datacol,int datacollen,char *data,int datalen);
int GetDataBaseSize(char *filename);
short reformatData(void *dst,short dstfmt,unsigned short dstsiz,void *src,short srcfmt,unsigned short srcsiz);

#endif // _DATABASE_H_

