Attribute VB_Name = "tine"
'==========================================================
'==                                                      ==
'==        Global constants of general use               ==
'==        Version 18.04.01,swh:  fill in struct types   ==
'==========================================================

Global Const CF_DOUBLE = 512
Global Const CF_INTEGER = 513
Global Const CF_SHORT = 513
Global Const CF_BYTE = 514
Global Const CF_LONG = 515
Global Const CF_TEXT = 516
Global Const CF_FLOAT = 517
Global Const CF_POCALBLK = 518
Global Const CF_STRUCT = 519
Global Const CF_CHAR8 = 520
Global Const CF_STRING8 = 520
Global Const CF_NAME8 = 520
Global Const CF_CHAR16 = 521
Global Const CF_STRING16 = 521
Global Const CF_NAME16 = 521
Global Const CF_CHAR16FI = 522
Global Const CF_BIT = 523
Global Const CF_HITTS = 524
Global Const CF_CHAR32 = 525
Global Const CF_STRING32 = 525
Global Const CF_NAME32 = 525
Global Const CF_FI = 526
Global Const CF_FLTINT = 526
Global Const CF_II = 527
Global Const CF_LI = 527
Global Const CF_LL = 527
Global Const CF_INTINT = 527
Global Const CF_LNGINT = 527
Global Const CF_DI = 528
Global Const CF_DBLINT = 528
Global Const CF_SI = 529
Global Const CF_SHTINT = 529
Global Const CF_TDS = 530
Global Const CF_IFI = 530
Global Const CF_CHAR48 = 531
Global Const CF_NAME48 = 531
Global Const CF_STRING48 = 531
Global Const CF_CHAR8I = 532
Global Const CF_NAME8I = 532
Global Const CF_CHAR16I = 533
Global Const CF_NAME16I = 533
Global Const CF_CHAR32I = 534
Global Const CF_NAME32I = 534
Global Const CF_CHAR48I = 535
Global Const CF_NAME48I = 535

Global Const CF_USTRING = 536
Global Const CF_XYS = 537
Global Const CF_FFI = 537
Global Const CF_FLTFLTINT = 537
Global Const CF_FLTINTINT = 538
Global Const CF_FILTER = 539
Global Const CF_IFFF = 539
Global Const CF_INTFLTFLTFLT = 539
Global Const CF_SPECTRUM = 540

Global Const CF_ADDRESS = 541
Global Const CF_IIII = 541
Global Const CF_INTINTINTINT = 541
Global Const CF_WINDOW = 542
Global Const CF_TTII = 542
Global Const CF_POINT = 543
Global Const CF_FF = 543
Global Const CF_XY = 543
Global Const CF_FLTFLT = 543
Global Const CF_TDSI = 544
Global Const CF_INTFLTSHTSHT = 544
Global Const CF_BOOLEAN = 545
Global Const CF_IIFF = 546
Global Const CF_INTINTFLTFLT = 546
Global Const CF_FIFI = 547
Global Const CF_FLTINTFLTINT = 547
Global Const CF_DEFAULT = 766
Global Const CF_NULL = 767

Global Const CM_CANCEL = 0
Global Const CM_SINGLE = 1
Global Const CM_REFRESH = 2
Global Const CM_POLL = 3
Global Const CM_REGISTER = 4

Type FLTINT
 fval As Single
 ival As Long
End Type

Type INTINT
 i1val As Long
 i2val As Long
End Type

Type SHTINT
 sval As Integer
 ival As Long
End Type

Type LNGINT
 lval As Long
 ival As Long
End Type

Type DBLINT
 dval As Double
 ival As Long
End Type

Type FLTFLTINT
  f1val As Single
  f2val As Single
  ival As Long
End Type

Type FLTINTINT
  fval As Single
  i1val As Long
  i2val As Long
End Type

Type INTINTINTINT
  i1val As Long
  i2val As Long
  i3val As Long
  i4val As Long
End Type

Type INTFLTFLTFLT
  ival As Long
  f1val As Single
  f2val As Single
  f3val As Single
End Type

Type INTINTFLTFLT
 i1val As Long
 i2val As Long
 f1val As Single
 f2val As Single
End Type

Type FLTINTFLTINT
 f1val As Single
 i1val As Long
 f2val As Single
 i2val As Long
End Type

Type NAME8
  nam(7) As Byte
End Type

Type NAME16
  nam(15) As Byte
End Type

Type NAME16I
  nam(15) As Byte
  ival As Long
End Type

Type NAME32
  nam(31) As Byte
End Type

Type NAME48
  nam(47) As Byte
End Type

Type NAME32I
  nam(31) As Byte
  ival As Long
End Type

Type NAME48I
  nam(47) As Byte
  ival As Long
End Type

Type NAMEFI
  nam(15) As Byte
  fval As Single
  ival As Long
End Type

Type NAME16FI
  nam(15) As Byte
  fval As Single
  ival As Long
End Type

Type CHAR16FI
  nam(15) As Byte
  f As Single
  i As Long
End Type

Type FSTRUCT
  date As Integer
  time As Integer
  fname(7) As Byte
End Type

Type TDS
  tval As Long
  dval As Single
  sval As Long
End Type

Type USTRING
  ival As Long
  f1val As Single
  f2val As Single
  ts As Long
  str(79) As Byte
End Type

Type DSPECTRUM
  str(79) As Byte
  ts As Long
  start As Single
  inc As Single
  status As Long
  spectrum(4095) As Single
End Type

Declare Function SetAcopQueueDepth Lib "acop.ocx" (ByVal QueueDepth%) As Integer

' -----------------------------------------------------
' | converts Byte array to UNICODE string and vice versa |
' -----------------------------------------------------

Declare Sub Bytes2String Lib "utils32.dll" (ByVal s$, byteArray As Byte, ByVal numBytes%)
Declare Sub String2Bytes Lib "utils32.dll" (byteArray As Byte, ByVal s$, ByVal numBytes%)


'==========================================================
'==                                                      ==
'==         network routines for data acquisition        ==
'==                                                      ==
'==========================================================

Type rpctext
  text As String * 80
End Type
Dim netuser As String * 16

Type DBLK
  dArrayLength As Long
  dFormat As Integer
  Reserved As Integer
  dTag(7) As Byte
End Type

'Direct inteface routines: (But use ACOP if you can)
'Note: the direction "in" and "out" are in the context of the Server,
'      that is: datain is input to the server (what you are sending to it)
'      and dataout is output from the server (what you are receiving from it)

Declare Function T_EXECLINK Lib "eqp32.dll" (ByVal devName$, ByVal devprop$, dout As DBLK, dataout As Any, din As DBLK, datain As Any, ByVal acc%, ByVal timeout&) As Integer
Declare Function T_OPENLINK Lib "eqp32.dll" (ByVal hWnd&, ByVal devName$, ByVal devprop$, dout As DBLK, din As DBLK, datain As Any, ByVal acc%, ByVal timer&, ByVal mode%) As Integer

'
' Legacy routines:
'
'Define Arguments in function call RPC (13.08.97)
'Eqm$ "EQPNAME" (points to REC and Server Task) [ now max of 16 characters ]
'Eqno% Equipment number (if server supports multiple devices)
'prop$ "PROPERTY"  VB string with up to 32 characters (now)
'num%  (number of data requested (ie array dimension for dat) SIGN, next line !!
'For READ, num%>0  , for WRITE, num% = -1*(array dimension) !!!!
'dat   (user defined array for data transfer - must be big enough !!)
'datasize (size of data transfer array in bytes ( for VB, use len(dat) )
'format  ( pktr datatype - CF_SHORT, CF_LONG, etc, see definitions above)
Declare Function rpc Lib "eqp32.dll" Alias "RPC" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal datasize%, ByVal fmt%) As Integer
Declare Function RPCEx Lib "eqp32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal datasize%, ByVal fmt%, ByVal timeout&) As Integer
Declare Function HOTRPC Lib "eqp32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal tim&, ByVal num%, ByVal fmt%) As Integer
Declare Function CLOSERPC Lib "eqp32.dll" (ByVal hWnd&, ByVal id%) As Integer
Declare Function GETRPC Lib "eqp32.dll" (ByVal id%, dat As Any) As Integer
Declare Function GETRPCSTR Lib "eqp32.dll" Alias "GETRPC" (ByVal id%, ByVal sdat As String) As Integer
Declare Function PUTRPC Lib "eqp32.dll" (ByVal id%, dat As Any) As Integer
Declare Function PUTRPCSTR Lib "eqp32.dll" Alias "PUTRPC" (ByVal id%, ByVal sdat As String) As Integer
Declare Function GETRPCDATA Lib "eqp32.dll" (ByVal id%, dat As Any, ts&) As Integer
Declare Function GETRPCSTRDATA Lib "eqp32.dll" Alias "GETRPCDATA" (ByVal id%, ByVal sdat As String, ts&) As Integer
Declare Function RPCERR Lib "eqp32.dll" (ByVal errno%, ByVal errstr$) As Integer
Declare Function GETGLOBAL Lib "eqp32.dll" (ByVal keyword$, dat As Any, ByVal size%, ByVal fmt%) As Integer
Declare Function GETUSER Lib "eqp32.dll" (ByVal user$) As Integer
Declare Function SUBSCRIBE Lib "eqp32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal tim&, ByVal num%, ByVal fmt%, ByVal mode%) As Integer
Declare Function A_RPC Lib "eqp32.dll" (ByVal hWnd&, ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, ByVal fmt%) As Integer
Declare Function SA_RPC Lib "eqp32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal datasize%, ByVal fmt%) As Integer
Declare Function S_RPC Lib "eqp32.dll" (ByVal eqm$, ByVal EqNo%, ByVal prop$, ByVal num%, dat As Any, ByVal datasize%, ByVal fmt%) As Integer
Declare Function FILLSTRUCT Lib "eqp32.dll" (ByVal structTag$, ByVal structSize%, ByVal maxArraySize%, ByVal fmt%) As Integer
Declare Function GETSTRUCTSIZE Lib "eqp32.dll" (ByVal structTag$) As Long
Declare Function RPCGETLASTERR Lib "eqp32.dll" (ByVal errstr$) As Integer
Declare Function RPCGETLASTERROR Lib "eqp32.dll" (ByVal errstr$) As Integer
Declare Function RPCGETLASTSOURCE Lib "eqp32.dll" (ByVal srcstr$) As Integer
Declare Function T_GETCONTEXTS Lib "eqp32.dll" (contexts As NAME16, ncontexts As Long) As Integer
Declare Function T_GETDEVICESERVERS Lib "eqp32.dll" (context As NAME16, servers As NAME16, nservers As Long) As Integer
Declare Function T_GETCONTEXTSFromFile Lib "eqp32.dll" (contexts As NAME16, ncontexts As Long) As Integer
Declare Function T_GETDEVICESERVERSFromFile Lib "eqp32.dll" (context As NAME16, servers As NAME16, nservers As Long) As Integer
Declare Function T_GETDEVICENAMES Lib "eqp32.dll" (context As NAME16, servers As NAME16, names As NAME16, Property As NAME32, ndevices As Long) As Integer
Declare Function T_GETDEVICEPROPERTIES Lib "eqp32.dll" (context As NAME16, servers As NAME16, name As NAME16, Properties As NAME32, nproperties As Long) As Integer
Declare Function GETRPCFECDATA Lib "eqp32.dll" (ByVal context$, ByVal server$, ByVal eqm$, ByVal fec$, AlarmSystem%, _
                 ByVal ipxnet$, ByVal ipxaddr$, ByVal ipaddr$, portoffset%) As Integer
Type RPCFECINFO
  os(11) As Byte
  Description(63) As Byte
  Location(31) As Byte
  hardware(47) As Byte
  responsible(31) As Byte
End Type
Declare Function GETRPCFECINFO Lib "eqp32.dll" (ByVal fecname$, rpcfec As RPCFECINFO) As Integer

' This is the original (ugh!) 'PAINT' API :  (use ACOP if you can)
' --------------------------------------------------------
' | to get the client username, you can also use the call:
' |
' |     user$ = username()
' |
' --------------------------------------------------------

' -----------------------------------------
' | Hot Link example (Asynchronous Call): |
' -----------------------------------------
'
' -----------------------------------------
' | 1). Register Link (e.g. in form_load) |
' -----------------------------------------
'      hotID% = HOTRPC(form1.hWnd, EQP$, EqNo%, prop$, 5000, 100, CF_INTEGER)
' OR:
'      hotID% = SUBSCRIBE(form1.hWnd, EQP$, EqNo%, prop$, 5000, 100, CF_INTEGER, CM_REFRESH)
'
' '    registers a Hot Link for:
' '       equipment function EQP$, equipment number EqNo%,
' '       property prop$, polling rate 5000 milliseconds,
' '       equipment size of 100 data elements,
' '       data element format CF_INTEGER
' '    SUBSCRIBE is a more general routine in that you can
' '       also specify the data acquisition mode:
' '       CM_SINGLE  - is a one-shot (i.e. COLD link)
' '                    asynchronous call
' '       CM_REFRESH - specifies a polling rate to the FEC
' '                    but receives data only when they have
' '                    changed (with a heartbeat of 60 sec)
' '                    good for status calls, etc.
' '       CM_POLL    - receives data at the given polling
' '                    rate.
' '       CM_CANCEL  - cancels the subscription
' '    HOTRPC   is identical to SUBSCRIBE with CM_POLL
' '    CLOSERPC is identical to SUBSCRIBE with CM_CANCEL
'
' -----------------------------------------
' | 2). In the paint routine of given form
' |     (here form1) include:
' -----------------------------------------
'
'      If hotID% > 0 Then
'        hotrc% = GETRPC(hotID%, dat%(0))
'        Select Case hotrc%
'          Case Is > 0: rpcerrbox.visible = True 'signal RPC error
'          Case 0: rpcerrbox.visible = False
'                  call updateData               'called when there are new data
'        End Select
'      End If
'
' '    retrieves the incoming data and puts them into array
' '    dat%(), beginning at dat%(0).  You must insure that
' '    dat%() is large enought to hold the amount of data
' '    you request
'
' --------------------------------------------------------
' | rpcerrbox is a picture box with a red RPC icon        |
' | when clicked you can give the most recent return code:|
' --------------------------------------------------------
'
'     rc% = RPCERR(hotrc%, errstr)
'     If rc% Then MsgBox "RPC: " + RPCERROR(rc%)
'
' ----------------------------------------
' | in form_unload() be sure to include: |
' ----------------------------------------
'
'    If CLOSERPC(form1.hWnd, hotID%) Then
'       msgbox"Error closing hot link!"
'    End If
'    End
'
'
' ----------------------------------------
' | Cold Link Example (Synchronous Call): |
' ----------------------------------------
'
'    rc% = RPC(EQP$, EqNo%, prop$, NPOINTS, data%(0), 8 * NPOINTS, CF_DOUBLE)
'    If rc% Then
'      MsgBox "RPC: " + RPCERROR(rc%)
'    Else
'      Call updataData
'    End If
'

Type PropertyQuery
  prpName(31) As Byte
  prpDesc(31) As Byte
  prpSize As Integer
  prpFormat As Byte
  prpAccess As Byte
End Type

'==========================================================
'==
'==              Special export from Acop.dll
'==
'==========================================================

Declare Function GetCompletionDataSize Lib "acop.dll" () As Long

'==========================================================
'==
'==              Net Globals
'==
'==========================================================

Global HPENERGY As Integer   'Hera Proton energy
Global HPCURRENT As Double   'Hera Proton Beam Current
Global HPTAU     As Double   'Hera Proton Beam Lifetime
Global HEENERGY As Integer   'Hera Electron energy
Global HECURRENT As Double   'Hera Electron Beam Current
Global HETAU     As Double   'Hera Electron Beam Lifetime

' The associated get routines are:
'     HERAGetEnergy(typ$)
'     HERAGetCurrent(typ$)
'     HERAGetLifetime(typ$)
' where typ$ is either "PROTON" or "ELECTRON"
' the above varables are then updated
'
' e.g. To get the current HERA Proton magnet energy:
'
'    rc% = HERAGetEnergy("PROTON")
'    If rc% Then
'      MsgBox "RPC Error : " + RPCERROR(rc%)
'    Else
'      MsgBox "Then energy in HERA P is: " + str$(HPENERGY)
'    End If
'

'==========================================================
'==
'==              Server Routines
'==
'==========================================================

Declare Function Address Lib "winsrv32.dll" (r As Any) As Long
Declare Function CADDR Lib "winsrv32.dll" (r As Any) As Long
Declare Function CSTRADDR Lib "winsrv32.dll" Alias "CADDR" (ByVal r As String) As Long
Declare Function UTIME Lib "winsrv32.dll" () As Long
Declare Function DebugServer Lib "winsrv32.dll" (ByVal level%) As Integer
Declare Function SetMinimumPollingRate Lib "winsrv32.dll" (ByVal mpr%) As Integer
Declare Function RegisterFecName Lib "winsrv32.dll" (ByVal name$, ByVal desc$, ByVal loc$, ByVal hdw$, ByVal resp$, ByVal port%) As Integer
Declare Function RegisterFecNameEx Lib "winsrv32.dll" (ByVal name$, ByVal desc$, ByVal loc$, ByVal hdw$, ByVal resp$, ByVal port%, ByVal context$) As Integer
Declare Function FILLSRVSTRUCT Lib "winsrv32.dll" (ByVal tag$, ByVal addr%, ByVal size%, ByVal fmt%) As Integer
Declare Sub GetCallerInfo Lib "winsrv32.dll" (ByVal ClientName$, ByVal ClientAddress$)
Declare Function SRVSTATUS Lib "winsrv32.dll" () As Integer
Declare Function feclog Lib "winsrv32.dll" (ByVal txt As String) As Integer

' ================================
'   RPC Access modes
' ================================

Global Const CA_READ = &H1
Global Const CA_WRITE = &H2
Global Const CA_WRITEREAD = &H3
Global Const CA_FIRST = &H40
Global Const CA_LAST = &H80

' ================================
'   RPC Error Definitions
' ================================
Global Const success% = 0
Global Const illegal_line% = 1
Global Const illegal_format% = 2
Global Const illegal_arithmetic% = 3
Global Const ambiguous% = 4
Global Const illegal_delimiter% = 5
Global Const zero_divide% = 6
Global Const WA_full% = 7
Global Const non_existent% = 8
Global Const wrong_type% = 9
Global Const link_exhausted% = 10
Global Const not_properly% = 11
Global Const un_allocated% = 12
Global Const no_such_line% = 13
Global Const illegal_shuffle% = 14
Global Const if_error% = 15
Global Const escape_typed% = 16
Global Const ask_error% = 18
Global Const argument_list_error% = 20
Global Const file_error% = 21
Global Const user_stream_transport% = 22
Global Const dimension_error% = 23
Global Const t_dimension_error% = 23
Global Const square_root_negative% = 24
Global Const buffer_too_small% = 25
Global Const string_too_long% = 26
Global Const ipx_socket_error% = 27
Global Const net_read_error% = 28
Global Const not_ready% = 29
Global Const log_negative% = 31
Global Const device_not_connected% = 32
Global Const unauthorised_action% = 33
Global Const hardware_error% = 34
Global Const illegal_equipment_number% = 35
Global Const illegal_property% = 36
Global Const out_of_range% = 37
Global Const not_implemented% = 38
Global Const no_such_computer% = 39
Global Const string_filled% = 40
Global Const syntax_error% = 41
Global Const no_such_file% = 42
Global Const no_file_space% = 44
Global Const link_not_open% = 45
Global Const remitted_data_lost% = 46
Global Const end_of_file% = 47
Global Const def_area_full% = 52
Global Const def_syntax% = 53
Global Const illegal_string_set% = 54
Global Const serr1% = 54
Global Const string_function_failure% = 55
Global Const serr2% = 55
Global Const Sif_error% = 57
Global Const Sask_error% = 58
Global Const string_expected% = 59
Global Const out_of_local_memory% = 60
Global Const out_of_shared_memory% = 61
Global Const invalid_structure_tag% = 62
Global Const invalid_index% = 63
Global Const illegal_equipment_name% = 64
Global Const link_error% = 65
Global Const code_failure% = 66
Global Const bracket_missing% = 67
Global Const wrong_hexa% = 68
Global Const wrong_octal% = 69
Global Const illegal_character% = 70
Global Const illegal_operator% = 71
Global Const not_allowed% = 72
Global Const illegal_read_write% = 73
Global Const out_of_memory% = 74
Global Const database_not_loaded% = 75
Global Const illegal_command% = 76
Global Const resources_exhausted% = 77
Global Const file_not_open% = 78
Global Const sedac_error% = 79
Global Const no_such_loop% = 80
Global Const driver_not_installed% = 82
Global Const port_not_available% = 83
Global Const scan_error% = 84
Global Const no_high_voltage% = 85
Global Const non_existent_elem% = 86
Global Const non_existent_fec% = 87
Global Const non_existent_client% = 88
Global Const cannot_lock% = 89
Global Const not_running% = 90
Global Const not_posted% = 91
Global Const not_accepted% = 92
Global Const oeration_timeout% = 93
Global Const illegal_protocol% = 94
Global Const gpib_error% = 95
Global Const rs232_error% = 96
Global Const operation_busy% = 97
Global Const connection_timeout% = 98
Global Const illegal_mode% = 99
Global Const not_owner% = 100
Global Const not_defined% = 101
Global Const net_write_error% = 102
Global Const invalid_data% = 103
Global Const software_error% = 104
Global Const access_denied% = 105
Global Const tcp_not_supported% = 106
Global Const ipx_not_supported% = 107
Global Const host_not_resolved% = 108
Global Const tcp_connect_error% = 109
Global Const tcp_socket_error% = 110
Global Const fpss_error% = 111
Global Const fpss_timeout% = 112
Global Const fpss_overflow% = 113
Global Const pocal_error% = 114
Global Const max_alarms_exceeded% = 115
Global Const not_exported% = 116
Global Const is_switching% = 117
Global Const at_limit% = 118


Function GETCURRENT() As Double
Static er As String * 80
rc% = GETGLOBAL("HPCur", HPCURRENT, 1, CF_DOUBLE)
If rc% = 0 Then
  GETCURRENT = HPCURRENT
Else
  rc% = RPCERR(rc%, er$)
  GETCURRENT = -1
End If
End Function

Function GETENERGY() As Integer
Static er As String * 80
rc% = GETGLOBAL("HPENERGY", HPENERGY, 1, CF_INTEGER)
If rc% = 0 Then
  GETENERGY = HPENERGY
Else
  rc% = RPCERR(rc%, er$)
  GETENERGY = -1
End If
End Function

Function HERAGetCurrent(ByVal t$)
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPCur", HPCURRENT, 1, CF_DOUBLE)
       If HPCur < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HECur", HECURRENT, 1, CF_DOUBLE)
       If HECur < 0 Then rc% = 91 ' not_posted
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetCurrent = rc%
End Function

Function HERAGetEnergy(ByVal t$) As Integer
Static hemagen As Single
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPENERGY", HPENERGY, 1, CF_INTEGER)
       If HPENERGY < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HEMAGEN", hemagen, 1, CF_FLOAT)
       HEENERGY = CInt(hemagen)
       If HEENERGY < 0 Then rc% = 91
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetEnergy = rc%
End Function

Function HERAGetLifetime(ByVal t$)
t$ = UCase$(t$)
Select Case t$
  Case "PROTON":
       rc% = GETGLOBAL("HPtau", HPTAU, 1, CF_DOUBLE)
       If HPTAU < 0 Then rc% = 91 ' not_posted
  Case "ELECTRON":
       rc% = GETGLOBAL("HEtau", HETAU, 1, CF_DOUBLE)
       If HETAU < 0 Then rc% = 91 ' not_posted
  Case Else: rc% = 86 ' non_existent_elem
End Select
HERAGetLifetime = rc%
End Function
Function GetEquipmentDevicePropertyInformation(devName As String, Properties() As String, PropertySizes() As Integer, PropertyTypes() As Integer, nproperties As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim prps() As PropertyQuery
Dim rc As Integer, i%
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(devName, "NPROPS", dbout, n, dbin, Null, CA_READ, 500)
If rc Then GoTo exitFunction
ReDim prps(n)
dbout.dArrayLength = n * Len(prps(0)): dbout.dFormat = CF_STRUCT
rc = T_EXECLINK(devName, "PROPS", dbout, prps(0), dbin, Null, CA_READ, 3000)
If rc Then GoTo exitFunction
ReDim Properties(n): ReDim PropertySizes(n): ReDim PropertyTypes(n)
For i% = 0 To n - 1
  Properties(i%) = Trim$(BSTR(prps(i).prpName))
  PropertySizes(i%) = prps(i).prpSize
  PropertyTypes(i%) = prps(i).prpFormat
Next
exitFunction:
nproperties = n
GetEquipmentDevicePropertyInformation = rc%
End Function
Function GetEquipmentDeviceProperties(devName As String, Properties() As String, nproperties As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Long 'Integer
Dim prps() As PropertyQuery
Dim rc As Integer, i%
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(devName, "NPROPS", dbout, n, dbin, Null, CA_READ, 100)
If rc Then GoTo exitFunction
ReDim prps(n)
dbout.dArrayLength = n * Len(prps(0)): dbout.dFormat = CF_STRUCT
rc = T_EXECLINK(devName, "PROPS", dbout, prps(0), dbin, Null, CA_READ, 3000)
If rc Then GoTo exitFunction
ReDim Properties(n)
For i% = 0 To n - 1
  Properties(i%) = Trim$(BSTR(prps(i).prpName))
Next
exitFunction:
nproperties = n
GetEquipmentDeviceProperties = rc%
End Function

Function GetPropertyInformation(devName As String, Property As String, DataLength As Long, DataFormat As Integer, Description As String) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim prp As PropertyQuery
Dim rc As Integer, i%
Dim tgt As NAME32
  
dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
dbout.dArrayLength = Len(prp): dbout.dFormat = CF_STRUCT
BARR tgt.nam(), Property
rc = T_EXECLINK(devName, "PROPS", dbout, prp, dbin, tgt, CA_READ, 1000)
If rc = 0 Then
  DataLength = prp.prpSize
  DataFormat = CF_DOUBLE + prp.prpFormat
  Description = BSTR(prp.prpDesc())
End If
GetPropertyInformation = rc%
End Function
Function GetEquipmentEGU(devName As String, devProperty As String, eguMin As Single, eguMax As Single, egu As String) As Integer
Dim u As USTRING
Dim dout As DBLK, din As DBLK
Dim rc As Integer
Dim devPrp As String

din.dArrayLength = 0: din.dFormat = CF_NULL
dout.dArrayLength = 1: dout.dFormat = CF_USTRING
devPrp = devProperty + ".EGU"
rc = T_EXECLINK(devName, devPrp, dout, u, din, 0, CA_READ, 500)
If rc Then
 GetEquipmentEGU = rc
 Exit Function
End If
eguMin = u.f1val
eguMax = u.f2val
egu$ = BSTR(u.str())
GetEquipmentEGU = 0
End Function
Function GetEquipmentExtEGU(devName As String, devProperty As String, eguMin As Single, eguMax As Single, egu As String, eguType As Integer) As Integer
Dim u As USTRING
Dim dout As DBLK, din As DBLK
Dim rc As Integer
Dim devPrp As String

din.dArrayLength = 0: din.dFormat = CF_NULL
dout.dArrayLength = 1: dout.dFormat = CF_USTRING
devPrp = devProperty + ".EGU"
rc = T_EXECLINK(devName, devPrp, dout, u, din, 0, CA_READ, 500)
If rc Then
 GetEquipmentExtEGU = rc
 Exit Function
End If
eguMin = u.f1val
eguMax = u.f2val
eguType = u.ival
egu$ = BSTR(u.str())
GetEquipmentExtEGU = 0
End Function
Function GetEquipmentDeviceNames(EqpName As String, devNames() As String, ndevices As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim nms() As NAME16
Dim rc As Integer, i%, j%
Dim dev As String
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
rc = T_EXECLINK(EqpName, "NDEVICES", dbout, n, dbin, Null, CA_READ, 100)
If rc Then GoTo exitFunction
ReDim nms(n)
dbout.dArrayLength = n: dbout.dFormat = CF_NAME16
rc = T_EXECLINK(EqpName, "DEVICES", dbout, nms(0), dbin, Null, CA_READ, 3000)
If rc Then GoTo exitFunction
ReDim devNames(n): j% = 0
For i% = 0 To n - 1
  dev = Trim$(BSTR(nms(i%).nam()))
  If Right$(dev, 1) = "&" And Len(dev) = 16 Then
    i% = i% + 1
    dev = Left$(dev, 15) + Trim$(BSTR(nms(i%).nam()))
  End If
  If Len(dev) > 0 Then
    devNames(j%) = dev
    j% = j% + 1
  End If
Next
exitFunction:
ndevices = j%
GetEquipmentDeviceNames = rc%
End Function

Function RPCERROR(ByVal rc%) As String
Static rpcerrbuff As String * 80
cc% = RPCERR(rc%, rpcerrbuff)
If cc% Then
  RPCERROR = "Error undefined"
Else
  RPCERROR = Left$(rpcerrbuff, InStr(rpcerrbuff, Chr(0)) - 1)
End If
End Function

Function UserName() As String
cc% = GETUSER(netuser$)
UserName = UCase(Left$(netuser$, InStr(netuser$, Chr(0)) - 1))
End Function

Function BSTR(B() As Byte) As String
Dim s As String * 2048
Dim numBytes%
numBytes% = UBound(B) - LBound(B) + 1
If numBytes% > 2048 Then numBytes% = 2048
Call Bytes2String(s, B(LBound(B)), numBytes%)
BSTR = Left$(s, InStr(s, Chr(0)) - 1)
End Function
Function BARR(B() As Byte, s As String) As Integer
Dim numBytes&, strlen%, i%
numBytes& = UBound(B) - LBound(B) + 1
strlen% = Len(s)
If strlen% > numBytes& Then
  BARR = 0
Else
  Call String2Bytes(B(LBound(B)), s, strlen%)
  If numBytes& > strlen% Then B(LBound(B) + strlen%) = 0
  BARR = strlen%
End If
End Function
Function GetFecsFromNameServer(ByVal context$, fecNames() As String, nfecs As Integer)
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim fns() As NAME16, cnt As NAME16
Dim devName As String
Dim rc As Integer, i%
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
devName = "ENS"
If Len(context$) > 0 Then
  devName = devName + "/" + context$
End If
rc = T_EXECLINK(devName, "NFECS", dbout, n, dbin, 0, CA_READ, 100)
If rc Then GoTo exitFunction
ReDim fns(n)
dbout.dArrayLength = n: dbout.dFormat = CF_NAME16
rc = T_EXECLINK(devName, "FECS", dbout, fns(0), dbin, 0, CA_READ, 1000)
If rc Then GoTo exitFunction
ReDim fecNames(n)
For i% = 0 To n - 1
  fecNames(i%) = Trim$(BSTR(fns(i%).nam()))
Next
exitFunction:
nfecs = n
GetFecsFromNameServer = rc%
End Function

Function GetEquipmentDeviceContexts(devContexts() As String, nDevContexts As Integer) As Integer
Dim ldc(200) As NAME16
Dim n As Long, rc As Integer, i%

n = 200
rc = T_GETCONTEXTS(ldc(0), n)
If rc Then GoTo exitGetEquipmentDeviceContexts
ReDim devContexts(n)
For i% = 0 To n - 1
  devContexts(i%) = Trim$(BSTR(ldc(i%).nam()))
Next

exitGetEquipmentDeviceContexts:
nDevContexts = n
GetEquipmentDeviceContexts = rc

End Function
Function GetEquipmentDeviceServers(devcontext As String, devSubSystem As String, devServers() As String, nDevServers As Integer) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer
Dim srvs() As NAME16, subsys As NAME16
Dim devName As String
Dim rc As Integer, i%
If Len(devSubSystem) = 0 Then
  dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
Else
  dbin.dArrayLength = 1: dbin.dFormat = CF_NAME16
  BARR subsys.nam(), devSubSystem
End If
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
devName = "ENS"
If Len(devcontext) > 0 Then devName = devName + "/" + devcontext
rc = T_EXECLINK(devName, "NTAGS", dbout, n, dbin, subsys, CA_READ, 100)
If rc Then GoTo exitFunction
ReDim srvs(n)
dbout.dArrayLength = n: dbout.dFormat = CF_NAME16
rc = T_EXECLINK(devName, "TAGS", dbout, srvs(0), dbin, subsys, CA_READ, 3000)
If rc Then GoTo exitFunction
ReDim devServers(n)
For i% = 0 To n - 1
  devServers(i%) = Trim$(BSTR(srvs(i%).nam()))
Next
exitFunction:
nDevServers = n
GetEquipmentDeviceServers = rc%
End Function
Function SetRPCDragDropString(devName$, devprop$, devType%, devSize&, devDesc$) As String
SetRPCDragDropString = devName$ & "!" & devprop$ & "!" & Trim$(str$(devType%)) _
                       & "!" & Trim$(str$(devSize&)) & "!" & devDesc$
End Function
Function ParseRPCDragDropString(ddstr$, devName$, devprop$, devType%, devSize&, devDesc$) As Integer
Dim tmpstr$
Dim pos As Long

tmpstr$ = ddstr$
pos = InStr(tmpstr$, "!") - 1
If pos = -1 Then
  ParseRPCDragDropString = -1
  Exit Function
End If
devName$ = Left$(tmpstr$, pos)
tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
pos = InStr(tmpstr$, "!") - 1
If pos = -1 Then
  ParseRPCDragDropString = -1
  Exit Function
End If
devprop$ = Left$(tmpstr$, pos)
tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
pos = InStr(tmpstr$, "!") - 1
If pos = -1 Then
  ParseRPCDragDropString = -1
  Exit Function
End If
devType% = CInt(Left$(tmpstr$, pos))
tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
pos = InStr(tmpstr$, "!") - 1
If pos = -1 Then
  ParseRPCDragDropString = -1
  Exit Function
End If
devSize& = CLng(Left$(tmpstr$, pos))
tmpstr$ = Right$(tmpstr$, Len(tmpstr$) - pos - 1)
devDesc$ = tmpstr$

End Function
Function TrimString(ByVal st As String) As String
Dim p As Integer
Dim s As String
s = st
s = Trim(s) ' ist iteration
p = InStr(s, Chr(0))
If p > 1 Then s = Left$(s, p - 1)
TrimString = s
End Function
