Attribute VB_Name = "OpticsArrays"
' --------------------------------------------------------------------------------------------------------------------------
' Standard Optik Arrays
' --------------------------------------------------------------------------------------------------------------------------

Global OpticList As OpticListType
Global OpticDescriptionFromMops As Boolean

' folgende Arrays knnen nicht alle in einer Struktur untergebracht werden
' (64K Grenze):

Global OpticHeader As OpticHeaderType
Global PosName(LatDim%) As String * 8
Global TypeName(LatDim%) As String * 8
Global Middle(LatDim%) As Double
Global Drift(LatDim%) As Double
Global Beta(LatDim%, 1) As Single
Global Alpha(LatDim%, 1) As Single
Global Phi(LatDim%, 1) As Single
Global Disp(LatDim%, 1) As Single
Global DispP(LatDim%, 1) As Single
Global ElePointer(LatDim%) As Integer
Global Ele(EleDim%) As ElementType
 
' Einzelne LatticeElemente:
' bitte keine RPC Loop ber LatDim%:
' Global Lattice(LatDim%) As LatticeElementType
' Global Lat1 As LatticeElementType
 
' prop$ = "CMSTRUCT"
' VB Structures
Global Mon(MonDim%, 1) As MonitorType
Global Cor(CorDim%, 1) As CorrectorType

' prop$ = "RCMOPS"
' F77 COMMON Blocks a la $mcmcom (IBM/HP)
' for Compatibility to Server Version 3 - please use "CMSTRUCT"
' Monitors:
Global MonPhi(MonDim%, 1) As Single               ' Phaseadvance
Global MonBeta(MonDim%, 1) As Single              ' Beta
Global MonDisp(MonDim%, 1) As Single              ' Dispersion
Global MonName(MonDim%, 1) As String * 8
' Correction Coils:
Global CorPhi(CorDim%, 1) As Single               ' Phaseadvance
Global CorBeta(CorDim%, 1) As Single              ' Beta
Global CorDisp(CorDim%, 1) As Single              ' Dispersion
Global CorKmax(CorDim%, 1) As Single              ' Max Kick in mrad for highest Energy
Global CorName(CorDim%, 1) As String * 8

' --------------------------------------------------------------------------------------------------------------------------
' Orbit Correction Arrays
' --------------------------------------------------------------------------------------------------------------------------

Global OrbitPolFit2 As OrbitType ' damit nichts berschrieben wird
Global OrbitList As OrbitListType

'Global TempOpticList As OpticListType
'Global TempOpticHeader As OpticHeaderType
'Global TempMon(MonDim%, 1) As MonitorType
'Global TempCor(CorDim%, 1) As CorrectorType

