%  TINEWRITE writes data to the control system  
%
% In the call TINEWRITE(VALUE,DEVPROPSTR) value is the data to be written to 
% the server, devpropstr is a string composed of the 
% server context CONTEXT, the server name SERVER, 
% the device name DEV and the device property PROP. The type of VALUE 
% depends an the data structure to be written.
%
% Caution: VALUE must be a column vector! 
% 
% Syntax:
%   tinewrite(value,'/<CONTEXT>/<SERVER>/<DEV>[<PROP>]')
% Or:
%   tinewrite(value,'<SERVER>/<DEV>[<PROP>]')
%
% Example:
%   tinewrite([0; 5; 2], '/HERA/HeEOrbit/WL   791[WrSet_dB]')