/*========================= Doris Netmex Data ========================*/
#ifndef DORISVER
#define DORISVER 102

/*
  102: added DOBW3RevSt => Wiggler Revolver Stellung

*/

#ifndef MSDOS
#define INT_32 unsigned int
#else
#define INT_32 unsigned long
#endif
#define CF_INT_32 CF_LONG

char rms_vertical[16];
char rms_horizontal[16];
char state_vertical[16];
char state_horizontal[16];
float rmsvalues[6];
float wrmsvalues[6];

NETKEY HRMSSTR={ "LAGERGL","HLRMS",CF_BYTE,16,1,RC_INI,T_INIT,ST_INI,DORISVER,(void*)rms_horizontal};
NETKEY VRMSSTR={ "LAGERGL","VLRMS",CF_BYTE,16,1,RC_INI,T_INIT,ST_INI,DORISVER,(void*)rms_vertical};
NETKEY HSTATESTR={ "LAGERGL","STATESTR",CF_BYTE,16,1,RC_INI,T_INIT,ST_INI,DORISVER,(void*)state_vertical};
NETKEY VSTATESTR={ "LAGERGL","STATESTR",CF_BYTE,16,2,RC_INI,T_INIT,ST_INI,DORISVER,(void*)state_vertical};
NETKEY RMSVALUES={ "LAGERGL","RMS",CF_FLOAT,6,1,RC_INI,T_INIT,ST_INI,DORISVER,(void*)rmsvalues};
NETKEY WRMSVALUES={ "LAGERGL","WRMS",CF_FLOAT,6,1,RC_INI,T_INIT,ST_INI,DORISVER,(void*)wrmsvalues};

#define DoBLBeamPos_NUM 38
NAME16 gn16DoBLBeamPosNAM[DoBLBeamPos_NUM];
float gfDoBLBeamPosX[DoBLBeamPos_NUM];
float gfDoBLBeamPosY[DoBLBeamPos_NUM];
float gfDoBLMonPosX[DoBLBeamPos_NUM];
float gfDoBLMonPosY[DoBLBeamPos_NUM];
NETKEY DoBLBeamPosNames={ "DORISDATA","DoBLBeamPos.X.NAM",CF_NAME16,DoBLBeamPos_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gn16DoBLBeamPosNAM};
NETKEY DoBLBeamPosX={ "DORISDATA","DoBLBeamPos.X",CF_FLOAT,DoBLBeamPos_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoBLBeamPosX};
NETKEY DoBLBeamPosY={ "DORISDATA","DoBLBeamPos.Y",CF_FLOAT,DoBLBeamPos_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoBLBeamPosY};
NETKEY DoBLMonPosX={ "DORISDATA","DoBLMonPos.X",CF_FLOAT,DoBLBeamPos_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoBLMonPosX};
NETKEY DoBLMonPosY={ "DORISDATA","DoBLMonPos.Y",CF_FLOAT,DoBLBeamPos_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoBLMonPosY};

#define DoBW3RevSt_NUM 1
short gsDoBW3RevSt[DoBW3RevSt_NUM];
NETKEY DoBW3RevSt={ "DORISDATA","DOBW3RevSt",CF_SHORT,DoBW3RevSt_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gsDoBW3RevSt};

#define DoBunCur_NUM 10
float gfDoBunCur[DoBunCur_NUM];
NETKEY DoBunCur={ "DORISDATA","DoBunCur",CF_FLOAT,DoBunCur_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoBunCur};

#define DoBunCount_NUM 1
float gfDoBunCount[DoBunCount_NUM];
NETKEY DoBunCount={ "DORISDATA","DoBunchCount",CF_FLOAT,DoBunCount_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoBunCount};

#define DoSumCur_NUM 1
float gfDoSumCur[DoSumCur_NUM];
NETKEY DoSumCur={ "DORISDATA","DoSumCur",CF_FLOAT,DoSumCur_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoSumCur};

#define DoDCCur_NUM 1
float gfDoDCCur[DoDCCur_NUM];
NETKEY DoDCCur={ "DORISDATA","DoDCCur",CF_FLOAT,DoDCCur_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoDCCur};
float gfDoDCLoss[DoDCCur_NUM];
NETKEY DoDCLoss={ "DORISDATA","DoDCLoss",CF_FLOAT,DoDCCur_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoDCLoss};
float gfDoDCTau[DoDCCur_NUM];
NETKEY DoDCTau={ "DORISDATA","DoDCTau",CF_FLOAT,DoDCCur_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoDCTau};

#define DoEnergy_NUM 1
float gfDoEnergy[DoEnergy_NUM];
NETKEY DoEnergy={ "DORISDATA","DoEnergy",CF_FLOAT,DoEnergy_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoEnergy};

#define DoOrbit_NUM 40
float gfDoOrbitHor[DoOrbit_NUM];
float gfDoOrbitVer[DoOrbit_NUM];
NETKEY DoOrbitHor={ "DORISDATA","DoOrbitHor",CF_FLOAT,DoOrbit_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoOrbitHor};
NETKEY DoOrbitVer={ "DORISDATA","DoOrbitVer",CF_FLOAT,DoOrbit_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoOrbitVer};

#define DoRWegVacPres_NUM 2
float gfDoRWegVacPres[DoRWegVacPres_NUM];
NETKEY DoRWegVacPres={ "DORISDATA","DoRWegVacPres",CF_FLOAT,DoRWegVacPres_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoRWegVacPres};

#define DoSTATE_NUM 1
NAME32 gn32DoSTATE[DoSTATE_NUM];
NETKEY DoSTATE={ "DORISDATA","DoSTATE",CF_NAME32,DoSTATE_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gn32DoSTATE};

#define DoVacPressure_NUM 156
NAME32 gfDoVacPressure[DoVacPressure_NUM];
NETKEY DoVacPressure={ "DORISDATA","DoVacPressure",CF_FLOAT,DoVacPressure_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoVacPressure};

#define DoVacAvePr_NUM 1
NAME32 gfDoVacAvePr[DoVacAvePr_NUM];
NETKEY DoVacAvePr={ "DORISDATA","DOVACAvePr",CF_FLOAT,DoVacAvePr_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoVacAvePr};

#define DoTVText_NUM 64
char gtDoTVText[DoTVText_NUM];
NETKEY DoTVText={ "DORISDATA","DoTVText",CF_TEXT,DoTVText_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gtDoTVText};

#define DoMODUS_NUM 32
char gtDoMODUS[DoMODUS_NUM];
NETKEY DoMODUS={ "DORISDATA","DoMODUS",CF_TEXT,DoMODUS_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gtDoMODUS};

#define DoArcTemp_NUM 46
float gfDoArcTemp[DoArcTemp_NUM];
NETKEY DoArcTemp={ "DORISDATA","DoArcTemp",CF_FLOAT,DoArcTemp_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoArcTemp};

#define DoBLWigglerGap_NUM 10
float gfDoBLWigglerGap[DoBLWigglerGap_NUM];
NETKEY DoBLWigglerGap={ "DORISDATA","DoBLWigglerGap",CF_FLOAT,DoBLWigglerGap_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoBLWigglerGap};

#define DoVCorrSoll_NUM 40
float gfDoVCorrSoll[DoVCorrSoll_NUM];
NETKEY DoVCorrSoll={ "DORISDATA","DoVCorrSoll",CF_FLOAT,DoVCorrSoll_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoVCorrSoll};

#define DoSekiDelay_NUM 5
float gfDoSekiDelay[DoSekiDelay_NUM];
NETKEY DoSekiDelay={ "DORISDATA","DoSekiDelay",CF_FLOAT,DoSekiDelay_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoSekiDelay};

#define DoSekiSoll_NUM 5
float gfDoSekiSoll[DoSekiSoll_NUM];
NETKEY DoSekiSoll={ "DORISDATA","DoSekiSoll",CF_FLOAT,DoSekiSoll_NUM,0,RC_INI,T_INIT,ST_INI,DORISVER,(void*)gfDoSekiSoll};

#endif /* DORISVER */
