#ifndef NTCMD_H_
#define NTCMD_H_

#include <signal.h>
#include <sys/types.h>
#include "rpcdefs.h"
#define CMDSIZE 256

typedef struct usrcmdStruct
{
  char cmd[32];
  int (*fcn)(int,int,int,int);
  int *iparam;
  float *fparam;
  int access;
  struct usrcmdStruct *next;
} USRCMD;
extern USRCMD *usrcmd;
extern int numUsrCmd;
int RegisterUserCommand(
    char *cmd,
    int (*fcn)(int,int,int,int),
    int *iparam,
    float *fparam,
    int access);

int getVal(char *var,char *s);
int setVal(char *var,char *val);
int InterpretCommand(char *cmd);
int quit(char *s1,char *s2);
int help(char *s1,char *s2);
void GetCommand(void);
int getControlSystemInfo(void);
void FecSynchronize(void);
void FecShowtime(void);
void initWatchDog(void);
int initSAPWatchDog(void);
void netWatchDog(void);
void watchDog(void);
void enableWatchDog(void);
void disableWatchDog(void);
void dumpGlobals(void);
int feclog(char *text);
int NetHandler(int errval,int ax,int bp,int si);
extern int NumCommands;
extern int NumEquipmentFunctions;
extern char cmdbuf[CMDSIZE];
extern char strbuf[CMDSIZE];
extern WORD watchdogBaseAddress;
extern int watchdogEnabled;
extern int CommandLevel;


#endif /* NTCMD_H_ */
