# Makefile for client test program - PKTR rpc calls
# Version 20.03.95
# Insert the defs for your machine
# SUN:    CC = CC         CCL = CC         LM = 
# SGI     CC = cc         CCL = cc         LM = -lm
# OSF     CC = cc         CCL = cc         LM = -lm
# LINUX   CC = cc         CCL = cc         LM = -lm
# ULT     CC = gcc -c -g  CCL = gcc -g     LM = 
# HP:     CC = cc -Aa     CCL = cc         LM = -lM
# SOL 2.4 CC = CC         CCL = CC         LM = -lsocket -lnsl

LIBS = /usr/TINE/lib
INCL = /usr/TINE/include
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/servdef.h \
	${INCL}/errors.h 

CPP = g++
CC = cc -Aa -c -g -I${INCL}
CCL = cc -g
LM = -lM

tdaemon: rpcserv.o tdaemon.o ${LIBS}/rpclib.a
	${CCL} -o tdaemon rpcserv.o tdaemon.o ${LIBS}/rpclib.a ${LM}

rpcserv.o: rpcserv.c ${HDRS}
	${CC} rpcserv.c

tdaemon.o: tdaemon.c ${HDRS}
	${CC} tdaemon.c 

clean:
	rm *.o
