package TINE;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
public final class FLTINT
{
  public float fval;
  public int ival;
  public static int sizeInBytes = 8;
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public FLTINT() {fval = 0; ival = 0; }  
  public FLTINT(float f) { fval = f; ival = 0; }  
  public FLTINT(int i) { ival = i; }  
  public FLTINT(float f,int i) { fval = f; ival = i; }  
  public byte[] toByteArray()
  {
    try
    {
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      byte[] b = Swap.Float(fval);
      ds.write(b,0,4);
      ds.writeInt(Swap.Long(ival));
      ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }    
  public void toStruct()
  {
    try
    {
      ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
      DataInputStream ds = new DataInputStream(dis);
      byte[] b = new byte[4];
      ds.read(b,0,4);
      fval = Swap.Float(b);
      ival = Swap.Long(ds.readInt());
      ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }	 
  }    
}
