package TINE;

/**
 * @brief Alias for INTINTFLTFLT
 *
 * Useful for providing data access ranges (windows) in the time domain
 * (the 2 integer fields as UTC values) and data domain (the 2 float fields
 * as min and max values).
 */
public final class FWINDOW extends INTINTFLTFLT
{
  public FWINDOW() { f1val = 0; f2val = 0; i1val = 0; i2val = 0; }  
  public FWINDOW(float f) { f1val = f; f2val = 0; i1val = 0; i2val = 0; }  
  public FWINDOW(int i) { f1val = 0; f2val = 0; i1val = i; i2val = 0; }  
  public FWINDOW(float f1,float f2,int i1,int i2) { f1val = f1; f2val = f2; i1val = i1; i2val = i2; }  
}
