package TINE;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
public final class LNGINT
{
  public int lval;
  public int ival;
  public static int sizeInBytes = 8;
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public LNGINT() {lval = 0; ival = 0; }  
  public LNGINT(int l) { lval = l; ival = 0; }  
  public LNGINT(int l,int i) { lval = l; ival = i; }  
  public byte[] toByteArray()
  {
	try
	{
		dBuffer.reset();
		DataOutputStream ds = new DataOutputStream(dBuffer);
		ds.writeInt(Swap.Long(lval));
		ds.writeInt(Swap.Long(ival));
		ds.close();
	}
	catch (IOException e)
	{
	  e.printStackTrace();
//	  System.exit(1);
	}
	hByteArray = dBuffer.toByteArray();
	return hByteArray;
  }  
  public void toStruct()
  {
	try
	{
		ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
		DataInputStream ds = new DataInputStream(dis);
		lval = Swap.Long(ds.readInt());
		ival = Swap.Long(ds.readInt());
		ds.close(); dis.close();
	}
	catch (IOException e)
	{
	  e.printStackTrace();
//	  System.exit(1);
	}	 
  }  
}