package TINE;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
public final class NAME16
{
  public String name;
  public static int sizeInBytes = 16;
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public NAME16() {name = new String(new StringBuffer(16)); }  
  public NAME16(String Name) { name = Name; }
  public String toString() { return name; }
  public byte[] toByteArray()
  {
    try
    {
    	dBuffer.reset();
    	DataOutputStream ds = new DataOutputStream(dBuffer);
    	byte[] bname = name.getBytes();
    	byte[] b = new byte[sizeInBytes];
    	for (int i=0; i<sizeInBytes && i<bname.length; i++) b[i] = bname[i];
    	ds.write(b,0,b.length);
    	ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }  
  public void toName()
  {
    try
    {
    	ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
    	DataInputStream ds = new DataInputStream(dis);
    	byte[] b = new byte[sizeInBytes];
    	ds.read(b,0,sizeInBytes);
    	int len = 0; for (int i=0; i<sizeInBytes && b[i] != 0; i++, len++);
    	name = new String(b,0,len);
    	ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }	 
  }  
}