package TINE;
public final class TAccess
{
  public static final short CA_NULL  = 0;
  public static final short CA_READ  = 1;
  public static final short CA_WRITE = 2;
  public static final short CA_ASYNC = 4;
  public static final short CA_SYNC  = 8;
  public static String toString(short access)
  {
    String add = "";
    if ((access & 0x04) == 0x4) add = "async ";
    if ((access & 0x08) == 0x8) add = "sync ";
    switch (access & 0x03)
    {
      case CA_NULL: return "none";
      case CA_READ: return add + "read only";
      case CA_WRITE: return add + "write";
      default: return add + "read/write";
    }
  }
}