package TINE;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
public final class TDS
{
  public int tval;
  public float dval;
  public int sval;
  public static int sizeInBytes = 12;
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public TDS() { tval = 0; dval = 0; sval = 0; }  
  public TDS(float d) { tval = 0; dval = d; sval = 0; }  
  public TDS(int t) { tval = t; dval = 0; sval = 0; }  
  public TDS(float d,int t) { dval = d; tval = t; sval = 0; }  
  public TDS(float d,int t,int s) { dval = d; tval = t; sval = s; }  
  public byte[] toByteArray()
  {
    try
    {
    	dBuffer.reset();
    	DataOutputStream ds = new DataOutputStream(dBuffer);
    	ds.writeInt(Swap.Long(tval));
    	byte[] b = Swap.Float(dval);
    	ds.write(b,0,4);
    	ds.writeInt(Swap.Long(sval));
    	ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }    
  public void toStruct()
  {
    try
    {
    	ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
    	DataInputStream ds = new DataInputStream(dis);
    	tval = Swap.Long(ds.readInt());
    	byte[] b = new byte[4];
    	ds.read(b,0,4);
    	dval = Swap.Float(b);
    	sval = Swap.Long(ds.readInt());
    	ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
    }	 
  }    
}