# Makefile for client netmex
# Version 20.03.95
# Insert the defs for your machine
# SUN:    	CC = CC         CCL = CC         LM = 
# SGI,OSF	CC = cc         CCL = cc         LM = -lm
# LINUX,FreeBSD CC = cc         CCL = cc         LM = -lm
# ULT     	CC = gcc -c -g  CCL = gcc -g     LM = 
# HP:     	CC = cc -Aa     CCL = cc         LM = -lM
# SOL 2.6 	CC = CC         CCL = CC         LM = -lsocket -lnsl

INCL = /usr/include/tine
LIBS = /usr/lib
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/servdef.h \
	${INCL}/errors.h \
	${INCL}/rpctypes.h \
	${INCL}/rpcdefs.h \
	${INCL}/almsrv.h

CC = cc -c -I${INCL}
CCL = cc
LM = -lm

mexcln: mexcln.o mexlib.o ${LIBS}/libtine.a
	${CCL} -o mexcln mexlib.o ${LIBS}/libtine.a mexcln.o ${LM}

mexlib.o:  mexlib.c netmex.h ${HDRS}
	${CC} mexlib.c

mexcln.o:  mexcln.c ${HDRS}
	${CC} mexcln.c

clean:
	rm *.o
