# Makefile for client test program - PKTR rpc calls
# Version 20.03.95
# Insert the defs for your machine
# SUN:    CC = CC         CCL = CC         LM = 
# SGI,OSF CC = cc         CCL = cc         LM = -lm
# LINUX   CC = cc         CCL = cc         LM = -lm
# ULT     CC = gcc -c -g  CCL = gcc -g     LM = 
# HP:     CC = cc -Aa     CCL = cc         LM = -lM
# SOL 2.6 CC = CC         CCL = CC         LM = -lsocket -lnsl

INCL = .
LIBS = .
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/servdef.h \
	${INCL}/errors.h \
	${INCL}/rpctypes.h \
	${INCL}/rpcdefs.h \
	${INCL}/almsrv.h

CPP = g++ -I${INCL}
CCL = nios-elf-ld -e _start -u _start -g -T /cygdrive/d/altera/excalibur/sopc_builder_2_5/bin/nios.ld ../lib/obj32/nios_jumptostart.s.o
CCLA = --start-group -l nios32 -l c -l m -l gcc -l c -l nios32 --end-group -L/cygdrive/d/altera/excalibur/sopc_builder_2_5/bin/nios-gnupro/nios-elf/lib/m32 -L/cygdrive/d/altera/excalibur/sopc_builder_2_5/bin/nios-gnupro/lib/gcc-lib/nios-elf/2.9-nios-010801-20020103/m32 -L../lib -L../../lib -L../../../lib -L../../../../lib
CC = nios-elf-gcc -c -I../inc -I${INCL} -O2 -mno-zero-extend -m32
LM = -lm -lc -lnios32 -lgcc

rpcserv: rpcserv.o sinsrv.o ${LIBS}/libtine.a
	${CCL} -o rpcserv rpcserv.o sinsrv.o nios_bsdlib.c.o libtine.a ${CCLA}

rpcserv.o: rpcserv.c ${HDRS}
	${CC} rpcserv.c

sinsrv.o: sinsrv.c ${HDRS}
	${CC} sinsrv.c

clean:
	rm *.o
