Attribute VB_Name = "Module1"
Global Const NUMEQP = 512
Global Const PARAMDEPTH = 64
Global Const cfgfile$ = "archmgr.csv"
Global Const g_numFilterOptions = 17
Type HSTRECORD
  idx As Integer
  srv As String
  prp As String
  dev As String
  len As Integer
  fmt As String
  hbt As Long
  rate As Long
  tol As String
End Type
Type ARCRECORD
    rec As Integer
    srv As String
    prp As String
    dev As String
    len As Integer
    fmt As String
    inputFile As String
    hbt As Long
    rate As Long
    ftr As String
    stcFile As String
    active As Integer
    rsp As String
End Type

Type FECSTRUCT
    eqm As String
    prop As String
    dev As String
    len As Integer
    fmt As String
    rectyp As Integer
    comment As String
    sfname As String
    active As Integer
    responsible As String
    recIndex As Integer
    nparam As Integer
End Type
Global fec(NUMEQP) As FECSTRUCT
Type PARAMSTRUCT
'Keyword,Format,Size,Units,Maximum,Minimum,Tolerance,Plot,NETMEX,Comment
    kwd As String
    fmt As String
    siz As String
    egu As String
    max As String
    min As String
    tol As String
    plt As String
    cmt As String
End Type
Global vname$(NUMEQP, PARAMDEPTH), vfmt$(NUMEQP, PARAMDEPTH), vcmt$(NUMEQP, PARAMDEPTH)
Global vmax#(NUMEQP, PARAMDEPTH), vmin#(NUMEQP, PARAMDEPTH), vunit$(NUMEQP, PARAMDEPTH), vsize%(NUMEQP, PARAMDEPTH)
Global fref%(NUMEQP), pref%(NUMEQP), nexti%, nextp%, nextf%
Function AppendDatabase(fname$, nsvrs%, nparam%) As Integer
' add a record
' is record name already there ? -> deactivate

End Function
Function writeDataBase(fname$, nsvrs%, nparam%) As Integer
dpos# = 1
fname$ = dbPath$ + fname$
If Dir(fname$) = "" Then
  writeDataBase = 0
  Exit Function
End If
hdr$ = "Record Type,Name,Property,Device,data length,RPC Format,"
hdr$ = hdr$ + "data input,Heartbeat,Polling Rate,Archive,Structure,Active,Responsibility"
phdr$ = "Keyword,Format,Size,Units,Maximum,Minimum,Comment"
Open fname$ For Output As #1
Print #1, hdr$
For i% = 0 To nsvrs% - 1
  a$ = str$(fec(i%).rectyp) + "," + fec(i%).eqm + "," + fec(i%).prop + "," + fec(i%).dev
  a$ = a$ + "," + str$(fec(i%).len) + "," + fec(i%).fmt + "," + fec(i%).sfname
  a$ = a$ + "," + str$(fec(i%).active) + "," + fec(i%).responsible
  Print #1, a$
  If fec(i%).active Then
    sfname$ = dbPath$ + "INFO\" + fec(i%).sfname$: done = 0
    Open sfname$ For Output As #2
    Print #2, phdr$
    For j% = 0 To fec(i%).nparam - 1
      a$ = vname$(i%, j%) + "," + vfmt$(i%, j%) + "," + str$(vsize%(i%, j%))
      a$ = a$ + vunit$(i%, j%) + "," + str$(vmax#(i%, j%)) + "," + str$(vmin#(i%, j%))
      a$ = a$ + vcmt$(i%, j%)
      Print #2, a$
    Next
    Close 2
  End If
Next
Close 1
writeDataBase = nsvrs%
End Function
Function readDataBase(fname$, nsvrs%, nparam%) As Integer
dpos# = 1
type_done = False
fname$ = dbPath$ + fname$
If Dir(fname$) = "" Then
  readDataBase = 0
  Exit Function
End If
Open fname$ For Input Access Read Shared As #1
i% = 0: p% = 0
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" Then
    If Not type_done Then
      rec_col = colptr(a$, "Record Type")
      name_col = colptr(a$, "Name")
      prop_col = colptr(a$, "Property")
      dev_col = colptr(a$, "Device")
      len_col = colptr(a$, "data length")
      fmt_col = colptr(a$, "RPC Format")
      sf_col = colptr(a$, "Structure")
      act_col = colptr(a$, "Active")
      rsp_col = colptr(a$, "Responsibility")
      type_done = True
    Else
      fec(i%).rectyp = Val(getcol(a$, rec_col))
      fec(i%).eqm = getcol(a$, name_col)
      fec(i%).prop = getcol(a$, prop_col)
      fec(i%).dev = getcol(a$, dev_col)
      fec(i%).len = Val(getcol(a$, len_col))
      fec(i%).fmt = getcol(a$, fmt_col)
      fec(i%).sfname$ = getcol(a$, sf_col)
      fec(i%).active = Val(getcol(a$, act_col))
      fec(i%).responsible = getcol(a$, rsp_col)
      
      fec(i%).rectyp = fec(i%).rectyp + Offset - 1
      If fec(i%).active Then
        j% = 0: sfname$ = dbPath$ + "INFO\" + fec(i%).sfname$: done = 0
        Open sfname$ For Input Access Read Shared As #2
        Do
          Line Input #2, a$
          tok$ = Left$(a$, 1)
          If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And Len(a$) > 7 Then
            If Not done Then
              kwd_col = colptr(a$, "Keyword")
              fmt_col = colptr(a$, "Format")
              siz_col = colptr(a$, "Size")
              uni_col = colptr(a$, "Units")
              max_col = colptr(a$, "Maximum")
              min_col = colptr(a$, "Minimum")
              cmt_col = colptr(a$, "Comment")
              done = True
            Else
              vname$(i%, j%) = getcol(a$, kwd_col)
              vfmt$(i%, j%) = getcol(a$, fmt_col)
              vsize%(i%, j%) = Val(getcol(a$, siz_col))
              vunit$(i%, j%) = getcol(a$, uni_col)
              vmax#(i%, j%) = Val(getcol(a$, max_col))
              vmin#(i%, j%) = Val(getcol(a$, min_col))
              vcmt$(i%, j%) = getcol(a$, cmt_col)
              fref%(p%) = i%: pref%(p%) = j%
              If maxsize% < vsize(i%, j%) Then maxsize% = vsize%(i%, j%)
              p% = p% + 1: j% = j% + 1
            End If
          End If
        Loop While Not EOF(2)
        Close 2
        fec(i%).nparam = j%
        i% = i% + 1
      End If
    End If
  End If
Loop While Not EOF(1)
Close 1

readDataBase = p%
nsvrs% = i%
nparam% = p%
End Function
