// =============================================================
// ==
// ==   Dataserver routine: herastatebase.c
// ==
// =============================================================
#include "prolog.h"
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <stdio.h>
#include <fcntl.h>
#include <malloc.h>
#include <ctype.h>
#include <signal.h>
#include <dirent.h>
#include "fecerr.h"
#include "rpctypes.h"
#include "database.h"
#include "almsrv.h"
#include "errors.h"
#include "archive.h"
#include "toolkit.h"

extern FEC *fec;

// important initialization:
int iHPenergy;
double HPCur = -1,HPTau = -1,HECur = -1,HETau = -1;
float fminus = -1;
float *HPenergy = &fminus,*HEenergy = &fminus;

// state variables:
extern int ramping, running, beam, lumi;
extern int Pramping, Eramping, Pbeam, Ebeam;
extern int Prunning, Erunning;
extern int DclEramping, DclPramping, DclLumi;
extern int DclEInj, DclPInj; 

void updateStateInfo(int i, int j,int cc)
{
  float *fptr;
  int k;
  static int STpanic = 0;
  char *c;
  
  if (!strcmp(fec[i].fecdata[j].param,"D3STATE"))
  {
    Prunning = FALSE;
    c = (char *)(fec[i].data+fec[i].fecdata[j].offset);
    if (!strncmp("Operating",c,7)) Prunning = TRUE;
    if (cc)            // there's something wrong
    {
      if (++STpanic > 3)
      {
        SetAlarm("FILER",0,state_undefined,NULL);
      }
    }
    else               // everything's okay
    {
      STpanic = 0;
      ClearAlarm("FILER",0);            
    }
    goto fixstate;
  }
fixstate:
  lumi = DclLumi;
  running = Erunning | Prunning;
  beam = Ebeam | Pbeam;
  ramping = DclEramping | DclPramping; 
}

int overloadEqpmod(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access)
{
  int cc, i, j, n;
  char prop[32], *c;
  short stateArray[7];
  short dsize,EqNo = 0,fmt;                                                     

  return illegal_property;
}
extern void cbackBrdsrv(int id,int cc);
int GlobalsRegistrationEx(void)
{
  DTYPE din;   
  // for historical reasons:
}

