VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "ENS Administration"
   ClientHeight    =   3480
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4395
   Icon            =   "fecadmin.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3480
   ScaleWidth      =   4395
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdRemoveDeviceServer 
      Caption         =   "Remove Device Server"
      Height          =   495
      Left            =   2310
      TabIndex        =   4
      Top             =   2880
      Width           =   1905
   End
   Begin VB.CommandButton cmdRemoveFec 
      Caption         =   "Remove FEC"
      Height          =   495
      Left            =   240
      TabIndex        =   3
      Top             =   2880
      Width           =   1905
   End
   Begin VB.ListBox lstDeviceServers 
      Height          =   2400
      Left            =   2280
      TabIndex        =   2
      Top             =   420
      Width           =   1935
   End
   Begin VB.ComboBox cmbContexts 
      Height          =   315
      Left            =   180
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   60
      Width           =   1965
   End
   Begin VB.ListBox lstFecNames 
      Height          =   2400
      Left            =   210
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   420
      Width           =   1935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim nfecs As Integer, ncontexts As Integer, nservers As Integer
Dim fecNames() As String
Dim contexts() As String
Dim servers() As String

Private Sub cmbContexts_Click()
Dim contxt$
lstFecNames.Clear
contxt$ = cmbContexts.text
If contxt$ = "DEFAULT" Then contxt$ = ""
rc% = GetFecsFromNameServer(contxt$, fecNames(), nfecs)
For i = 0 To nfecs - 1
  If (Len(fecNames(i)) > 0) And (fecNames(i) <> "ENS") Then lstFecNames.AddItem fecNames(i)
Next
If lstFecNames.ListCount > 0 Then lstFecNames.ListIndex = 0
End Sub

Sub fillContextCombo()
cmbContexts.Clear
rc% = GetEquipmentDeviceContexts(contexts(), ncontexts)
If rc% Then
  MsgBox RPCERROR(rc%)
  Exit Sub
End If
cmbContexts.AddItem "DEFAULT"
For i = 0 To ncontexts - 1
  cmbContexts.AddItem contexts(i)
Next
If cmbContexts.ListCount > 0 Then cmbContexts.ListIndex = 0
End Sub

Private Sub cmdRemoveDeviceServer_Click()
Dim dbout As DBLK
Dim dbin As DBLK
Dim devName As String
Dim devnm As NAME16
Dim rc As Integer, i%
Dim msg$

dbin.dArrayLength = 1: dbin.dFormat = CF_NAME16
BARR devnm.nam(), lstDeviceServers.text
dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
devName = "ENS/" + cmbContexts.text

msg$ = "Remove Device Server : " + lstDeviceServers.text + vbNewLine
rc = MsgBox(msg$, vbOKCancel, "Remove Entry From ENS")
If rc = vbCancel Then Exit Sub

rc = T_EXECLINK(devName, "REMOVE", dbout, 0, dbin, devnm, CA_READ + CA_WRITE, 1000)
If rc = 0 Then Call cmbContexts_Click Else MsgBox RPCERROR(rc)
End Sub

Private Sub cmdRemoveFec_Click()
Dim dbout As DBLK
Dim dbin As DBLK
Dim devName As String
Dim fecnm As NAME16
Dim rc As Integer, i%
Dim msg$

dbin.dArrayLength = 1: dbin.dFormat = CF_NAME16
BARR fecnm.nam(), lstFecNames.text
dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
devName = "ENS/FEC"

msg$ = "Remove Front End Computer : " + lstFecNames.text + vbNewLine
For i% = 0 To lstDeviceServers.ListCount - 1
  msg$ = msg$ + "            Device Server : " + lstDeviceServers.List(i%) + vbNewLine
Next
rc = MsgBox(msg$, vbOKCancel, "Remove Entry From ENS")
If rc = vbCancel Then Exit Sub
rc = T_EXECLINK(devName, "REMOVE", dbout, 0, dbin, fecnm, CA_READ + CA_WRITE, 1000)
If rc = 0 Then Call cmbContexts_Click Else MsgBox RPCERROR(rc)
End Sub

Private Sub Form_Load()
Call fillContextCombo
End Sub

Private Sub lstFecNames_Click()
lstDeviceServers.Clear
rc% = GetEquipmentDeviceServers(cmbContexts.text, lstFecNames.text, servers(), nservers)
If rc% Then
  If rc% = link_not_opern% Then MsgBox RPCERROR(rc%)
  Exit Sub
End If
If nservers = 0 Then Exit Sub
For i = 0 To nservers - 1
  lstDeviceServers.AddItem servers(i)
Next
If lstDeviceServers.ListCount > 0 Then lstDeviceServers.ListIndex = 0

End Sub
