VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "FEC Setup"
   ClientHeight    =   2760
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7335
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   2760
   ScaleWidth      =   7335
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame8 
      Caption         =   "Subsystem"
      Height          =   645
      Left            =   4920
      TabIndex        =   14
      Top             =   1440
      Width           =   2355
      Begin VB.ComboBox subsysCombo 
         Height          =   315
         Left            =   150
         Style           =   2  'Dropdown List
         TabIndex        =   15
         Top             =   210
         Width           =   2055
      End
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Done"
      Height          =   495
      Left            =   5670
      TabIndex        =   12
      Top             =   2160
      Width           =   1635
   End
   Begin VB.Frame Frame7 
      Caption         =   "Description"
      Height          =   645
      Left            =   30
      TabIndex        =   10
      Top             =   1440
      Width           =   4845
      Begin VB.TextBox DescriptionText 
         Height          =   375
         Left            =   90
         TabIndex        =   11
         Text            =   "Text1"
         Top             =   180
         Width           =   4605
      End
   End
   Begin VB.Frame Frame6 
      Caption         =   "Hardware"
      Height          =   615
      Left            =   4860
      TabIndex        =   8
      Top             =   780
      Width           =   2415
      Begin VB.TextBox HardwareText 
         Height          =   345
         Left            =   90
         TabIndex        =   9
         Text            =   "Text1"
         Top             =   180
         Width           =   2235
      End
   End
   Begin VB.Frame Frame5 
      Caption         =   "Location"
      Height          =   615
      Left            =   2490
      TabIndex        =   6
      Top             =   780
      Width           =   2355
      Begin VB.TextBox LocationText 
         Height          =   345
         Left            =   90
         TabIndex        =   7
         Text            =   "Text1"
         Top             =   180
         Width           =   2145
      End
   End
   Begin VB.Frame Frame4 
      Caption         =   "Responsible"
      Height          =   615
      Left            =   60
      TabIndex        =   4
      Top             =   780
      Width           =   2415
      Begin VB.TextBox ResponsibleText 
         Height          =   345
         Left            =   90
         TabIndex        =   5
         Text            =   "Text1"
         Top             =   180
         Width           =   2235
      End
   End
   Begin VB.Frame Frame3 
      Caption         =   "Context"
      Height          =   645
      Left            =   4860
      TabIndex        =   3
      Top             =   90
      Width           =   2385
      Begin VB.ComboBox ContextCombo 
         Height          =   315
         Left            =   120
         TabIndex        =   16
         Text            =   "TEST"
         Top             =   240
         Width           =   2145
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "FEC Name"
      Height          =   645
      Left            =   2490
      TabIndex        =   1
      Top             =   90
      Width           =   2355
      Begin VB.TextBox FecNameText 
         Height          =   345
         Left            =   60
         TabIndex        =   2
         Text            =   "Text1"
         Top             =   210
         Width           =   2145
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Exported Device Server Name"
      Height          =   645
      Left            =   60
      TabIndex        =   0
      Top             =   90
      Width           =   2415
      Begin VB.ComboBox ExportName 
         Height          =   315
         Left            =   120
         TabIndex        =   13
         Top             =   240
         Width           =   2205
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Const DBPATH$ = "FECDB"
Private Type fec
  fecname As String '* 16
  ExpName As String '* 16
  context As String '* 16
  os As String '* 12
  desc As String '* 64
  loc As String '* 32
  hdw As String '* 48
  resp As String '* 32
  portoffset As Integer
End Type
Private Type subsysInfo
  subsysName As String
  subsysTag As String
End Type
Dim subs(100) As subsysInfo
Dim nsubs As Integer
Dim fecs(100) As fec
Dim nfecs As Integer
Dim fecdb$
Dim exportNameAdded As Boolean
Private Const ContextConfigFile$ = "contexts.txt"
Private Sub Command1_Click()
AppendFecInformation fecdb$, ExportName.text
EndApplication
End Sub

Private Sub ExportName_Change()
If Not exportNameAdded Then
  offerDefaults
  exportNameAdded = True
End If
End Sub

Private Sub ExportName_Click()
Dim i As Integer, j As Integer
Dim subsys As String
i = ExportName.ListIndex
ContextCombo.text = "TEST"
For j = 0 To ContextCombo.ListCount - 1
  If fecs(i).context = ContextCombo.List(j) Then
    ContextCombo.text = fecs(i).context
    Exit For
  End If
Next
ResponsibleText.text = fecs(i).resp
HardwareText.text = fecs(i).hdw
LocationText.text = fecs(i).loc
j = InStr(fecs(i).desc, "]")
If j > 0 Then
  subsys = Left$(fecs(i).desc, j)
  subsysCombo.ListIndex = subsysCombo.ListCount - 1
  DescriptionText.text = Right(fecs(i).desc, Len(fecs(i).desc) - j)
  For j = 0 To nsubs - 1
    If subsys = subs(j).subsysTag Then
      subsysCombo.ListIndex = j
      Exit For
    End If
  Next
Else
  DescriptionText.text = fecs(i).desc
End If
FecNameText.text = fecs(i).fecname
exportNameAdded = False
End Sub

Private Sub Form_Load()
Dim setenv As Boolean

'On Error GoTo fecsetupError
fecdb$ = Environ$(DBPATH$)
If Len(fecdb$) = 0 Then ' not set
  setenv = True
Else
  If Right$(fecdb$, 1) <> "\" Then
    fecdb$ = fecdb$ + "\"
    setenv = True
  End If
End If
If setenv Then ' not set
  envstr$ = "SETX.EXE " + DBPATH$ + " C:\DATABASE\ -m"
  Shell (envstr$)
  fecdb$ = "C:\DATABASE\"
End If

fecdir$ = Dir(fecdb$)
If Len(fecdir$) = 0 Then ' doesn't exist
  MkDir fecdb$
  fecdb$ = fecdb$ + "fecid.csv"
  Open fecdb$ For Output As #1
  Close 1
Else
  fecdb$ = fecdb$ + "fecid.csv"
End If

fillinContextCombo
fillinSubsystemCombo

' Append FEC information
GetFecInformation fecdb$
If ExportName.ListCount > 0 Then
  ExportName.ListIndex = 0
Else
  offerDefaults
End If
Exit Sub
fecsetupError:
Resume Next
End Sub
Sub fillinContextCombo()
Dim a$, tok$
ContextCombo.AddItem "TEST"
On Error GoTo fillinContextComboError
Dim fn As String
fn = App.Path + "\" + ContextConfigFile$
Open fn For Input Access Read Shared As #1
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" Then
    ContextCombo.AddItem a$
  End If
Loop While Not EOF(1)
Close 1
fillinContextComboError:
ContextCombo.ListIndex = 0
End Sub
Sub fillinSubsystemCombo()
Dim i As Integer
subs(0).subsysName = "Diagnostics": subs(0).subsysTag = "[DIA]"
subs(1).subsysName = "RF": subs(1).subsysTag = "[RF]"
subs(2).subsysName = "Vacuum": subs(2).subsysTag = "[VAC]"
subs(3).subsysName = "Quench": subs(3).subsysTag = "[QUE]"
subs(4).subsysName = "Magnets": subs(4).subsysTag = "[MAG]"
subs(5).subsysName = "Tunes/FB": subs(5).subsysTag = "[TUN]"
subs(6).subsysName = "Injection": subs(6).subsysTag = "[INJ]"
subs(7).subsysName = "Experiments": subs(7).subsysTag = "[EXP]"
subs(8).subsysName = "Services": subs(8).subsysTag = "[SER]"
subs(9).subsysName = "Netmex": subs(9).subsysTag = "[MEX]"
subs(10).subsysName = "Subsystems": subs(10).subsysTag = "[SUB]"
subs(11).subsysName = "Timing": subs(11).subsysTag = "[TIM]"
subs(12).subsysName = "Cryogenics": subs(12).subsysTag = "[CRY]"
subs(13).subsysName = "Tests": subs(13).subsysTag = "[TST]"
nsubs = 14
For i = 0 To nsubs - 1
  subsysCombo.AddItem subs(i).subsysName
Next
subsysCombo.ListIndex = 0
End Sub
Sub AppendFecInformation(fecdb$, expnam$)
Dim fs, f, S, ts
Dim hdr$, ln$
Dim i As Integer, poff As Integer
Dim fecnm$, cntxt$, rsp$, dsc$, loc$, hdw$, expn$
Dim expfound As Boolean
Set fs = CreateObject("Scripting.FileSystemObject")
If fs.FileExists(fecdb$) Then
  Set f = fs.GetFile(fecdb$)
  f.Copy fecdb$ + "-bak", True
  Set ts = f.OpenAsTextStream(2, -2)
Else
  Set ts = fs.CreateTextFile(fecdb$)
End If
'fs.CreateTextFile fecdb$
'Set f = fs.GetFile(fecdb$)
hdr$ = "Fec_Name,Context,Export_Name,Port_Offset,Description,Location,Hardware,Responsible"
ts.WriteLine hdr$
For i = 0 To nfecs - 1
 If fecs(i).ExpName = expnam$ Then expfound = True
 ln$ = fecs(i).fecname + "," + fecs(i).context + "," + fecs(i).ExpName + "," + str$(fecs(i).portoffset) + ","
 ln$ = ln$ + fecs(i).desc + "," + fecs(i).loc + "," + fecs(i).hdw + "," + fecs(i).resp
 ts.WriteLine ln$
 If fecs(i).portoffset >= poff Then poff = fecs(i).portoffset + 1
 cntxt$ = fecs(i).context
Next
If Not expfound Then
    cntxt$ = ContextCombo.text
    rsp$ = ResponsibleText.text
    hdw$ = HardwareText.text
    loc$ = LocationText.text
    If (Left$(DescriptionText.text, 1) = "[") And InStr(DescriptionText.text, "]") > 0 Then
      dsc$ = DescriptionText.text
    Else
      dsc$ = subs(subsysCombo.ListIndex).subsysTag + DescriptionText.text
    End If
    fecnm$ = FecNameText.text
    expn$ = ExportName.text
    ln$ = fecnm$ + "," + cntxt$ + "," + expn$ + "," + str$(poff) + ","
    ln$ = ln$ + dsc$ + "," + loc$ + "," + hdw$ + "," + rsp$
    ts.WriteLine ln$
End If
ts.Close
End Sub
Sub GetFecInformation(fecdb$)
Dim done
Dim name_col As Integer, export_col As Integer, context_col As Integer, loc_col As Integer
Dim resp_col As Integer, desc_col As Integer, hdw_col As Integer, poff_col As Integer
Dim i As Integer, poff As Integer
Dim dsc As String

On Error GoTo AppendFecInformationError

Open fecdb$ For Input Access Read Shared As #1
i% = 0
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" Then
    If Not done Then
      name_col = colptr(a$, "FEC_NAME")
      export_col = colptr(a$, "EXPORT_NAME")
      context_col = colptr(a$, "CONTEXT")
      resp_col = colptr(a$, "RESPONSIBLE")
      desc_col = colptr(a$, "DESCRIPTION")
      hdw_col = colptr(a$, "HARDWARE")
      loc_col = colptr(a$, "LOCATION")
      poff_col = colptr(a$, "PORT_OFFSET")
      done = True
    Else
      fecs(i).fecname = getcol(a$, name_col)
      fecs(i).resp = getcol(a$, resp_col)
      
      dsc = getcol(a$, desc_col)
      If InStr(dsc, "]") = 0 Then
        fecs(i).desc = "[TST]" + dsc
      Else
        fecs(i).desc = dsc
      End If
      fecs(i).hdw = getcol(a$, hdw_col)
      fecs(i).loc = getcol(a$, loc_col)
      fecs(i).fecname = getcol(a$, name_col)
      If export_col >= 0 Then
        fecs(i).ExpName = getcol(a$, export_col)
      End If
      If context_col >= 0 Then
        fecs(i).context = getcol(a$, context_col)
      End If
      If poff_col >= 0 Then
        fecs(i).portoffset = Int(getcol(a$, poff_col))
        If fecs(i).portoffset >= poff Then poff = fecs(i).portoffset + 1
      End If
      If Len(fecs(i).ExpName) > 0 Then
        ExportName.AddItem fecs(i).ExpName
        i% = i% + 1
      End If
    End If
  End If
Loop While Not EOF(1)
AppendFecInformationError:
Close 1
nfecs = i%
End Sub
Sub offerDefaults()
Dim i As Integer, poff As Integer
ContextCombo.text = "TEST"
ResponsibleText.text = Environ$("USERNAME")
HardwareText.text = "none"
LocationText.text = ResponsibleText.text + "'s office"
DescriptionText.text = ResponsibleText.text + "'s test fec"
For i = 0 To nfecs - 1
  If fecs(i).portoffset >= poff Then poff = fecs(i).portoffset + 1
Next
FecNameText.text = Environ$("COMPUTERNAME") + "." + Trim$(str$(poff))
End Sub
Function FindExportName(fecdb$, expnam$) As Boolean
Dim done
Dim name_col As Integer, export_col As Integer
If Len(expnam$) = 0 Then
  FindExportName = False
  Exit Function
End If
On Error GoTo FindExportNameError
Open fecdb$ For Input Access Read Shared As #1
i% = 0
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" Then
    If Not done Then
      name_col = colptr(a$, "FEC_NAME")
      export_col = colptr(a$, "EXPORT_NAME")
      If export_col < 0 Then
        FindExportName = False
        Close 1
        Exit Function
      End If
      done = True
    Else
      ex$ = getcol(a$, export_col)
      If ex$ = expnam$ Then
        FindExportName = True
        Close 1
        Exit Function
      End If
    End If
  End If
Loop While Not EOF(1)
FindExportNameError:
Close 1
FindExportName = False
Exit Function
End Function
