Attribute VB_Name = "CLIENT1"
Global Const NUMEQP = 1500
Global Const NUMPROP = 1200
Global Const NUMDEV = 4000
Global Const PROPSET_QUERY = 512
Global Const PROPSET = 18
Global Const PROPSET_LNG = 18
Global Const PROPSET_SHT = 6
Global Const PARAMDEPTH = 100
Global Const MAX_ARRAYSIZE = 4096
Global Const MIN_TIMEOUT = 100
Global nRecs%, numEqm%, nl$, dmode%, off%
'Global ddat#(MAX_ARRAYSIZE), idat%(MAX_ARRAYSIZE), fdat!(MAX_ARRAYSIZE * 2), ldat&(MAX_ARRAYSIZE)
Global ddat#(), idat%(), fdat!(), ldat&()
Type CSTRING
  s As String * MAX_ARRAYSIZE
End Type
Global sdat As CSTRING
Global nam16dat(NUMEQP) As NAME16
Global fltintdat() As FLTINT
Global bdat() As Byte ' use a 32Kb byte 'blob' for exotic format types
Global histnames(100) As NAME32, nHistories%
Global pnam32(NUMPROP) As NAME32
Global pquery(NUMPROP / 10) As PropertyQuery
Global pqx(NUMPROP / 10) As PropertyQueryEx
Global xpq(NUMPROP / 10) As XPropertyQuery
Global nullquery As PropertyQueryEx
Global Const MAXNUMCONTEXTS = 50
Global numContexts%
Global contxts$(MAXNUMCONTEXTS)
Global DeviceContext$, DeviceSubSystem$
Global ndevices As Integer
Global devices(NUMDEV) As NAME16
Global eqnm$(NUMEQP), eqMxNo%
Global eqfltr$(50), neqfltr%
Type STRUCTINFO
 tag As String
 slen As Long
 sf(64) As INTINT
End Type
Global strctinfo(NUMPROP / 10) As STRUCTINFO
Global nRegisteredStructs As Integer
Type PROPINFO
  nam As String
  noverloads As Integer
  drawmode As Integer
  pq() As PropertyQueryEx
End Type
Global eqprpinfo(NUMEQP) As PROPINFO
Global eqnprop%(NUMEQP)
Global eqprop$(NUMPROP), eqpropDotNam$(NUMPROP / 2)
Global numDotNamEqp As Integer
Global defaultNumDevices As Integer
Global phist(NUMPROP) As Byte, pdone(NUMPROP) As Byte
Global nm_index%, prop_index%, sz_index&, type_index%
Global rpcerrStr As String * 80
Global datetime As String * 25
Global devicePrecedence As Boolean
Global propertyPrecedence As Boolean
Global CDBPATH$, DBPATH$
'Global Const DBPATH$ = "l:\database\archive\"
Global nparam%
Global g_nsubSystems As Integer
Type SUBSTYPE
  tag As String
  alias As String
End Type
Global g_subSystems(50) As SUBSTYPE
Global rtyp As String * 1
Type FECSTRUCT: eqm As String
                prop As String
                dev As String
                EqNo As Integer
                len As Integer
                fmt As String
                rectyp As Integer
                tstamp As Integer
                vnum As Integer
                comment As String
                responsible As String
                recIndex As Integer
End Type
Global fec(NUMEQP) As FECSTRUCT
Global vname$(NUMEQP, PARAMDEPTH), vfmt$(NUMEQP, PARAMDEPTH), vcmt$(NUMEQP, PARAMDEPTH)
Global vmax#(NUMEQP, PARAMDEPTH), vmin#(NUMEQP, PARAMDEPTH), vunit$(NUMEQP, PARAMDEPTH), vsize%(NUMEQP, PARAMDEPTH)
Global fref%(NUMEQP), pref%(NUMEQP), nexti%, nextp%, nextf%
Global rpcID%(NUMEQP), ddata#(NUMEQP)
Global statusID%, fecstat%(NUMEQP)
Global npktr%, nmex%, nfecs%, nlinks%, maxsize%
Global MKIoffset%, MEXoffset%
Global RPCdebug As Integer
Global AsyncID%, readID%
Global EqpName$, EQPproperty$, EQPsize&, EQPdev$, EQPStructTag$
Global eqpunits$, doAutoscale As Integer
Global rpcxmax As Single, rpcxmin As Single
Global showStockPrps As Boolean

Global eqs(200) As ElemQueryStruct

Global InputDataType As String
Global InputDataLength As Integer
Global writeAccess As Boolean
Global InstanceCount As Integer

'---- DLL function definitions -----
Declare Function LOADDLL Lib "tinecln32.dll" () As Integer
Declare Function EQPDEINIT Lib "tinecln32.dll" () As Integer
Declare Function GETEQPUSAGE Lib "tinecln32.dll" () As Integer


Function fecload(fname$, Offset%)
dpos# = 1
type_done = False
fname$ = DBPATH$ + fname$
If Dir(fname$) = "" Then
  fecload = 0
  Exit Function
End If
Open fname$ For Input Access Read Shared As #1
i% = Offset%: p% = nparam%
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" Then
    If Not type_done Then
      rec_col = colptr(a$, "Record Type")
      Name_col = colptr(a$, "Name")
      prop_col = colptr(a$, "Property")
      dev_col = colptr(a$, "Device")
      len_col = colptr(a$, "data length")
      fmt_col = colptr(a$, "RPC Format")
      sf_col = colptr(a$, "Structure")
      act_col = colptr(a$, "Active")
      rsp_col = colptr(a$, "Responsibility")
      type_done = True
    Else
      fec(i%).rectyp = Val(getcol(a$, rec_col))
      fec(i%).eqm = getcol(a$, Name_col)
      fec(i%).prop = getcol(a$, prop_col)
      fec(i%).dev = getcol(a$, dev_col)
      If fec(i).dev <> "" Then fec(i%).EqNo = Val(Right$(fec(i).dev, Len(fec(i).dev) - 1))
      fec(i%).len = Val(getcol(a$, len_col))
      fec(i%).fmt = getcol(a$, fmt_col)
      sfname$ = getcol(a$, sf_col)
      active% = Val(getcol(a$, act_col))
      fec(i%).responsible = getcol(a$, rsp_col)
      
      fec(i%).rectyp = fec(i%).rectyp + Offset - 1
      If active% Then
        j% = 0: sfname$ = DBPATH$ + "INFO\" + sfname$: done = 0
        Open sfname$ For Input Access Read Shared As #2
        Do
          Line Input #2, a$
          tok$ = Left$(a$, 1)
          If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And Len(a$) > 7 Then
            If Not done Then
              kwd_col = colptr(a$, "Keyword")
              fmt_col = colptr(a$, "Format")
              siz_col = colptr(a$, "Size")
              uni_col = colptr(a$, "Units")
              max_col = colptr(a$, "Maximum")
              min_col = colptr(a$, "Minimum")
              cmt_col = colptr(a$, "Comment")
              done = True
            Else
              vname$(i%, j%) = getcol(a$, kwd_col)
              vfmt$(i%, j%) = getcol(a$, fmt_col)
              vsize%(i%, j%) = Val(getcol(a$, siz_col))
              vunit$(i%, j%) = getcol(a$, uni_col)
              vmax#(i%, j%) = Val(getcol(a$, max_col))
              vmin#(i%, j%) = Val(getcol(a$, min_col))
              vcmt$(i%, j%) = getcol(a$, cmt_col)
              fref%(p%) = i%: pref%(p%) = j%
              If maxsize% < vsize(i%, j%) Then maxsize% = vsize%(i%, j%)
              p% = p% + 1: j% = j% + 1
            End If
          End If
        Loop While Not EOF(2)
        Close 2
        i% = i% + 1
      End If
    End If
  End If
Loop While Not EOF(1)
numEqm% = i%
Close 1

fecload = p% - nparam%
nparam% = p%
nfecs% = i%
Close 1

End Function

Function getStructIndexFromTag(ByVal tag As String)
Dim i As Integer
For i = 0 To nRegisteredStructs - 1
  If strctinfo(i).tag = tag Then Exit For
Next
If i < nRegisteredStructs Then
  getStructIndexFromTag = i
Else
  getStructIndexFromTag = -1
End If
End Function


