VERSION 5.00
Object = "{A8B3B723-0B5A-101B-B22E-00AA0037B2FC}#1.0#0"; "GRID32.OCX"
Object = "{3C5F82B2-2B3E-11D1-B429-00AA004115AF}#1.1#0"; "ACOP.ocx"
Begin VB.Form machine 
   Appearance      =   0  'Flat
   BackColor       =   &H00808000&
   Caption         =   "Current HERA Machine Parameters"
   ClientHeight    =   6330
   ClientLeft      =   1380
   ClientTop       =   420
   ClientWidth     =   8100
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Icon            =   "MACHINE.frx":0000
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   6330
   ScaleWidth      =   8100
   Begin ACOPLib.ACOP mparam 
      Height          =   375
      Left            =   5730
      TabIndex        =   6
      Top             =   5880
      Visible         =   0   'False
      Width           =   465
      _Version        =   65537
      _ExtentX        =   820
      _ExtentY        =   661
      _StockProps     =   47
      ForeColor       =   0
      BackColor       =   16777215
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      AccessRate      =   "30000"
      AccessMode      =   "POLL"
      XAxisLabel      =   ""
      YAxisLabel      =   ""
      Status          =   ""
      RandomData      =   0   'False
   End
   Begin VB.CommandButton Command1 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Print"
      Height          =   315
      Left            =   6300
      TabIndex        =   2
      Top             =   5940
      Width           =   735
   End
   Begin VB.CommandButton BACK 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "BACK"
      Height          =   315
      Left            =   7200
      TabIndex        =   1
      Top             =   5940
      Width           =   735
   End
   Begin VB.PictureBox rpcerrbox 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   555
      Left            =   60
      Picture         =   "MACHINE.frx":030A
      ScaleHeight     =   525
      ScaleWidth      =   525
      TabIndex        =   0
      Top             =   5760
      Visible         =   0   'False
      Width           =   555
   End
   Begin MSGrid.Grid MachineGrid 
      Height          =   5535
      Left            =   120
      TabIndex        =   5
      Top             =   120
      Width           =   7695
      _Version        =   65536
      _ExtentX        =   13573
      _ExtentY        =   9763
      _StockProps     =   77
      BackColor       =   16777215
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Label timelab 
      Appearance      =   0  'Flat
      BackColor       =   &H00FFFFC0&
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   315
      Left            =   3720
      TabIndex        =   4
      Top             =   5880
      Width           =   1815
   End
   Begin VB.Label datelab 
      Appearance      =   0  'Flat
      BackColor       =   &H00FFFFC0&
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   315
      Left            =   1140
      TabIndex        =   3
      Top             =   5880
      Width           =   2175
   End
End
Attribute VB_Name = "machine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim strdata As String * 80
Dim n8dat(100) As NAME8
Dim n16dat(100) As NAME16
Dim n32dat(100) As NAME32
Dim gridPos(500) As Integer

Private Sub BACK_Click()
Unload machine
End Sub

Private Sub Command1_Click()
machine.Print
End Sub

Private Sub Form_Load()
On Error GoTo err_handler
MachineGrid.Rows = nlinks% + 1
MachineGrid.Cols = maxsize% + 4
MachineGrid.Row = 0
MachineGrid.col = 0: MachineGrid.text = "Parameter"
MachineGrid.col = 1: MachineGrid.text = "Description"
MachineGrid.col = 2: MachineGrid.text = "Units"
MachineGrid.col = 3: MachineGrid.text = "Time"
MachineGrid.col = 4: MachineGrid.text = "Value"
MachineGrid.ColWidth(0) = 1200
MachineGrid.ColWidth(1) = 2000
MachineGrid.ColWidth(2) = 1200
MachineGrid.ColWidth(3) = 1000
For i% = 4 To maxsize% + 3
  MachineGrid.ColWidth(i%) = 1000
Next i%
n% = 0
For i% = 0 To nlinks% - 1
  f% = fref%(i%): p% = pref%(i%)
  prop$ = vname$(f%, p%)
  comment$ = vcmt$(f%, p%)
  units$ = vunit$(f%, p%)
  siz% = vsize(f%, p%)
  Select Case vfmt$(f%, p%)
    Case "char": fmt% = CF_TEXT
    Case "long", "unsigned long": fmt% = CF_LONG
    Case "double": fmt% = CF_DOUBLE
    Case "short", "int", "integer": fmt% = CF_INTEGER
    Case "float": fmt% = CF_FLOAT
    Case Else:
      fmt% = 0
  End Select
  If siz% > 100 Then
    siz% = 100
    vsize(f%, p%) = 100
  End If
  If i% < npktr% Then
    mparam.deviceName = "HERADATA/#0"
  Else
    mparam.deviceName = "MEXDATA/#0"
  End If
  mparam.deviceProperty = prop$
  If prop$ <> "dummy" Then
    rpcID%(i%) = mparam.OpenLink(, siz%, vfmt$(f%, p%))
    If rpcID%(i%) < 0 Then
      MsgBox prop$ + " : " + mparam.Status
      Exit For
    End If
    MachineGrid.Row = n% + 1
    MachineGrid.col = 0: MachineGrid.text = prop$
    MachineGrid.col = 1: MachineGrid.text = comment$
    MachineGrid.col = 2: MachineGrid.text = units$
    gridPos(i%) = n%
    n% = n% + 1
  End If
Next i%
machine.Left = 0: machine.Top = 0
Exit Sub
err_handler:
Resume
End Sub

Private Sub Form_Resize()
If WindowState = 1 Then Exit Sub
MachineGrid.Height = machine.ScaleHeight - 675
MachineGrid.Width = machine.Width - MachineGrid.Left * 2
BACK.Top = MachineGrid.Height + 100: BACK.Left = MachineGrid.Width - BACK.Width
Command1.Top = MachineGrid.Height + 100: Command1.Left = BACK.Left - Command1.Width - 100
datelab.Top = MachineGrid.Height + 150
timelab.Top = MachineGrid.Height + 150
End Sub

Private Sub Form_Unload(cancel As Integer)
mparam.CloseLink
End Sub

Private Sub mparam_Receive(ByVal LinkIndex As Long, ByVal StatusCode As Long)
Static LONGtime&
On Error GoTo DataError
For i% = 0 To nlinks%
  If rpcID(i%) = LinkIndex Then Exit For
Next
If i% = nlinks% Then Exit Sub
    
If StatusCode Then
    MachineGrid.Row = gridPos(i%) + 1
    MachineGrid.col = 4
    MachineGrid.text = mparam.Status
    Exit Sub
End If
f% = fref%(i%): p% = pref%(i%): siz% = vsize(f%, p%)
Select Case vfmt$(f%, p%)
  Case "char", "string":
    cc& = mparam.GetData(strdata, , rpcID%(i%))
    updateGridLine gridPos(i%), siz%, CF_TEXT, cc&
  Case "string8", "char8", "name8":
    cc& = mparam.GetData(n8dat(0).nam, , rpcID%(i%))
    updateGridLine gridPos(i%), siz%, CF_NAME8, cc&
  Case "string16", "char16", "name16":
    cc& = mparam.GetData(n16dat(0).nam, , rpcID%(i%))
    updateGridLine gridPos(i%), siz%, CF_NAME16, cc&
  Case "string32", "char32", "name32":
    cc& = mparam.GetData(n32dat(0).nam, , rpcID%(i%))
    updateGridLine gridPos(i%), siz%, CF_NAME32, cc&
  Case "long":
    cc& = mparam.GetData(ldat, , rpcID%(i%))
    updateGridLine gridPos(i%), siz%, CF_LONG, cc&
  Case "int", "short", "integer":
    cc& = mparam.GetData(idat, , rpcID%(i%))
    updateGridLine gridPos(i%), siz%, CF_SHORT, cc&
  Case "double":
    cc& = mparam.GetData(ddat, , rpcID%(i%))
    updateGridLine gridPos(i%), siz%, CF_DOUBLE, cc&
  Case "float", "single":
    cc& = mparam.GetData(fdat, , rpcID%(i%))
    updateGridLine gridPos(i%), siz%, CF_FLOAT, cc&
End Select
MachineGrid.col = 3
MachineGrid.text = mparam.CTIME(mparam.timestamp)
timelab.Caption = " " + time$: datelab.Caption = " " + date$
Exit Sub
DataError:
 Resume Next
End Sub
Sub updateGridLine(ByVal r As Integer, ByVal ncol As Integer, ByVal fmt As Integer, ByVal cc As Long)
    If cc Then fmt = -1
    MachineGrid.Row = r + 1
    For j% = 4 To ncol + 3
      MachineGrid.col = j%
      Select Case fmt
        Case CF_TEXT:
        l = InStr(strdata, Chr(0)): If l > 0 Then l = l - 1 Else l = ncol
        sdata$ = Left$(strdata, l)
        MachineGrid.text = sdata$
        Exit For
        Case CF_NAME8:
        sdata$ = BSTR(n8dat(j% - 4).nam)
        Case CF_NAME16:
        sdata$ = BSTR(n16dat(j% - 4).nam)
        Case CF_NAME32:
        sdata$ = BSTR(n32dat(j% - 4).nam)
        Case CF_LONG:
        ld& = ldat&(j% - 4)
        sdata$ = str$(ld&)
        Case CF_SHORT:
        sd% = idat%(j% - 4)
        sdata$ = str$(sd%)
        Case CF_DOUBLE:
        dd# = ddat#(j% - 4)
        sdata$ = str$(dd#)
        Case CF_FLOAT:
        fd! = fdat!(j% - 4)
        If fd! > 10000 Then
          sdata$ = Format$(fd!, "0.000E-00")
        Else
          sdata$ = Format$(fd!, "0.000")
        End If
        Case -1:
        strdata = mparam.Status
        l = InStr(strdata, Chr(0)): If l > 0 Then l = l - 1
        sdata$ = Left$(strdata, l)
        MachineGrid.text = sdata$
        Exit Sub
        Debug.Print vname$(f%, p%) + " : " + mparam.Status
     End Select
      MachineGrid.text = sdata$
    Next j%
End Sub
