Attribute VB_Name = "Winsrv"

Public Type NET_PROCINFO
    name As String * 256
    running As Integer
    auto_restart As Integer
    started As Long
    stopped As Long
    check_hbeat As Integer
    reserved As Integer
End Type
Public Net_ProcDef As NET_PROCINFO

Declare Function Address Lib "winsrv32.dll" (r As Any) As Long
Declare Function CADDR Lib "winsrv32.dll" (r As Any) As Long
Declare Function UTIME Lib "winsrv32.dll" () As Long
Declare Function DebugServer Lib "winsrv32.dll" (ByVal level%) As Integer
Declare Function SetMinimumPollingRate Lib "winsrv32.dll" (ByVal mpr%) As Integer
Declare Function RegisterFecName Lib "winsrv32.dll" (ByVal name$, ByVal desc$, ByVal loc$, ByVal hdw$, ByVal resp$, ByVal port%) As Integer
Declare Function FILLSRVSTRUCT Lib "winsrv32.dll" (ByVal tag$, ByVal size%, ByVal num%, ByVal fmt%) As Integer

' ================================
'   RPC Access modes
' ================================

Global Const CA_READ = &H1
Global Const CA_WRITE = &H2
Global Const CA_WRITEREAD = &H3
Global Const CA_FIRST = &H40
Global Const CA_LAST = &H80

' ================================
'   RPC Error Definitions
' ================================
Global Const success% = 0
Global Const illegal_line% = 1
Global Const illegal_format% = 2
Global Const illegal_arithmetic% = 3
Global Const ambiguous% = 4
Global Const illegal_delimiter% = 5
Global Const zero_divide% = 6
Global Const WA_full% = 7
Global Const non_existent% = 8
Global Const wrong_type% = 9
Global Const link_exhausted% = 10
Global Const not_properly% = 11
Global Const un_allocated% = 12
Global Const no_such_line% = 13
Global Const illegal_shuffle% = 14
Global Const if_error% = 15
Global Const escape_typed% = 16
Global Const ask_error% = 18
Global Const argument_list_error% = 20
Global Const file_error% = 21
Global Const user_stream_transport% = 22
Global Const dimension_error% = 23
Global Const square_root_negative% = 24
Global Const buffer_too_small% = 25
Global Const string_too_long% = 26
Global Const ipx_socket_error% = 27
Global Const net_read_error% = 28
Global Const not_ready% = 29
Global Const log_negative% = 31
Global Const device_not_connected% = 32
Global Const unauthorised_action% = 33
Global Const hardware_error% = 34
Global Const illegal_equipment_number% = 35
Global Const illegal_property% = 36
Global Const out_of_range% = 37
Global Const not_implemented% = 38
Global Const no_such_computer% = 39
Global Const string_filled% = 40
Global Const syntax_error% = 41
Global Const no_such_file% = 42
Global Const no_file_space% = 44
Global Const link_not_open% = 45
Global Const remitted_data_lost% = 46
Global Const end_of_file% = 47
Global Const def_area_full% = 52
Global Const def_syntax% = 53
Global Const illegal_string_set% = 54
Global Const serr1% = 54
Global Const string_function_failure% = 55
Global Const serr2% = 55
Global Const Sif_error% = 57
Global Const Sask_error% = 58
Global Const string_expected% = 59
Global Const out_of_local_memory% = 60
Global Const out_of_shared_memory% = 61
Global Const invalid_structure_tag% = 62
Global Const invalid_index% = 63
Global Const illegal_equipment_name% = 64
Global Const link_error% = 65
Global Const code_failure% = 66
Global Const bracket_missing% = 67
Global Const wrong_hexa% = 68
Global Const wrong_octal% = 69
Global Const illegal_character% = 70
Global Const illegal_operator% = 71
Global Const not_allowed% = 72
Global Const illegal_read_write% = 73
Global Const out_of_memory% = 74
Global Const database_not_loaded% = 75
Global Const illegal_command% = 76
Global Const resources_exhausted% = 77
Global Const file_not_open% = 78
Global Const sedac_error% = 79
Global Const no_such_loop% = 80
Global Const driver_not_installed% = 82
Global Const port_not_available% = 83
Global Const scan_error% = 84
Global Const no_high_voltage% = 85
Global Const non_existent_elem% = 86
Global Const non_existent_fec% = 87
Global Const non_existent_client% = 88
Global Const cannot_lock% = 89
Global Const not_running% = 90
Global Const not_posted% = 91
Global Const not_accepted% = 92
Global Const oeration_timeout% = 93
Global Const illegal_protocol% = 94
Global Const gpib_error% = 95
Global Const rs232_error% = 96
Global Const operation_busy% = 97
Global Const connection_timeout% = 98
Global Const illegal_mode% = 99
Global Const not_owner% = 100
Global Const not_defined% = 101
Global Const net_write_error% = 102
Global Const invalid_data% = 103
Global Const software_error% = 104
Global Const access_denied% = 105
Global Const tcp_not_supported% = 106
Global Const ipx_not_supported% = 107
Global Const host_not_resolved% = 108
Global Const tcp_connect_error% = 109
Global Const tcp_socket_error% = 110
Global Const fpss_error% = 111
Global Const fpss_timeout% = 112
Global Const fpss_overflow% = 113
Global Const pocal_error% = 114
Global Const max_alarms_exceeded% = 115
Global Const not_exported% = 116
Global Const is_switching% = 117
Global Const at_limit% = 118

