VERSION 5.00
Object = "{0BA686C6-F7D3-101A-993E-0000C0EF6F5E}#1.0#0"; "THREED32.OCX"
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "MSHFLXGD.OCX"
Begin VB.Form PROCINFO 
   Caption         =   "watchdog - process info"
   ClientHeight    =   5115
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6735
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5115
   ScaleWidth      =   6735
   StartUpPosition =   3  'Windows Default
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid PROCESS_DEF_GRID 
      Height          =   4575
      Left            =   0
      TabIndex        =   0
      Top             =   480
      Width           =   6735
      _ExtentX        =   11880
      _ExtentY        =   8070
      _Version        =   393216
      FixedRows       =   0
      FixedCols       =   0
      GridColor       =   16711680
      _NumberOfBands  =   1
      _Band(0).Cols   =   2
   End
   Begin Threed.SSCommand PRINT_BUTT 
      Height          =   375
      Left            =   5880
      TabIndex        =   1
      Top             =   0
      Width           =   735
      _Version        =   65536
      _ExtentX        =   1296
      _ExtentY        =   661
      _StockProps     =   78
      Caption         =   "&Print"
      ForeColor       =   12582912
      Font3D          =   1
   End
End
Attribute VB_Name = "PROCINFO"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
    
    With PROCESS_DEF_GRID
        .TextArray(0) = "name"
        .TextArray(2) = "running"
        .AddItem ("started")
        .AddItem ("stopped")
        .AddItem ("auto restart")
        .AddItem ("check heart beat")
        .AddItem ("use loopback")
        .AddItem ("main window handle")
        .AddItem ("window handles")
        .AddItem ("pid")
        .AddItem ("process handle")
        .AddItem ("thread id")
        .AddItem ("thread handle")
        .AddItem ("dependcy:")
    End With
            
End Sub

Private Sub formatGrids(g As MSHFlexGrid)
    Dim al As Integer, j As Integer, i As Integer
    With g
        For i = 0 To .Rows - 1
            .Row = i
            .RowHeight(i) = .Height / (.Rows + 1)
            .col = 0: .CellAlignment = flexAlignRightCenter
            .col = 1: .CellAlignment = flexAlignLeftCenter
        Next
        .ColWidth(0) = (.Width - 100) / 4
        .ColWidth(1) = .ColWidth(0) * 3
    End With
End Sub
Private Sub Form_Activate()
    Dim i As Integer, idx As Integer
    
    idx = MAIN.APPLIST.ListIndex
    If idx < 0 Then
        Hide
        Exit Sub
    End If
    
    Call formatGrids(PROCESS_DEF_GRID)
    
    With PROCESS_DEF_GRID
        .TextArray(1) = ProcList(idx).name
        .TextArray(3) = IIf(ProcList(idx).running, "yes", "no")
        If ProcList(idx).started < 0 Then
            .TextArray(5) = "(attached) " + CStr(ProcList(idx).attached)
        Else
            .TextArray(5) = CStr(ProcList(idx).started)
        End If
        .TextArray(7) = IIf(ProcList(idx).stopped < 0, "never", CStr(ProcList(idx).stopped))
        .TextArray(9) = IIf(ProcList(idx).auto_restart, "yes", "no")
        .TextArray(11) = IIf(ProcList(idx).check_hbeat, "yes", "no")
        .TextArray(13) = IIf(ProcList(idx).use_loopBack, "yes", "no")
        .TextArray(15) = CStr(ProcList(idx).hMainWindow)
        .TextArray(17) = ""
        For i = 1 To ProcList(idx).hwnds.count
            .TextArray(17) = .TextArray(17) + CStr(ProcList(idx).hwnds(i)) + " "
        Next
        .TextArray(19) = ProcList(idx).pid
        .TextArray(21) = ProcList(idx).phandle
        .TextArray(23) = ProcList(idx).tid
        .TextArray(25) = ProcList(idx).thandle
        .TextArray(27) = ProcList(idx).mustBeRunningProcess
    End With
End Sub

Private Sub Form_Resize()
    If WindowState = vbMinimized Then Exit Sub
    With PROCESS_DEF_GRID
        .Width = ScaleWidth - .Left
        .Height = ScaleHeight - .Top
        Call formatGrids(PROCESS_DEF_GRID)
    End With
End Sub

Private Sub PRINT_BUTT_Click()
    PrintForm
End Sub
