Type BYTE
  dat As String * 1
End Type
Global Const NUMEQP = 512
Global Const NUMPROP = 512
Global Const PARAMDEPTH = 32
Global Const NUMDEV = 1500
Global MAXNUMPROP As Integer
Global MAXNUMDEV As Integer
Global nRecs%, numEqm%, nl$, dmode%, off%
Global bdat(2048) As BYTE
Global ddat#(2048), idat%(2048), fdat!(2048), ldat&(2048)
Global xarr!(2048)
Type SSTRING: s As String * 48: End Type
Type CSTRING: s As String * 2048: End Type
Global sdat As CSTRING
Global n8dat(512) As NAME8
Global n16dat(512) As NAME16
Global n32dat(512) As NAME32
Global eqnm$(NUMEQP), eqdsc$(NUMEQP), eqfec$(NUMEQP), eqMxNo%
Global eqnprop%(NUMEQP), eqfile$(NUMEQP)
Global eqprop$(NUMPROP), psize%(NUMPROP), ptype$(NUMPROP), pdesc$(NUMPROP)
Global pquery(NUMPROP) As PropertyQueryType
Global devices(NUMDEV) As NAME16
Global nDevices As Integer
Global nm_index%, prop_index%, sz_index%, num_index%, type_index%
Global rpcerrStr As String * 80
Global datetime As String * 25
Global Const PROPSET_LNG = 18
Global CDBPATH$
Global Const DBPATH$ = "l:\database\archive\"
Global nparam%
Global rtyp As String * 1
Type FECSTRUCT: eqm As String
                prop As String
                dev As String
                EqNo As Integer
                len As Integer
                fmt As String
                reclen As Integer
                rectyp As Integer
                tstamp As Integer
                vnum As Integer
                comment As String
                responsible As String
                recIndex As Integer
End Type
Global FEC(NUMEQP) As FECSTRUCT
Global vname$(NUMEQP, PARAMDEPTH), vfmt$(NUMEQP, PARAMDEPTH), vcmt$(NUMEQP, PARAMDEPTH)
Global vmax#(NUMEQP, PARAMDEPTH), vmin#(NUMEQP, PARAMDEPTH), vunit$(NUMEQP, PARAMDEPTH), vsize%(NUMEQP, PARAMDEPTH)
Global fref%(NUMEQP), pref%(NUMEQP), nexti%, nextp%, nextf%
Global rpcID%(NUMEQP), ddata#(NUMEQP), fdata!(NUMEQP), ldata&(NUMEQP)
Global statusID%, fecstat%(NUMEQP)
Global npktr%, nmex%, nfecs%, nlinks%, maxsize%
Global MEXoffset%
Global RPCdebug As Integer

Global glbname$(NUMEQP), glbfmt%(NUMEQP), glbsiz%(NUMEQP), nglobals%, globalsize%

Global nProperties%
Global doAsynchronously As Integer
Global InputDblk As DBLK
Global writeAccess As Integer
Global delaytime As Long ' in seconds
'---- DLL function definitions -----
          
Declare Function LOADDLL Lib "tinecl16.dll" () As Integer
Declare Function EQPDEINIT Lib "tinecl16.dll" () As Integer
Declare Function RPCDBG Lib "tinecl16.dll" (ByVal dbg%) As Integer

Function fecload (fname$, offset%)
Dim rec_col As Integer
Dim Name_col As Integer
Dim prop_col As Integer
Dim dev_col As Integer
Dim len_col As Integer
Dim fmt_col As Integer
Dim sf_col As Integer
Dim act_col As Integer
Dim rsp_col As Integer
Dim kwd_col As Integer
Dim siz_col As Integer
Dim uni_col As Integer
Dim max_col As Integer
Dim min_col As Integer
Dim cmt_col As Integer

fecload = 0
On Error GoTo fnf
dpos# = 1
type_done = False
fname$ = DBPATH$ + fname$
If Dir(fname$) = "" Then
  fecload = 0
  Exit Function
End If
Open fname$ For Input Access Read Shared As #1
i% = offset%: p% = nparam%
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" Then
    If Not type_done Then
      rec_col = colptr(a$, "Record Type")
      Name_col = colptr(a$, "Name")
      prop_col = colptr(a$, "Property")
      dev_col = colptr(a$, "Device")
      len_col = colptr(a$, "data length")
      fmt_col = colptr(a$, "RPC Format")
      sf_col = colptr(a$, "Structure")
      act_col = colptr(a$, "Active")
      rsp_col = colptr(a$, "Responsibility")
      type_done = True
    Else
      FEC(i%).rectyp = Val(getcol(a$, rec_col))
      FEC(i%).eqm = getcol(a$, Name_col)
      FEC(i%).prop = getcol(a$, prop_col)
      FEC(i%).dev = getcol(a$, dev_col)
      If FEC(i%).dev <> "" Then FEC(i%).EqNo = Val(Right$(FEC(i%).dev, Len(FEC(i%).dev) - 1))
      FEC(i%).len = Val(getcol(a$, len_col))
      FEC(i%).fmt = getcol(a$, fmt_col)
      sfname$ = getcol(a$, sf_col)
      active% = Val(getcol(a$, act_col))
      FEC(i%).responsible = getcol(a$, rsp_col)
      
      FEC(i%).rectyp = FEC(i%).rectyp + offset - 1
      If active% Then
        j% = 0: sfname$ = DBPATH$ + "INFO\" + sfname$: done = 0
        Open sfname$ For Input Access Read Shared As #2
        Do
          Line Input #2, a$
          tok$ = Left$(a$, 1)
          If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And Len(a$) > 7 Then
            If Not done Then
              kwd_col = colptr(a$, "Keyword")
              fmt_col = colptr(a$, "Format")
              siz_col = colptr(a$, "Size")
              uni_col = colptr(a$, "Units")
              max_col = colptr(a$, "Maximum")
              min_col = colptr(a$, "Minimum")
              cmt_col = colptr(a$, "Comment")
              done = True
            Else
              vname$(i%, j%) = getcol(a$, kwd_col)
              vfmt$(i%, j%) = getcol(a$, fmt_col)
              vsize%(i%, j%) = Val(getcol(a$, siz_col))
              vunit$(i%, j%) = getcol(a$, uni_col)
              vmax#(i%, j%) = Val(getcol(a$, max_col))
              vmin#(i%, j%) = Val(getcol(a$, min_col))
              vcmt$(i%, j%) = getcol(a$, cmt_col)
              fref%(p%) = i%: pref%(p%) = j%
              If maxsize% < vsize(i%, j%) Then maxsize% = vsize%(i%, j%)
              p% = p% + 1: j% = j% + 1
            End If
          End If
        Loop While Not EOF(2)
        Close 2
        i% = i% + 1
      End If
    End If
  End If
Loop While Not EOF(1)
numEqm% = i%
Close 1
If maxsize% > 100 Then maxsize% = 100

fecload = p% - nparam%
nparam% = p%
nfecs% = i%
Close 1
quit:
Exit Function
fnf:
fecload = 0
Resume quit
End Function

Sub getInputData ()
Dim tok$
If InputData.Visible Then
  writeAccess = InputData.AccessOption.Value
  s$ = Trim$(InputData.InputPanel.Text)
  If Len(s$) = 0 Then
    InputDblk.dFormat = CF_NULL
  Else
    If InStr(s$, ",") Then tok$ = "," Else tok$ = " "
  End If
  
  n% = 0
  Select Case InputDblk.dFormat
    Case CF_INTEGER:
      Do
        v$ = s$
        p% = InStr(s$, tok$)
        If p% = 0 Then
          p% = Len(s$)
          s$ = ""
        Else
          s$ = Right$(s$, Len(s$) - p%)
          s$ = LTrim$(s$)
        End If
        idat%(n%) = CInt(Val(Left$(v$, p%)))
        n% = n% + 1
      Loop While Len(s$) > 0
    Case CF_LONG:
      Do
        v$ = s$
        p% = InStr(s$, tok$)
        If p% = 0 Then
          p% = Len(s$)
          s$ = ""
        Else
          s$ = Right$(s$, Len(s$) - p%)
          s$ = LTrim$(s$)
        End If
        ldat&(n%) = CLng(Val(Left$(v$, p%)))
        n% = n% + 1
      Loop While Len(s$) > 0
    Case CF_FLOAT:
      Do
        v$ = s$
        p% = InStr(s$, tok$)
        If p% = 0 Then
          p% = Len(s$)
          s$ = ""
        Else
          s$ = Right$(s$, Len(s$) - p%)
          s$ = LTrim$(s$)
        End If
        fdat!(n%) = CSng(Val(Left$(v$, p%)))
        n% = n% + 1
      Loop While Len(s$) > 0
    Case CF_DOUBLE:
      Do
        v$ = s$
        p% = InStr(s$, tok$)
        If p% = 0 Then
          p% = Len(s$)
          s$ = ""
        Else
          s$ = Right$(s$, Len(s$) - p%)
          s$ = LTrim$(s$)
        End If
        ddat#(n%) = CDbl(Val(Left$(v$, p%)))
        n% = n% + 1
      Loop While Len(s$) > 0
    Case CF_TEXT:
        sdat.s = s$
        n% = Len(s$)
  End Select
  InputDblk.dArrayLength = n%
Else
  InputDblk.dFormat = CF_NULL
  InputDblk.dArrayLength = 0
  writeAccess = False
End If
End Sub

