VERSION 2.00
Begin Form globals 
   BackColor       =   &H00808000&
   Caption         =   "Globals"
   ClientHeight    =   1320
   ClientLeft      =   210
   ClientTop       =   480
   ClientWidth     =   3225
   Height          =   1725
   Icon            =   GLOBALS.FRX:0000
   Left            =   150
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1320
   ScaleWidth      =   3225
   Top             =   135
   Width           =   3345
   Begin Timer Timer1 
      Interval        =   1000
      Left            =   1290
      Top             =   -180
   End
   Begin Grid globalsGrid 
      Height          =   1125
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2955
   End
End
'Dim glbname$(NUMEQP), glbfmt%(NUMEQP), glbsiz%(NUMEQP), nglobals%, globalsize%

Sub Form_Load ()
globfile$ = CDBPATH$ + "nglobals.csv"
On Error GoTo globalsLoadError
Open globfile$ For Input Access Read Shared As #1
Input #1, a$, a$, a$, a$, a$, a$   ' header
i% = 0
Do
  Input #1, glbname$(i%), fmtstr$, glbsiz%(i%), a$, a$, a$
  glbfmt%(i%) = getFormatFromString(fmtstr$)
  i% = i% + 1
  If glbsiz%(i%) > globalsize% Then globalsize% = glbsiz%(i%)
Loop While Not EOF(1)
nglobals% = i%
Close 1
globalsGrid.Rows = nglobals% + 1
globalsGrid.Cols = globalsize% + 2
globalsGrid.Row = 0
globalsGrid.Col = 0: globalsGrid.Text = "Parameter"
globalsGrid.Col = 1: globalsGrid.Text = "Value"
globalsGrid.ColWidth(0) = 1200
globalsGrid.ColWidth(1) = 2400
For i% = 2 To globalsize% + 1
  globalsGrid.ColWidth(i%) = 2400
Next i%
For i% = 0 To nglobals% - 1
  globalsGrid.Row = i% + 1
  globalsGrid.Col = 0: globalsGrid.Text = glbname$(i%)
Next i%
globals.Height = (nglobals% + 1) * 240 + 800
globals.Left = screen.Width - globals.Width
globals.Top = screen.Height - globals.Height
globalsLoadError:
Exit Sub
End Sub

Sub Form_Resize ()
globalsGrid.Height = globals.ScaleHeight - globalsGrid.Top * 2
End Sub

Function getFormatFromString (s$) As Integer
Select Case UCase(s$)
  Case "BYTE": getFormatFromString = CF_BYTE
  Case "SHORT", "INT", "INTEGER": getFormatFromString = CF_SHORT
  Case "LONG": getFormatFromString = CF_LONG
  Case "FLOAT", "SINGLE ": getFormatFromString = CF_FLOAT
  Case "DOUBLE": getFormatFromString = CF_DOUBLE
  Case "CHAR", "TEXT": getFormatFromString = CF_TEXT
  Case "CHAR8": getFormatFromString = CF_CHAR8
  Case "CHAR16": getFormatFromString = CF_CHAR16
  Case "CHAR32": getFormatFromString = CF_CHAR32
End Select
End Function

Sub Timer1_Timer ()
Dim glbstr As SSTRING
For i% = 0 To nglobals% - 1
  globalsGrid.Row = i% + 1
  Select Case glbfmt%(i%)
    Case CF_DOUBLE:
      rc% = GETGLOBAL(glbname$(i%), ddat#(0), glbsiz%(i%), CF_DOUBLE)
      For j% = 1 To glbsiz%(i%)
        globalsGrid.Col = j%
        globalsGrid.Text = Format$(ddat#(j% - 1), "####0.000")
      Next j%
    Case CF_INTEGER:
      rc% = GETGLOBAL(glbname$(i%), idat%(0), glbsiz%(i%), CF_INTEGER)
      For j% = 1 To glbsiz%(i%)
        globalsGrid.Col = j%
        globalsGrid.Text = Str$(idat%(j% - 1))
      Next j%
    Case CF_LONG:
      rc% = GETGLOBAL(glbname$(i%), ldat&(0), glbsiz%(i%), CF_LONG)
      For j% = 1 To glbsiz%(i%)
        globalsGrid.Col = j%
        globalsGrid.Text = Str$(ldat&(j% - 1))
      Next j%
    Case CF_FLOAT:
      rc% = GETGLOBAL(glbname$(i%), fdat!(0), glbsiz%(i%), CF_FLOAT)
      For j% = 1 To glbsiz%(i%)
        globalsGrid.Col = j%
        globalsGrid.Text = Str$(fdat!(j% - 1))
      Next j%
    Case CF_STRING32:
      rc% = GETGLOBAL(glbname$(i%), glbstr, glbsiz%(i%), CF_STRING32)
      For j% = 1 To glbsiz%(i%)
        globalsGrid.Col = j%
        globalsGrid.Text = glbstr.s
      Next j%
    Case CF_STRING16:
      rc% = GETGLOBAL(glbname$(i%), glbstr, glbsiz%(i%), CF_STRING16)
      For j% = 1 To glbsiz%(i%)
        globalsGrid.Col = j%
        globalsGrid.Text = glbstr.s
      Next j%
    Case CF_STRING8:
      rc% = GETGLOBAL(glbname$(i%), glbstr, glbsiz%(i%), CF_STRING8)
      For j% = 1 To glbsiz%(i%)
        globalsGrid.Col = j%
        globalsGrid.Text = glbstr.s
      Next j%
    End Select
Next i%
End Sub

