VERSION 2.00
Begin Form machine 
   BackColor       =   &H00808000&
   Caption         =   "Current HERA Machine Parameters"
   ClientHeight    =   6330
   ClientLeft      =   1410
   ClientTop       =   630
   ClientWidth     =   8100
   Height          =   6735
   Icon            =   MACHINE.FRX:0000
   Left            =   1350
   LinkTopic       =   "Form1"
   ScaleHeight     =   6330
   ScaleWidth      =   8100
   Top             =   285
   Width           =   8220
   Begin CommandButton Command1 
      Caption         =   "Print"
      Height          =   315
      Left            =   6300
      TabIndex        =   3
      Top             =   5940
      Width           =   735
   End
   Begin CommandButton BACK 
      Caption         =   "BACK"
      Height          =   315
      Left            =   7200
      TabIndex        =   2
      Top             =   5940
      Width           =   735
   End
   Begin PictureBox rpcerrbox 
      Height          =   555
      Left            =   60
      Picture         =   MACHINE.FRX:0302
      ScaleHeight     =   525
      ScaleWidth      =   525
      TabIndex        =   1
      Top             =   5760
      Visible         =   0   'False
      Width           =   555
   End
   Begin Grid machineGrid 
      BackColor       =   &H00FFFFC0&
      Cols            =   20
      FixedCols       =   0
      ForeColor       =   &H00FF0000&
      Height          =   5655
      Left            =   45
      Rows            =   30
      TabIndex        =   0
      Top             =   60
      Width           =   7935
   End
   Begin Label timelab 
      BackColor       =   &H00FFFFC0&
      BorderStyle     =   1  'Fixed Single
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   12
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   315
      Left            =   3720
      TabIndex        =   5
      Top             =   5880
      Width           =   1815
   End
   Begin Label datelab 
      BackColor       =   &H00FFFFC0&
      BorderStyle     =   1  'Fixed Single
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   12
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   315
      Left            =   1140
      TabIndex        =   4
      Top             =   5880
      Width           =   2175
   End
End

Sub BACK_Click ()
Unload machine
End Sub

Sub Command1_Click ()
machine.Print
End Sub

Sub Form_Load ()
On Error GoTo err_handler
machineGrid.Rows = nlinks% + 1
machineGrid.Cols = maxsize% + 4
machineGrid.Row = 0
machineGrid.Col = 0: machineGrid.Text = "Parameter"
machineGrid.Col = 1: machineGrid.Text = "Description"
machineGrid.Col = 2: machineGrid.Text = "Units"
machineGrid.Col = 3: machineGrid.Text = "Time"
machineGrid.Col = 4: machineGrid.Text = "Value"
machineGrid.ColWidth(0) = 1200
machineGrid.ColWidth(1) = 2000
machineGrid.ColWidth(2) = 1200
machineGrid.ColWidth(3) = 1000
For i% = 4 To maxsize% + 3
  machineGrid.ColWidth(i%) = 1000
Next i%
For i% = 0 To nlinks% - 1
  f% = fref%(i%): p% = pref%(i%)
  prop$ = vname$(f%, p%)
  comment$ = vcmt$(f%, p%)
  units$ = vunit$(f%, p%)
  siz% = vsize(f%, p%)
  Select Case vfmt$(f%, p%)
    Case "char": fmt% = CF_TEXT2
    Case "unsigned long", "long":
                 fmt% = CF_LONG
    Case "short", "int": fmt% = CF_INTEGER
    Case "double": fmt% = CF_DOUBLE
    Case Else:   fmt% = CF_FLOAT
  End Select
  'If vfmt$(f%, p%) = "char" Then fmt% = CF_TEXT Else fmt% = CF_FLOAT
  If siz% > 100 Then
    MsgBox prop$ + ": Truncating array size to 100"
    siz% = siz%
    vsize(f%, p%) = 100
  End If
  If i% < npktr% Then
    rpcID%(i%) = HOTRPC(machine.hWnd, "HERADATA", 1, prop$, 30000, siz%, fmt%)
  Else
    rpcID%(i%) = HOTRPC(machine.hWnd, "MEXDATA", 1, prop$, 30000, siz%, fmt%)
  End If
  If rpcID%(i%) < 1 Then
     rc% = RPCERR(-rpcID(i%), rpcerrstr)
     MsgBox "Can't create LINK to " + prop$ + " : " + rpcerrstr$
     Exit Sub
  End If
  machineGrid.Row = i% + 1
  machineGrid.Col = 0: machineGrid.Text = prop$
  machineGrid.Col = 1: machineGrid.Text = comment$
  machineGrid.Col = 2: machineGrid.Text = units$
Next i%
machine.Left = 0: machine.Top = 0
Exit Sub
err_handler:
Resume
End Sub

Sub Form_Paint ()
Static strdata As RPCTEXT
Static LONGtime&
For i% = 0 To nlinks% - 1
  If rpcID%(i%) > 0 Then
    f% = fref%(i%): p% = pref%(i%): siz% = vsize(f%, p%)
    If vfmt$(f%, p%) = "char" Then
      hotrc% = GETRPCDATA(rpcID%(i%), strdata, LONGtime&)
    ElseIf InStr(vfmt$(f%, p%), "long") Then
      hotrc% = GETRPCDATA(rpcID%(i%), ldata&(0), LONGtime&)
    Else
      hotrc% = GETRPCDATA(rpcID%(i%), fdata!(0), LONGtime&)
    End If
    Select Case hotrc%
      Case Is > 0: rpcerrbox.Visible = True 'signal RPC error
      Case 0: rpcerrbox.Visible = False
              machineGrid.Row = i% + 1
              For j% = 4 To siz% + 3
                machineGrid.Col = j%
                If vfmt$(f%, p%) = "char" Then
                  sdata$ = Left$(strdata.Text, InStr(strdata.Text, Chr(0)) - 1)
                  machineGrid.Text = sdata$
                  GoTo Jend
                Else
                  If InStr(vfmt$(f%, p%), "long") Then dd# = ldata&(j% - 4) Else dd# = fdata!(j% - 4)
                  If dd# > 10000 Then
                    sdata$ = Format$(dd#, "0.000E-00")
                  Else
                    sdata$ = Format$(dd#, "0.000")
                  End If
                End If
                machineGrid.Text = sdata$
              Next j%
Jend:         machineGrid.Col = 3
              rc% = CONVTIME(datetime, LONGtime&)
              machineGrid.Text = Mid$(datetime, 11, 9)
    End Select
  End If
Next i%
timelab.Caption = " " + Time$: datelab.Caption = " " + Date$
End Sub

Sub Form_Resize ()
If windowstate = 1 Then Exit Sub
machineGrid.Height = machine.ScaleHeight - 675
machineGrid.Width = machine.Width - machineGrid.Left * 2
BACK.Top = machineGrid.Height + 100: BACK.Left = machineGrid.Width - BACK.Width
Command1.Top = machineGrid.Height + 100: Command1.Left = BACK.Left - Command1.Width - 100
datelab.Top = machineGrid.Height + 150
timelab.Top = machineGrid.Height + 150
rpcerrbox.Top = machineGrid.Height + 20
End Sub

Sub Form_Unload (Cancel As Integer)
For i% = 0 To nlinks% - 1
  If rpcID%(i%) > 0 Then
    If CLOSERPC(machine.hWnd, rpcID%(i%)) Then
      MsgBox "Couldn't close "
    End If
    rpcID%(i%) = 0
  End If
Next
End Sub

