#include "prolog.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "servdef.h"
#include "rpctypes.h"
#include "errors.h"

extern int NGdebug;
extern int nofeclog;
extern int ListenForGlobals;
extern int ListenForMCasts;
extern int defaultClientTimeout;
int tgetEx(char *dev,char *prp,int fmt, int siz);
int main(int argc, char *argv[])
{
  int cc;
  int siz = 0, fmt = CF_DEFAULT;
  if (argc < 3) 
  {
    printf("Usage tget <device name> <property> [<size> <format>]\n");
    printf("      e.g. tget /HERA/HEPBPM/WL197MX ORBIT.X\n");
    printf("      or   tget /HERA/HEPBPM/WL197MX ORBIT.X 10 float\n");
    exit(1);
  }
  MaxNumConnections = 3;
  ListenForGlobals = ListenForMCasts = FALSE;
  MaxPollingRate = MinPollingRate = 50;
  defaultClientTimeout = 50;
  nofeclog = TRUE;
  if (argc == 5)
  {
    siz = atoi(argv[3]);
    fmt = ftoi(argv[4]);
  }
  if ((cc=tgetEx(argv[1],argv[2],fmt,siz)) != 0) printf("error : %s\n",erlst[cc]);
  printf("\n");
  return cc;
}
