#ifndef _WATCHDOG_H_
#define _WATCHDOG_H_

#define WD_PFORTE 0
#define WD_BECKER 1

#define WATCH_INTERVAL  5
#define WD_RESET(i)  ((i)+0x0003)
#define WD_POLL(i)   ((i)+0x0002)
#define WD_STATUS(i) ((i)+0x0001)

extern int watchdogEnabled;
extern int watchdogType;
extern int watchdogBaseAddress;
extern int watchdogStatus;
extern int watchdogMode;
void initWatchDog(void);
void watchDog(void);
void enableWatchDog(void);
void disableWatchDog(void);
void rebootPC(void);

#endif // _WATCHDOG_H_
