Attribute VB_Name = "Module1"
Global LMBSessionID As Integer
Global LMBeventTag As String
Global LMBpmArcGrp As String
Type APCBLK32
  SessionID As Long
  Event As Long
  Ext(3) As Byte
  EqpName(15) As Byte
  devName(15) As Byte
  devProperty(31) As Byte
  dsize As Long
  dFormat As Integer
End Type
Function CloseLMBArchivedDataSession()
Dim dout As DBLK, din As DBLK
  
  If LMBSessionID > 0 Then ' close it
    dout.dArrayLength = 0: dout.dFormat = CF_NULL
    din.dArrayLength = 1: din.dFormat = CF_SHORT
    rc& = T_EXECLINK("HELMBARCHIVE/" & pmArcGrp, "CLOSE", dout, 0, din, LMBSessionID, 1, 1000)
    If rc& Then GoTo CloseLMBArchivedDataError
  End If
CloseLMBArchivedDataError:
  CloseLMBArchivedData = rc&
  LMBSessionID = 0
End Function

Function GetLMBArchivedData(ByVal pmArchiveGroup$, ByVal evnTag$, ByVal devName$, ByVal devProperty$, ByVal channel%, npoints As Long, DataBuffer As Variant)
'Static SessionID As Integer
'Static eventTag As String
'Static pmArcGrp As String
Dim dout As DBLK, din As DBLK
Dim apc As APCBLK
Dim devsrvnam$
Dim rc&, p%, i%, dServerName$, dName$, evn As NAME8
Dim id() As Integer, ld() As Long, fd() As Single, dd() As Double
Dim n32 As NAME32
Static done As Boolean

If Not done Then
  FILLSTRUCT "APCBLK", Len(apc), 1, CF_NULL
  done = True
End If

rc& = 0

If LMBeventTag <> evnTag Or pmArchiveGroup$ <> LMBpmArcGrp Then ' new session
  LMBeventTag = evnTag
  LMBpmArcGrp = pmArchiveGroup$
  If LMBSessionID > 0 Then ' close it
    dout.dArrayLength = 0: dout.dFormat = CF_NULL
    din.dArrayLength = 1: din.dFormat = CF_SHORT
    rc& = T_EXECLINK("HELMBARCHIVE/" & pmArchiveGroup$, "CLOSE", dout, 0, din, LMBSessionID, 1, 1000)
    If rc& Then GoTo GetPMArchivedDataError
  End If
  If evnTag$ = "" Then GoTo GetPMArchivedDataError ' just close the current session
  dout.dArrayLength = 1: dout.dFormat = CF_SHORT
  din.dArrayLength = 1: din.dFormat = CF_NAME8
  BARR evn.nam(), evnTag$
  rc& = T_EXECLINK("HELMBARCHIVE/" & pmArchiveGroup$, "OPEN", dout, LMBSessionID, din, evn, 1, 1000)
  If rc& Then GoTo GetPMArchivedDataError
End If
If LMBeventTag = "" Then GoTo GetPMArchivedDataError

p% = InStr(devName$, "/")
If p% = 0 Then
  dServerName$ = devName$
  dName$ = "#0"
Else
  dServerName$ = Left$(devName$, p% - 1)
  dName$ = Right$(devName$, Len(devName$) - p%)
End If

apc.SessionID = LMBSessionID
BARR apc.EqpName(), dServerName$
BARR apc.devName(), dName$
BARR apc.devProperty(), devProperty$
din.dArrayLength = 1
din.dFormat = CF_STRUCT
BARR din.dTag(), "APCBLK"

If npoints > 1 Then
  If UBound(DataBuffer) - LBound(DataBuffer) < npoints - 1 Then
    rc& = 2
    GoTo GetPMArchivedDataError
  End If
End If
dout.dArrayLength = npoints
devsrvnam$ = "HELMBARCHIVE/#" & Trim$(str$(channel))
Select Case VarType(DataBuffer) - vbArray
  Case vbInteger:
       ReDim id(npoints)
       dout.dFormat = CF_SHORT
       rc& = T_EXECLINK(devsrvnam$, "READDATA", dout, id(0), din, apc, 1, 1000)
       For jj& = 0 To npoints - 1: DataBuffer(jj&) = id(jj&): Next
  Case vbLong:
       ReDim ld(npoints)
       dout.dFormat = CF_LONG
       rc& = T_EXECLINK(devsrvnam$, "READDATA", dout, ld(0), din, apc, 1, 1000)
       For jj& = 0 To npoints - 1: DataBuffer(jj&) = ld(jj&): Next
  Case vbSingle:
       ReDim fd(npoints)
       dout.dFormat = CF_FLOAT
       rc& = T_EXECLINK(devsrvnam$, "READDATA", dout, fd(0), din, apc, 1, 1000)
       For jj& = 0 To npoints - 1: DataBuffer(jj&) = fd(jj&): Next
  Case vbDouble:
       ReDim dd(npoints)
       dout.dFormat = CF_DOUBLE
       rc& = T_EXECLINK(devsrvnam$, "READDATA", dout, dd(0), din, apc, 1, 1000)
       For jj& = 0 To npoints - 1: DataBuffer(jj&) = dd(jj&): Next
  Case Else:
       If VarType(DataBuffer) = vbString Then
         dout.dArrayLength = 1
         dout.dFormat = CF_NAME32
         rc& = T_EXECLINK(devsrvnam$, "READDATA", dout, n32.nam(0), din, apc, 1, 1000)
         DataBuffer = BSTR(n32.nam())
       Else
         rc& = 2 ' illegal_format
       End If
End Select
If rc& Then GoTo GetPMArchivedDataError

GetPMArchivedDataError:
GetLMBArchivedData = rc&
End Function

