Attribute VB_Name = "mki3"
Declare Function Get_Version Lib "MKIDLL.DLL" (ByVal v%) As Long
Declare Function GetInfo Lib "MKIDLL.DLL" (v&) As Long

Type MKI3Header    ' Create user-defined type.
  RemotePC(19) As Byte      ' sendPC's name
  Version As Byte           ' 32 or 27
  Type As Byte              ' fllow 32 bytes...data type 1 to 6
  toID(7) As Byte
  Propert(7) As Byte
  FromID(7) As Byte
  Message As Integer
  timestamp As Long
End Type

Type CycleRecord    ' Create user-defined type.
    Header As MKI3Header
    
    Cycle As Long      ' Define elements of data type.
    Energy As Single
    Current As Single
    Bunches As Integer
    eventCode As Integer
    Alarmflag As Integer
    dummy As Integer
    Rfvoltage As Single
    Qx As Single
    Qy As Single
    Qs As Single
    Momentum As Single
    a As Single
    B As Single
    C As Single
    
    lanDate(9) As Byte
    MCInfo(21) As Byte
    lanTime(7) As Byte
    Particle(9) As Byte
    Procedure(9) As Byte
    Status(9) As Byte
    MCFile(49) As Byte
    
    MCModus(31) As Byte
    
    bunchStrom As Single
    teilchen As Single
    lifeTime As Single
    trigger As Single
    
    betriebsMode(9) As Byte
    datenTvText(63) As Byte
    optik(11) As Byte
      
    rmsx As Single
    rmsz As Single
    relImpAbw As Single
End Type

Type EQPRecord    ' Create user-defined type.
    Header As MKI3Header
    EqNumber(7) As Integer
    EqValue(7) As Single
    EqFlag(7) As Integer
End Type

Type StringRecord    ' Create user-defined type.
    Header As MKI3Header
    s_length As Long
    strData(1400) As Byte
End Type

Type RealRecord    ' Create user-defined type.
    Header As MKI3Header
    r_packname(7) As Byte
    r_packindex As Integer
    r_packlength As Integer
    r_packdata(349) As Single
End Type

Type IntRecord    ' Create user-defined type.
    Header As MKI3Header
    i_packname(7) As Byte
    i_packindex As Integer
    i_packlength As Integer
    i_packdata(699) As Integer
End Type

